<%@ page import="com.sas.oprisk.monitor.web.cpb.runtime.component.*" %>
<%@ page import="com.sas.oprisk.server.ApplicationProperties" %>
<%@ page import="com.sas.oprisk.monitor.web.iap.issue.*" %>
<%@ page import="com.sas.oprisk.monitor.web.tags.issues.*" %>
<%@ page import="com.sas.oprisk.framework.server.util.*" %>
<%@ page import="com.sas.oprisk.server.IssueEx" %>
<%@ page import="java.util.*" %>
<%@ include file="/tiles/taglibs.jsp" %>

<%@page import="com.sas.solutions.cpb.web.tag.field.ComponentFieldRenderer"%>
<%@page import="com.sas.oprisk.server.cpb.MonitorUIDefinitionType"%>
<%@page import="com.sas.solutions.cpb.web.util.RequestUtil"%><mon:setBundle />

<%
   ResourceBundle bundle = ApplicationProperties.getBundle(request.getLocale());
   MonitorContext mContext = MonitorContext.getMonitorContext(request);
   PersistenceSession psession = MonitorContext.getPersistenceSession(request);

   IssuesTableTag.IssueTableModel model = 
      (IssuesTableTag.IssueTableModel)request.getAttribute("issueTableModel"); 
   
   String exportUrl = request.getContextPath() + "/LinkedIssueQuery.do" + 
      "?entryId=linkedIssues&tpHandle=" + model.getPboHandle() + 
      "&fromCache=" + !model.isImmediateSave();
      
   Map columnFormatters = (Map)request.getAttribute("issueColFormatters");

   final String refLabel = bundle.getString("issue.field.referenceNo.displayName.txt");
   final String idLabel = bundle.getString("issue.field.issueId.displayName.txt");
   final String sscLabel = bundle.getString("issue.field.sourceSystemCd.displayName.txt");
   
   String title = bundle.getString("iap.issue.issueView.relatedIssues.section.txt");
   boolean required = false;
   boolean invalid = false;
   
   // if this is being used in a CPB screen, we can get some extra info
   final ComponentFieldRenderer.ComponentInfo componentInfo =
      ComponentFieldRenderer.getComponentInfo(request);
   if (componentInfo != null && MonitorUIDefinitionType.COMP_ISSUES.equals(componentInfo.getComponent().getName())) {
      title = CustomTableComponent.getLabel(request);
      required = componentInfo.isRequired();
      invalid = RequestUtil.isFieldValueInvalid(componentInfo.getField().getName(), pageContext);
   }
%>

<!--  Table View -->

<%
   if (!model.isMinimal()) {
%>

<mon:tableComponent columnFormatters="<%= columnFormatters%>" id="issue" entryName="linkedIssues" 
       exportXlsUrl="<%= exportUrl %>" required="<%= required %>" valid="<%= !invalid %>">
   <mon:title><%= title %></mon:title>

<%
   final IssueEx issue = (IssueEx)pageContext.findAttribute("issue");
   
   // double escape because it is going in an href
   final String escName = issue == null ? null : ParsingUtils.escape(ParsingUtils.escape(issue.getIssueShortDesc()));
%>
   
   <c:if test="${!issueTableModel.readOnly}">
      <c:if test="${!issueTableModel.pboFresh && issueTableModel.canCreate}">
         <mon:action href="javascript:createIssue()">
            <fmt:message key='application.create.txt'/>
         </mon:action>
      </c:if>
      <c:if test="${issueTableModel.canRead}">
         <mon:action href="javascript:chooseIssue()">
            <fmt:message key='application.link.txt'/>
         </mon:action>
      </c:if>
      
      <mon:fixedColumn width="1%" before="false" title='<%= bundle.getString("application.remove.txt") %>' >
         <a href="javascript:unlinkIssue('<c:out value="${issue.handleString}" />', '<%= escName %>')">
            <img border="0" src="<fmt:message key='application.remove.image' />"  
            alt="<fmt:message key='application.remove.txt'/>" 
            title="<fmt:message key='application.remove.txt'/>"/>
         </a>
      </mon:fixedColumn>
   </c:if>
   
</mon:tableComponent>
<%
   } else {
%>
<!--  Minimal View -->

   <c:set var="hasIssues" value="false" />
   <c:forEach items="${linkedIssues_TCQueryParameters.objectList}" var="issue" varStatus="status"><c:if test="${status.index > 0}">, </c:if>
<%
	final IssueEx issue = (IssueEx)pageContext.findAttribute("issue");
	
	// double escape because it is going in an href
	final String escName = issue == null ? null : ParsingUtils.escape(ParsingUtils.escape(issue.getIssueShortDesc()));
	final String sourceSystem = mContext.getSourceSystemDescription(
	      issue.getSourceSystemCd(), request.getLocale(), psession);
	
   final String tip = refLabel + ": " + issue.getReferenceNo() + "\n"
      + idLabel + ": " + issue.getIssueId() + "\n"
      + sscLabel + ": " + sourceSystem;
%>
      <c:set var="hasIssues" value="true" />
      <a href="javascript:viewRelatedIssue('<%= issue.getHandleString() %>')"
         title="<%= StringUtil.escapeHTML(tip) %>"><c:out value="${issue.issueShortDesc}" /></a
         ><c:if test="${!issueTableModel.readOnly}">
            [<a href="javascript:unlinkIssue('<c:out value="${issue.handleString}" />', '<%= escName %>')" ><img 
               src="<fmt:message key='application.remove.image' />" border="0" align="absmiddle"
               alt="<fmt:message key='application.remove.txt' />"
               title="<fmt:message key='application.remove.txt' />" /></a>]</c:if></c:forEach>
   <c:if test="${!issueTableModel.readOnly && ((!issueTableModel.pboFresh && issueTableModel.canCreate) || issueTableModel.canRead)}">
      <c:if test="${hasIssues}">&nbsp;<b>|</b>&nbsp;</c:if>
      <c:if test="${!issueTableModel.pboFresh && issueTableModel.canCreate}">
         [<a href="javascript:createIssue()" ><fmt:message key='application.create.txt' /></a>]
      </c:if>
      <c:if test="${issueTableModel.canRead}">
         [<a href="javascript:chooseIssue()" ><fmt:message key='application.link.txt' /></a>]
      </c:if>
   </c:if>
<%
   }
%>
<c:if test="${hasInvisibleLinkedIssues}">
   <span class="infoMessage"><img align="absmiddle" src="<%= request.getContextPath() %>/images/MessageInform_16.gif">
   <fmt:message key="iap.issue.hasInvisibleItems.txt" /></span><br/>
</c:if>      
