function OraPopupLayout()
{
}

/**
 * the ID of the page body element that is automatically looked for when
 * OraPopupLayout.initialize() is called.
 */
OraPopupLayout.PAGE_BODY_CONTAINER_ID = "pageBodyContainer";
OraPopupLayout.PAGE_BODY_ID = "pageBody";
OraPopupLayout.BUTTON_BAR_CONTAINER_ID = "popupButtonBarContainer";
OraPopupLayout.BUTTON_BAR_ID = "popupButtonBar";
OraPopupLayout.FILTER_BAR_ID = "filterBar";
OraPopupLayout.CHOOSER_ID = "chooser";
OraPopupLayout.IFRAME1_ID = "treeChooserFrame";
OraPopupLayout.IFRAME2_ID = "treeChoosersetSelectedValue";
OraPopupLayout.WINDOW_DIMENSIONS = {};

/** the single page body container if there is only one */
OraPopupLayout.pageBodyContainer = null;

/** the single page body if there is only one */
OraPopupLayout.pageBody = null;

/** the single poup buttons container if there is only one */
OraPopupLayout.popupButtonBarContainer = null;

/** the single popup button if there is only one */
OraPopupLayout.popupButtonBar = null;

/**
 * This function will look for an element called "pageBody" and if it exists
 * then this element will automatically be resized when the size of the browser
 * window changes.
 */
OraPopupLayout.initialize = function()
{
   OraPopupLayout.pageBodyContainer = document.getElementById(OraPopupLayout.PAGE_BODY_CONTAINER_ID);
   OraPopupLayout.popupButtonBarContainer = document.getElementById(OraPopupLayout.BUTTON_BAR_CONTAINER_ID);
   OraPopupLayout.filterBar = document.getElementById(OraPopupLayout.FILTER_BAR_ID);
   OraPopupLayout.chooser = document.getElementById(OraPopupLayout.CHOOSER_ID);

   if (OraPopupLayout.popupButtonBarContainer)
   {
      if (OraPopupLayout.RTL)
      {
         OraPopupLayout.popupButtonBarContainer.style.right = "0";
      }
      else
      {
         OraPopupLayout.popupButtonBarContainer.style.left = "0";
      }
      
      OraPopupLayout.popupButtonBar = document.getElementById(OraPopupLayout.BUTTON_BAR_ID);
   }

   if (OraPopupLayout.pageBodyContainer)
   {
      OraPopupLayout.pageBody = document.getElementById(OraPopupLayout.PAGE_BODY_ID);
      OraPopupLayout.pageBodyContainer.style.overflow = "auto";
   }

   Event.observe(window, "resize", OraPopupLayout.handleWindowOnResize);
   OraPopupLayout.handleWindowOnResize();
}

/**
 * The default handler for the window.onresize event. This handler will
 * automatically fix the height of the page content area.
 */
OraPopupLayout.handleWindowOnResize = function()
{
   OraPopupLayout.updateWindowDimensions();
   var size = OraPopupLayout.WINDOW_DIMENSIONS;
   
   var newHeight = size.height - OraPopupLayout.pageBodyContainer.offsetTop;
   var newWidth = size.width;

   var popupButtonBarHeight;
   
   if (OraPopupLayout.popupButtonBarContainer)
   {
      popupButtonBarHeight = OraPopupLayout.popupButtonBarContainer.offsetHeight
      newHeight -= popupButtonBarHeight;
      OraPopupLayout.popupButtonBarContainer.style.top = size.height
            - popupButtonBarHeight + "px";
      OraPopupLayout.popupButtonBarContainer.style.width = newWidth + "px";
   }
   
   if (OraPopupLayout.filterBar)
   {
      if (!popupButtonBarHeight)
      {
         popupButtonBarHeight = 0;
      }
      
      var filterBarHeight = OraPopupLayout.filterBar.offsetHeight;
      OraPopupLayout.filterBar.style.top = (size.height - popupButtonBarHeight - filterBarHeight) + "px";
   }

   var chooserTop = OraPopupLayout.chooser.offsetTop;
   var computedHeight = size.height - chooserTop - popupButtonBarHeight - filterBarHeight;
   var computedWidth = size.width - 10 - 115 - 25;
   OraPopupLayout.chooser.style.height =  computedHeight + "px";
   OraPopupLayout.chooser.style.width = computedWidth + "px";
   
   var iframe1 = frames[OraPopupLayout.IFRAME1_ID];
   if (iframe1)
   {
      var iframe2 = iframe1.frames[OraPopupLayout.IFRAME2_ID];
      if (iframe2)
      {
         iframe1.frameElement.style.height = OraPopupLayout.chooser.style.height;
         iframe2.frameElement.style.height = OraPopupLayout.chooser.style.height;
         if (computedWidth < 500)
         {
            iframe1.frameElement.style.width = "500px";
            iframe2.frameElement.style.width = "500px";
         }
         else
         {
            iframe1.frameElement.style.width = OraPopupLayout.chooser.style.width;
            iframe2.frameElement.style.width = OraPopupLayout.chooser.style.width;
         }
      }
   }
   
   if (newHeight > 0)
   {
      OraPopupLayout.pageBodyContainer.style.height = newHeight + "px";
   }

   if (OraPopupLayout.pageBody)
   {
      OraPopupLayout.pageBodyContainer.style.width = newWidth + "px";
      OraPopupLayout.pageBody.style.width = (newWidth - 30) + "px";
   }

   if (window.sas_ensureCalendarsVisible)
   {
      sas_ensureCalendarsVisible();
   }
}

OraPopupLayout.updateWindowDimensions = function()
{
   var width, height = 0;

   if (window.innerWidth !== undefined)
   {
      // Non-IE
      width = window.innerWidth;
      height = window.innerHeight;
   }
   else if (document.documentElement)
   {
      // IE 6+ in 'standards compliant mode'
      width = document.documentElement.clientWidth;
      height = document.documentElement.clientHeight;
   }
   else
   {
      // IE 4 compatible
      width = document.body.clientWidth;
      height = document.body.clientHeight;
   }

   OraPopupLayout.WINDOW_DIMENSIONS.width = width;
   OraPopupLayout.WINDOW_DIMENSIONS.height = height;
}

window.PageLayout = OraPopupLayout;