<%@page import="java.sql.Timestamp"%>
<%@page import="com.sas.oprisk.server.logical.InstanceAnswerContainer"%>
<%@page import="java.util.Iterator"%>
<%@page import="com.sas.oprisk.server.cpb.uiDefType.ControlInstanceUIDefinitionType"%>
<%@page import="com.sas.oprisk.server.logical.AbstractQuestionGroup"%>
<%@page import="com.sas.solutions.cpb.runtime.UIContext"%>
<%@page import="com.sas.solutions.cpb.web.util.RequestUtil"%>
<%@page import="com.sas.solutions.cpb.web.tag.field.ComponentFieldRenderer"%>
<%@page import="com.sas.oprisk.server.base.AssessableTypeCd"%>

<%@ include file="/tiles/taglibs.jsp" %>

<%@page import="com.sas.oprisk.framework.server.util.ParsingUtils"%>
<%@page import="com.sas.oprisk.server.web.cpb.runtime.MonitorUIContext"%>
<%@page import="com.sas.oprisk.server.cpb.uiDefType.AssessmentUIDefinitionType"%>
<%@page import="com.sas.solutions.cpb.web.util.HTMLUtil"%>
<%@page import="com.sas.solutions.cpb.web.util.CPBWebConstants"%>
<%@page import="com.sas.oprisk.monitor.web.cpb.runtime.component.assessment.RatingsComponent"%><mon:setBundle />

<%
   final PersistenceSession psession = MonitorContext.getPersistenceSession(request);
   final MonitorUIContext uiContext = (MonitorUIContext)RequestUtil.getUIContext(request);
   final ComponentFieldRenderer.ComponentInfo componentInfo =
      ComponentFieldRenderer.getComponentInfo(request);
   final boolean defaultExpanded = !Boolean.FALSE.equals(
      componentInfo.getField().getParameters(uiContext).get(RatingsComponent.PARAM_EXPANDED));
   
   final Assessment assessment = (Assessment)uiContext.getBusinessObject(
      ControlInstanceUIDefinitionType.ASSESSMENT_OBJ_NAME); 
   
   Timestamp ratingsTemplateFrozenDttm = null; 
   String mustBeSavedForRatingsKey = "RiskInstance.mustBeSavedForRatings.txt";
   
   final BusinessObjectList groups;
   
   AssessableTypeCd atc = AssessableTypeCd.risk;
   
   if (assessment != null) {
      final RatingsTemplate ratingsTemplate = assessment.getRatingsTemplate(psession);
      ratingsTemplateFrozenDttm = assessment.getRatingsTemplateFrozenDttm();
      
      // tagged pointer handle of the instance that this component is being displayed for
      final TaggedPointerHandle instanceHandle =   
         (TaggedPointerHandle)uiContext.getValue(MonitorUIContext.DefaultField.TP_HANDLE.getName());
      atc = InstanceAnswerContainer.getAssessableTypeCd(instanceHandle); 
      
      groups = ratingsTemplate.getQuestionGroups(atc, ratingsTemplateFrozenDttm, psession);
      
      if (AssessableTypeCd.control.equals(atc)) {
         mustBeSavedForRatingsKey = "ControlInstance.mustBeSavedForRatings.txt";
      }
   } else {
      groups = new BusinessObjectList(0);
   }
   
   final InstanceAnswerContainer iac = (InstanceAnswerContainer)uiContext.getValue(componentInfo.getField());
   final boolean ratingsSectionReadOnly = componentInfo.isReadOnly() || (assessment != null && iac == null);
%>

<mon:include js="/script/checkboxRadioUtil.js" />
<script type="text/javascript" 
   src="<%= request.getContextPath() %>/tiles/CSA/assessment/RatingsComponent.js"></script>
<%-- 
--%>

<script type="text/javascript">

var assessableType = "<%= atc.getValue() %>";

<% if (assessment != null) { %>
   addLoadEvent(RatingsComponent.registerOnChanges);
<% } %>   

var assessmentHandle = "<%= assessment == null ? "" : assessment.getHandleString() %>";

RatingsComponent.fieldName = "<c:out value="${componentInfo.field.name}"/>";
RatingsComponent.hasOnChangeActions = <c:out value="${componentInfo.field.hasOnChangeActions}"/>;
</script>

<a name="ratings"></a>
<%
   int sectionIdx = 0;
   for (Iterator it = groups.iterator(); it.hasNext();) {
      final AssessmentQuestionGroup group = (AssessmentQuestionGroup)it.next();
      final String sectionId = "ratings" + (sectionIdx++); 
      final AbstractQuestionGroup abstractGroup = 
         AbstractQuestionGroup.newInstance(group, ratingsTemplateFrozenDttm, psession);
      
      boolean expanded = defaultExpanded; // default is defined by the param value in XML
      
      // next, see if the user has changed the expanded/collapsed state
      Boolean bExpanded = uiContext.getSectionExpanded(sectionId);
      if (bExpanded != null) {
         expanded = bExpanded.booleanValue();
      }      
      
      final String secStateId = HTMLUtil.getSectionStateId(sectionId);
      
      if (sectionIdx > 1) {  // padding between sections/groups
%>
<br />
<%    } %>

<mon:section id="<%= sectionId %>" expanded="<%= expanded %>">
   <mon:title><%= StringUtil.escapeHTML(abstractGroup.getName()) %></mon:title>

<%
      final String grpHelp = abstractGroup.getHelpText();
      if (!ParsingUtils.isEmpty(grpHelp)) {   
         final String helpURL = "javascript:questionGroupHelp('" + group.getHandleString() + "')";
%>
   <mon:action href="<%= helpURL %>"><fmt:message key="application.help.txt" /></mon:action>
<%    } %>

<c:if test="${uiContext.neverBeenSaved}">   
   <span class="infoMessage"><img align="absmiddle" src="<%= request.getContextPath() %>/images/MessageInform_16.gif">
   <fmt:message><%= mustBeSavedForRatingsKey %></fmt:message>
   </span>
   <br /><br />
</c:if>

<mon:questionGroup
   questionGroup="<%= group %>"
   instanceAnswerContainer="<%= iac %>"
   formBased="true" 
   supportRadio="false"
   showTitle="false"
   readOnly="<%= ratingsSectionReadOnly %>"
   pointInTime="<%= ratingsTemplateFrozenDttm %>" 
/>
   
</mon:section>
<script type="text/javascript">
setCollapsible('<%= sectionId %>_body', '<%= sectionId %>_toggle_img',
   function(expanded) {cpb.elementById('<%= secStateId %>').value = '<%= sectionId %>:' + expanded;}, 
   '<%= sectionId %>_toggle_href');

cpb.addSectionId("<%= sectionId %>");
</script>
<%
      final String secState = sectionId + ":" + expanded; 
      HTMLUtil.writeHiddenField(CPBWebConstants.PARAM_SECTION_EXPANDED, 
         HTMLUtil.getSectionStateId(sectionId), secState, out);      
%>

<% } // end for() %>
