<%@ page import="java.util.*"%>
<%@ page import="com.sas.oprisk.framework.server.util.ParsingUtils"%>
<%@ page import="com.sas.oprisk.monitor.web.csa.RCSAGeneralModel"%>
<%@ page import="com.sas.oprisk.server.AssessmentTemplateEx"%>
<%@ page import="com.sas.oprisk.server.base.TemplateStatusCd"%>

<%@ include file="/tiles/taglibs.jsp"%>

<%
   final Locale locale = request.getLocale();
   final ResourceBundle bundle = ApplicationProperties.getBundle(locale);
   final PersistenceSession psession = MonitorContext.getPersistenceSession(request);
   final User currentUser = SecurityUtils.getUser(psession);
   
   // 4.3 Hotfix 4, retaining delete confirmation if change reason is not required anymore.
   boolean changeReasonRequired = ConfigDataProperties.isChangeReasonRequired();
   String deleteConfirmMsg = ParsingUtils.escape(bundle.getString("AssessmentTemplate.delete.confirm.message.fmt.txt"));
%>

<mon:Page template="wizardbanner">
   <mon:Head>
      <script type="text/javascript">
      function createNewAssessment(url) {beginWait();window.location.href = url;}
      function deleteAssessment(url) {beginWait();window.location.href = url;}
      function goAssessment(method, handle, showWaitDialog) {
         if (showWaitDialog) {
            beginWait();
         }
         document.forms.rcsaGeneralForm.action =
            "<%=request.getContextPath()%>/AssessmentTemplate.do"
               + "?method=" + method
               + "&handle=" + handle;
         document.forms.rcsaGeneralForm.submit();
      }
      
      function setDimAreaHandle(daHandle) {
         beginWait();
         document.forms.rcsaGeneralForm.submit();
         return false;
      }
      
      function createAssessmentTemplate() {
         var f = document.forms.rcsaGeneralForm;
         f.action =
           "<%=request.getContextPath()%>/AssessmentTemplate.do?method=create";
         f.submit();
      }
      
      function deleteAssessmentTemplate(name, handle){
          <% if (!changeReasonRequired) { %>
          var msg = formatMessage(
                unescape('<%= deleteConfirmMsg %>'), 
                unescape(name)
                );
          if (!confirm(msg)) {
             return;
          }
          <% } %>
          goAssessment('delete', handle);
       }
      
      function showContextMenu(handle, name, active, published, assessmentCnt) {
         var enabled = true;
         var copyFromEnabled = published && active;
         var deleteEnabled = assessmentCnt == 0;
         
         var menu = new TableMenu();
         <c:if test="${canUpdate}">
            menu.addMenuItem(new MenuItem(MenuItem.prototype.action,
               "<%=request.getContextPath()%>/" + (active ? "<fmt:message key='application.deactivate.image'/>" : "<fmt:message key='application.activate.image'/>"), 
               active ? "<fmt:message key='application.deactivate.txt'/>" : "<fmt:message key='application.button.reactivate.txt'/>", 
               active ? "javascript:goAssessment('deactivate', '" + handle + "')" : "javascript:goAssessment('reactivate', '" + handle + "')", 
               published));
         </c:if>
         <c:if test="${canCreate}">
            menu.addMenuItem(new MenuItem(MenuItem.prototype.action,
               "<%=request.getContextPath()%>/" + "<fmt:message key='application.createNewFrom.image'/>" , 
               "<fmt:message key='application.createNewFrom.txt'/>", "javascript:goAssessment('createFrom', '" + handle + "')", 
               copyFromEnabled));         
         </c:if>
         <c:if test="${canDelete}">
            menu.addMenuItem(new MenuItem(MenuItem.prototype.separator));
            menu.addMenuItem(new MenuItem(MenuItem.prototype.action, 
               "<%=request.getContextPath()%>/<fmt:message key='application.delete.image'/>", 
               "<fmt:message key='application.button.delete.txt'/>", 
               "javascript:deleteAssessmentTemplate('" + name + "', '" + handle + "')",
               deleteEnabled));
            
         </c:if>     
         menu.render();
         return false;
      }
      </script>
   </mon:Head>
   <mon:Body>
      <html:form action="/RCSAGeneral.do?method=assessmentTemplates">
         <mon:ToolBar />

         <mon:Content>
            <mon:tableComponent
               id="assessmentTemplate">
               <c:if test="${canCreate}">
                  <mon:action
                     href="javascript:createAssessmentTemplate();">
                     <fmt:message
                        key='AssessmentTemplates.button.new.txt' />
                  </mon:action>
               </c:if>

               <mon:column fieldName='assetRiskProfileRespVal'
                  formatter='com.sas.oprisk.monitor.web.table.AssetRiskProfileCellFormatter' />

               <mon:fixedColumn
                  title='<%= bundle.getString("displayTable.actions.txt") %>'
                  width="1%">
                  <%
                     final AssessmentTemplateEx template = (AssessmentTemplateEx) pageContext.findAttribute("assessmentTemplate");
                     int assessmentCnt = template.getCreatedFromTemplCount().intValue();
                     final boolean active = template.getTemplateActiveFlg().booleanValue();
                     boolean published = TemplateStatusCd.published.equals(template.getTemplateStatusCd());
                     String escName = ParsingUtils.escape(template.getName());
                  %>
               &nbsp;<a href="#"
                     onclick="return showContextMenu('<c:out value='${assessmentTemplate.handleString}'/>', '<%= escName %>',<%= active %>, <%= published %>, <%= assessmentCnt %>)"><img
                     border="0"
                     src="<%=request.getContextPath()%>/<fmt:message key='application.showActionsButton.row.image'/>"
                     alt="<fmt:message key='application.rowActions.tooltip.txt'/>"
                     title="<fmt:message key='application.rowActions.tooltip.txt'/>" /></a>&nbsp;
               </mon:fixedColumn>
               <mon:fixedColumn width="1%" before="false"
                  title='<%= bundle.getString("AssessmentWizard.create.title.txt") %>'>
                  <%
                     final AssessmentTemplateEx template = (AssessmentTemplateEx) pageContext
                  											.findAttribute("assessmentTemplate");
                  									final boolean canCreateAssessments = (TemplateStatusCd.published
                  											.equals(template
                  													.getTemplateStatusCd()))
                  											&& template.getTemplateActiveFlg()
                  													.booleanValue();

                  									if (canCreateAssessments) {
                  %>


                  <c:if test="${canCreateAssessmentsSomeWhere}">

                     <a
                        href="javascript:createNewAssessment('<%=request.getContextPath()%>/Assessment.do?method=createFromTemplate&handle=<c:out value="${assessmentTemplate.handleString}"/>')">
                     <img border="0" style="border: 0px;"
                        src="<%=request.getContextPath()%>/<fmt:message key='application.createNew.image'/>"
                        alt="<fmt:message key='application.create.tooltip.txt'/>"
                        title="<fmt:message key='application.create.tooltip.txt'/>" /></a>
                  </c:if>
                  <%
                     } else {
                  %>
         &nbsp;
         
         <%
                     }
                  %>
               </mon:fixedColumn>

            </mon:tableComponent>
         </mon:Content>
      </html:form>
   </mon:Body>
</mon:Page>
