<%@ include file="/tiles/taglibs.jsp" %>
<%@ page import="com.sas.oprisk.server.logical.*" %>
<%@ page import="com.sas.oprisk.monitor.web.csa.*" %>
<%
   String property = request.getParameter("property");
   String form = request.getParameter("form");
   String onsave = request.getParameter("onsave");
   String positionContainer = request.getParameter("positionContainer");
   String type = request.getParameter("type");
   String questionnaireTemplate = request.getParameter("questionnaireTemplate");

   String[] selectedHandleList = (String[]) request.getAttribute("selectedHandles");
   String[] selectedRisksHandles = (String[]) request.getAttribute("selectedRisks");

   StringBuilder selectedHandles = new StringBuilder();
   if (selectedHandleList != null)
   {
      for (int i = 0; i < selectedHandleList.length; i++)
      {
         String handle = selectedHandleList[i];
         selectedHandles.append(handle).append(",");
      }
   }

   StringBuilder selectedRisks = new StringBuilder();
   if (selectedRisksHandles != null)
   {
      for (int i = 0; i < selectedRisksHandles.length; i++)
      {
         String risk = selectedRisksHandles[i];
         selectedRisks.append(risk).append(",");
      }
   }

   String exportURL =
      request.getContextPath() +
      "/AssessmentWizardInstancesChooser.do" +
      "?positionContainer=" + StringUtil.encodeURLValue(positionContainer) +
      "&type=" + StringUtil.encodeURLValue(type) +
      "&entryId=" + StringUtil.encodeURLValue(type) +
      "&questionnaireTemplate=" + StringUtil.encodeURLValue(questionnaireTemplate);
%>

<mon:Page template="popup">

   <mon:Head>
      <script type="text/javascript">
      InstancesChooserDialog.initialize({
         property: "<%= StringUtil.escapeJSForHTML(property) %>",
         form: "<%= StringUtil.escapeJSForHTML(form) %>",
         onsave: "<%= StringUtil.escapeJSForHTML(onsave) %>",
         parameters: {
            positionContainer: "<%= StringUtil.escapeJSForHTML(positionContainer) %>",
            type: "<%= StringUtil.escapeJSForHTML(type) %>"
            }   
         });
      </script>
   </mon:Head>
   
   <mon:Body>
      
      <html:form action="/AssessmentWizardInstancesChooser">
      
      <mon:Content>
         <input type="hidden" name="property" value="<%= StringUtil.escapeHTML(property) %>" />
         <input type="hidden" name="form" value="<%= StringUtil.escapeHTML(form) %>" />
         <input type="hidden" name="onsave" value="<%= StringUtil.escapeHTML(onsave) %>" />
         <input type="hidden" name="positionContainer" value="<%= StringUtil.escapeHTML(positionContainer) %>" />
         <input type="hidden" name="questionnaireTemplate" value="<%= StringUtil.escapeHTML(questionnaireTemplate) %>" />
         <input type="hidden" name="type" value="<%= StringUtil.escapeHTML(type) %>" />
         <input type="hidden" name="selectedHandles" value="<%= StringUtil.escapeHTML(selectedHandles) %>" />
         <input type="hidden" name="selectedRisks" value="<%= StringUtil.escapeHTML(selectedRisks) %>" />
         <input type="hidden" name="filterCauses" value="<%=  StringUtil.escapeHTML(request.getAttribute("filterCauses")) %>" />
         <input type="hidden" name="filterControls" value="<%=  StringUtil.escapeHTML(request.getAttribute("filterControls")) %>" />
      
         <mon:tableComponent id="entry" entryName="<%= type %>"
                             exportXlsUrl="<%= exportURL %>">
         
            <c:set var="checkAll">
                <input type="checkbox" name="checkAll" id="checkAll" title="<fmt:message key="application.selectAll.tooltip.txt" />"/>
            </c:set>
      
            <mon:fixedColumn width='20' title="${checkAll}">
               <input type="checkbox" name="handleList"
                      value="<c:out value='${entry.handle}'/>"
                      <c:if test="${entry.selected}">checked="checked"</c:if>
                      />
            </mon:fixedColumn>
         
         </mon:tableComponent>
         
         <script type="text/javascript">
         new CheckboxGroup("queryForm", "handleList", "checkAll");
         </script>
      </mon:Content>
   
      <mon:PopupButtonBar>
         <mon:Button name="save" onclick="InstancesChooserDialog.save(); InstancesChooserDialog.close();">
            <fmt:message key='application.button.save.txt' />
         </mon:Button>
         
         <mon:Button name="apply" onclick="InstancesChooserDialog.save()">
            <fmt:message key='application.button.apply.txt' />
         </mon:Button>
      
         <mon:Button name="cancel" onclick="InstancesChooserDialog.close()">
            <fmt:message key='application.button.cancel.txt' />
         </mon:Button>         
      </mon:PopupButtonBar>
      </html:form>
      
   <%-- END BODY --%>
   </mon:Body>
   
<%-- END PAGE --%>
</mon:Page>