<%@ page import="java.util.*" %>
<%@ page import="com.sas.oprisk.monitor.web.csa.*" %>
<%@ page import="com.sas.solutions.cpb.web.util.RequestUtil" %>
<%@ page import="com.sas.solutions.cpb.web.util.HTMLUtil" %>

<%@ include file="/tiles/taglibs.jsp" %>

<%
   AssessmentWizardModel model = AssessmentWizardModel.getInstance(request);
   boolean readOnly = model.isReadOnly();
   PersistenceSession psession = model.getPersistenceSession();
	Locale locale = request.getLocale();
	ResourceBundle bundle = ApplicationProperties.getBundle(locale);
%>

<mon:Page template="wizard">

   <mon:Head>
      
      <script type="text/javascript">
      function previewTemplate(handle) {
         goWizard("previewTemplate&templateHandle=" + handle, "previous");
      }
      
      </script>
   
   </mon:Head>
   
   <mon:Body>
      
      <html:form action="/AssessmentWizard">
      
      <mon:ToolBar/>
      
      <mon:Content>
      
         <mon:maintainWizardState/>
            
         <mon:DimAreaChooser 
            property="location"
            excludedDimensions="RiskEventType"
            readOnly="true"
            feature="Assessment"
         />
               
         <br/>
         <%
         if (model.isFresh())
         {
         %>
         <mon:table scrollHeight="200px" class="displayTable" cellspacing="0" name="templates" id="template">
             <mon:title>
             <%
                HTMLUtil.writeSectionIndicators(
                   "templateId",
                   true,
                   RequestUtil.isFieldValueInvalid("template", pageContext),
                   request.getLocale(),
                   out);
                %>
                <fmt:message key="RCSAGeneral.step.questionnaires.txt"/> 
                
            </mon:title>
         <%
               final QuestionnaireTemplate t = (QuestionnaireTemplate) template;
         %>      
               <display:column width='20'>
         <%      
               final String tHandle = t.getHandleString();
         %>       
                  <html:radio property="template" value="<%= tHandle %>" />
               </display:column>
               
               <display:column title='<%= bundle.getString("application.id.txt") %>'><c:out value="${template.templateId}"/></display:column>
           
               <display:column title='<%= bundle.getString("structuredBusinessObjectLocalization.field.nameTxt.displayName.txt") %>'>
                  <c:if test="${not empty template}">
                     <%= StringUtil.escapeHTML(t.getName(psession)) %>
                  </c:if>
               </display:column>
         
               <display:column title='<%= bundle.getString("structuredBusinessObjectLocalization.field.descTxt.displayName.txt") %>'>
                  <c:if test="${not empty template}">
                     <%= (t.getDescription(psession) == null) ? "" : StringUtil.escapeHTML(t.getDescription(psession)) %>
                  </c:if>
               </display:column>
         
               <display:column title='<%= bundle.getString("questionnaireTemplate.field.sourceSystemCd.displayName.txt") %>'>
         <%
               if (t.getSourceSystemCd() != null) {
                  out.println(StringUtil.escapeHTML(MonitorContext.getMonitorContext(request).
                     getSourceSystemDescription(t.getSourceSystemCd(), locale, psession)));
               }
         %>       
               </display:column>
                
               <display:column width="1%" title='<%= bundle.getString("application.preview.txt") %>' align="center" headerClass="nwc">
                  <a href="javascript:previewTemplate('<c:out value='${template.handleString}'/>')">
                     <img border="0" src="<fmt:message key='application.preview.image'/>" /></a>
               </display:column>
         </mon:table>
         <%-- ensure a template is selected --%>
         <input type="hidden" name="template" value="" />
         <%
         }
         else
         {
            // We are editing existing assessment. Cannot change template.
            final QuestionnaireTemplate t = model.getTemplate();
            
            if (t != null)
            {
         %>
         <table>
            <tr>
               <th class="fieldlabel">
                  <fmt:message key="questionnaireTemplate.field.templateId.displayName.txt" />:
               </th>
               <td class="field">
                  <c:out value="${template.templateId}" />
               </td>
            </tr>
            <tr>
               <th class="fieldlabel">
                  <fmt:message key="structuredBusinessObjectLocalization.field.nameTxt.displayName.txt" />:
               </th>
               <td class="field">
                  <%= StringUtil.escapeHTML(t.getName(psession)) %>
               </td>
            </tr>
            <tr>
               <th class="fieldlabel">
                  <fmt:message key="structuredBusinessObjectLocalization.field.descTxt.displayName.txt" />:
               </th>
               <td class="field">
         <%
               final String descr = t.getDescription(psession);
               if (descr != null) {
                  out.print(StringUtil.escapeHTML(descr));
               }
         %>         
               </td>
            </tr>
            <tr>
               <th class="fieldlabel">
                  <fmt:message key="questionnaireTemplate.field.sourceSystemCd.displayName.txt" />:
               </th>
               <td class="field">
         <%
               if (t.getSourceSystemCd() != null) {
                  out.print(StringUtil.escapeHTML(MonitorContext.getMonitorContext(request).
                     getSourceSystemDescription(t.getSourceSystemCd(), locale, psession)));
               }
         %>       
               </td>
            </tr>
            <tr>
               <th class="fieldlabel">
                  <fmt:message key="ora.riskArea.title.txt" />:
               </th>
               <td class="field">
                  <%= t.getLocation(psession).formatHtml(psession) %>
               </td>
            </tr>
         </table>
         <%
            }
            else
            {
         %>
            <fmt:message key="AssessmentWizard.noTemplate.txt" /> 
         <%
            }
         }
         %>
      
      </mon:Content>
   
      </html:form>
      
   </mon:Body>
   
</mon:Page>