<%@ include file="/tiles/taglibs.jsp" %>
<%@ page import="java.util.*" %>
<%@ page import="com.sas.oprisk.monitor.web.csa.*" %>
<%@ page import="com.sas.oprisk.framework.server.util.DateTimeUtils" %>
<mon:setBundle />

<%
   ControlWizardModel model = ControlWizardModel.getFromRequest(request);
   
   Locale locale = request.getLocale();
   ResourceBundle bundle = ApplicationProperties.getBundle(locale);
   PersistenceSession psession = model.getPersistenceSession();
   
   boolean readOnly = model.isReadOnly();
%>

<script type="text/javascript">
function selectParentDimensionNode(id, name, node) {
   document.forms.controlWizardForm.parentHandle.value = id;
}
</script>

<html:form action="/ControlWizard" >

   <mon:maintainWizardState/>
   
   <html:hidden property="parentHandle" />

   <table width="100%">
      <tr id="controlWizard_controlNm">   
         <td width="25%"><mon:label key="control.field.controlNm.displayName.txt" property="controlNm" /></td>
         <td><mon:text property="controlNm" style="width:97%" maxlength="100" readonly="<%=readOnly%>" /></td>
      </tr>
      <tr id="controlWizard_controlId">   
         <td><mon:label key="control.field.controlId.displayName.txt" property="controlId" /></td>
         <td><mon:text property="controlId" size="32" maxlength="32" readonly="<%=readOnly%>" /></td>
      </tr>
      <tr id="controlWizard_sourceSystemCd">
         <td>
            <mon:label key="control.field.sourceSystemCd.displayName.txt" property="sourceSystemCd" />
         </td>
         <td>
            <mon:select property="sourceSystemCd" disabled="<%=readOnly%>">
               <html:options 
                  name="request"
                  collection="sourceSystems" 
                  property="code" 
                  labelProperty="description" />
            </mon:select>
         </td>
      </tr>
      <tr id="controlWizard_contolDesc">   
         <td><mon:label key="control.field.controlDesc.displayName.txt" property="controlDesc" /></td>
         <td><mon:textarea property="controlDesc" style="width:97%" rows="4" readonly="<%=readOnly%>" /></td>
      </tr>
      <tr id="controlWizard_owner">
         <th class="fieldlabel">
            <mon:label key='dimensionNode.field.owner.displayName.txt'
                       property="owner" />
         </th>
         <td class="field">
            <mon:UserChooser property="owner" readOnly="<%= !model.canSetOwner() %>" />
            <script type="text/javascript">
            <%-- Overrides the js method generated by UserChooserTag --%>
            function chooseUser_OWNER() {
               openModal(
                  "<%= request.getContextPath()%>/UserQueryForResponsibleUser.do"
                     + "?userProperty=owner",
                  'user_popup', 'width=750,height=500,scrollbars,resizable');
            }
            </script>
         </td>
      </tr>
      <tr id="controlWizard_activeDttm">
         <th class="fieldlabel">
            <mon:label key='control.field.activeFromDttm.displayName.txt'
                       property="activeFromDt" />
         </th>      
         <td>
            <table cellspacing="0" cellpadding="0">
               <tr>
                  <td class="field">
                     <mon:date property="activeFromDt"
                               dateFormat='<%= DateTimeUtils.getShortDateFormatPattern(request.getLocale()) %>' 
                               readOnly="<%= readOnly %>"/> 
                  </td>
                  <td>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</td>
                  <th class="fieldlabel">
                     <mon:label key='control.field.activeToDttm.displayName.txt'
                                property="activeToDt" separatorVisible="true" />
                  </th>
                  <td class="field">
                     <mon:date property="activeToDt"
                               dateFormat='<%= DateTimeUtils.getShortDateFormatPattern(request.getLocale()) %>' 
                               readOnly="<%= readOnly %>"/>
                  </td>
               </tr>
            </table>
         </td>
      </tr>
      <tr id="controlWizard_soxFlg">
        <th class="fieldlabel">
            <mon:label key='control.field.soxFlg.displayName.txt'
                       property="soxFlg" separatorVisible="true" />
        </th>
        <td>
            <fieldset class="screen-reader-only">
            <legend><mon:label key='control.field.soxFlg.displayName.txt'
                       property="soxFlg" separatorVisible="true" /></legend>
            <html:radio property="soxFlg" value="true" disabled="<%= readOnly %>">
               <fmt:message key="application.yes.txt" />
            </html:radio>    
            <html:radio property="soxFlg" value="false" disabled="<%= readOnly %>">
               <fmt:message key="application.no.txt" />
            </html:radio>
            </fieldset>
            <c:if test="${readOnly}">
              <html:hidden property="soxFlg"/>
            </c:if>
        </td>
      </tr>
      <tr id="controlWizard_controlNatureCd">   
         <td><mon:label key="control.field.controlNatureCd.displayName.txt" property="controlNatureCd" /></td>
         <td>
            <mon:select property="controlNatureCd" disabled="<%=readOnly%>">
               <html:options 
                  name="request"
                  collection="ctlNatureCds" 
                  property="code" 
                  labelProperty="description" />
            </mon:select>
         </td>
      </tr>
      <tr id="controlWizard_controlAutomationTypeCd">   
         <td><mon:label key="control.field.controlAutomationTypeCd.displayName.txt" property="controlAutomationTypeCd" /></td>
         <td>
            <mon:select property="controlAutomationTypeCd" disabled="<%=readOnly%>">
               <html:options 
                  name="request"
                  collection="controlAutomationTypes" 
                  property="code" 
                  labelProperty="description" />
            </mon:select>
         </td>
      </tr>
      <tr id="controlWizard_controlFrequencyCd">   
         <td><mon:label key="control.field.controlFrequencyCd.displayName.txt" property="controlFrequencyCd" /></td>
         <td>
            <mon:select property="controlFrequencyCd" disabled="<%=readOnly%>">
               <html:options 
                  name="request"
                  collection="ctlIntervalCds" 
                  property="code" 
                  labelProperty="description" />
            </mon:select>
         </td>
      </tr>
      <tr id="controlWizard_parent">
         <td style="white-space: nowrap; vertical-align: top;">
            <mon:label key='controlAssoc.field.parent.displayName.txt' property="parentHandle" />
         </td>
         <td valign="top" >
            <mon:SearchTreeChooser
               readOnly="<%= readOnly %>"
               dimensionNodeClassName="<%= com.sas.oprisk.server.Control.class.getName() %>"
               selectMethod="selectParentDimensionNode"
               selectedNodeKey="parentHandle"
               secureObjectClass="<%=model.getSecureObjectClass().getName()%>"
               secureAction="<%= Do.CREATE.getValue() %>"
               showRoot="true"
               cssStyle="height:145px; width:100%"/>
         </td>
      </tr>
      <tr id="controlWizard_assertions">
         <td style="white-space: nowrap; vertical-align: top;">
            <mon:label key='control.assertions.txt' property="parentHandle" />
         </td>
         <td valign="top" >
<%
   List controlAssertionList = readOnly ? model.getSelectedControlAssertionList() :
                                          model.getEntireControlAssertionList();
   
   Iterator iter = controlAssertionList.iterator();
   
   while(iter.hasNext())
   {
      ControlAssertion controlAssertion = (ControlAssertion)iter.next();
      boolean selected = model.isControlAssertionSelected(controlAssertion);
      String controlAssertionHandle = controlAssertion.getHandleString();
      String id = "controlAssertion" + controlAssertionHandle;
      
      if (readOnly)
      {
%>
            <div style="margin-bottom: .25em;"><%=controlAssertion.getName(locale, psession)%></div>
<%
      }
      else
      {
%>
            <div style="vertical-align: top;">
               <input type="checkbox"
                      name="selectedControlAssertions" id="<%=id%>"
                      value="<%=controlAssertionHandle%>"
                      <%= selected ? "checked='checked'" : "" %>
             /><label
                  for="<%= StringUtil.escapeHTML(id) %>" style="cursor: pointer;">
                  <%= StringUtil.escapeHTML(controlAssertion.getName(locale, psession)) %>
               </label>
            </div>
<%
      }
   }
%>
         </td>
      </tr>
      <tr id="controlWizard_policy">
        <th class="fieldlabel">
            <mon:label key='control.field.policy.displayName.txt'
                       property="policy" />
        </th>
        <td>
            <mon:textarea property="policy" style="width:97%" rows="8" readonly="<%= readOnly %>" />
            <c:if test="${readOnly}">
              <html:hidden property="policy"/>
            </c:if>
        </td>
      </tr>

   </table>
</html:form>