<%@ page import="java.util.*" %>
<%@ include file="/tiles/taglibs.jsp" %>
<%@ page import="com.sas.oprisk.monitor.web.tags.smarttags.SmartLabelTag" %>
<%@ page import="com.sas.oprisk.monitor.web.csa.actions.RiskProfileEditAction.RiskMeasure" %>
<%@ page import="com.sas.oprisk.monitor.web.csa.actions.RiskProfileEditAction.RiskProfileWrapper" %>
<%@ page import="com.sas.oprisk.monitor.web.csa.NumericInputResponseScale" %>
<%@ page import="com.sas.oprisk.monitor.web.csa.RiskResponseScale" %>
<%@ page import="com.sas.oprisk.server.util.CurrencyUtils" %>
<%@ page import="com.sas.oprisk.framework.server.util.ParsingUtils" %>

<%
	final Locale locale = request.getLocale();
	final ResourceBundle bundle = ApplicationProperties.getBundle(locale);
	final PersistenceSession psession = MonitorContext.getPersistenceSession(request);
	final List risks = (List)request.getAttribute("risks");
	final List rsts = (List)request.getAttribute("measures");

    final StringBuffer paramOrder = new StringBuffer(risks.size() * 5);
%>

<mon:Page template="details">
   <mon:Head>
      <script type="text/javascript">

      function setDimAreaHandle(daHandle) {
         beginWait();
         document.forms.riskProfileForm.submit();
         return false;
      }
         
      function save() {
         document.forms.riskProfileForm.submit();
      }
      
      function cancel() {
         document.forms.riskProfileForm.action = 
           "<%= request.getContextPath() %>/Breadcrumb.do";
         document.forms.riskProfileForm.submit();
      }
      
      </script>
   </mon:Head>
   <mon:Body>      
      <html:form action="/RiskProfileSave">      
         <mon:ToolBar>
            <mon:Button name="saveButton" onclick="save();">
               <fmt:message key='saveButton.txt' />
            </mon:Button>
            <mon:Button name="cancelButton" onclick="cancel();">
               <fmt:message key='cancelButton.txt' />
            </mon:Button>
         </mon:ToolBar>
         
         <mon:Content>
            <html:hidden property="location" />
   
            <mon:DimAreaChooser 
            property="location"
            excludedDimensions="RiskCategory"
            readOnly="true"
            feature="RiskManagement"/>
         
            <br/>
            
            <table cellspacing="0">
               <tr>
                  <td><mon:label 
                     property="assessmentPeriod" separatorVisible="true"
                    key="assessment.field.assessmentPeriod.displayName.txt" />
                  </td>
                  <td>
                  <mon:select property="assessmentPeriod">
                      <html:options name="request" collection="assessmentPeriods" 
                           property="handle" labelProperty="periodDesc" />
                  </mon:select> 
                  </td>
               </tr>
               <tr><td colspan="2"><br/></td></tr>
               <tr>
                  <td><mon:label 
                     key="questionnaireTemplate.field.currCd.displayName.txt"
                     separatorVisible="true"
                     property="currencyCd" />
                  </td>
                  <td>
                  <mon:select property="currencyCd">
                     <html:options name="request" 
                          collection="currencyCds" 
                          property="code" 
                          labelProperty="code" />
                  </mon:select>
                  </td>
                </tr>
            </table>
            
            <br/>
            
            <table width="100%" class="displayTable"  cellspacing="1" cellpadding="0">
               <tr><thead>
                  <th><fmt:message key="riskManagement.irm.path.txt"/></th>
                  <th><fmt:message key="assessmentPeriod.displayName.txt"/></th>        
         <%
                  for (Iterator i = rsts.iterator(); i.hasNext(); ) {
         %>
                     <th>
         <%          final ResponseScaleType rst = (ResponseScaleType)i.next(); 
                     final String calculation = rst.getComputationFn();
                     if (calculation != null && !calculation.equals("")) {
         %>             <img border="0" align="absmiddle" src="<fmt:message key='application.expressionEditor.image' />"
                                 alt="<%= StringUtil.escapeHTML(calculation) %>"  
                                 title="<%= StringUtil.escapeHTML(calculation) %>" />
         <%          }
         %>          <%= StringUtil.escapeHTML(rst.getName(locale, psession).trim()) %>
                     </th>
         <%       }
         %>
               </thead></tr> 
         <%
                  int rowNum = 1;
                  for (final Iterator j = risks.iterator(); j.hasNext(); ) {
                  
                     final RiskProfileWrapper risk = (RiskProfileWrapper)j.next();
                     if (rowNum > 1) { 
                        paramOrder.append(",");
                     }
                     paramOrder.append(risk.getHandle());
                     
                     final String rowStyle = ((rowNum % 2) == 0) ? "dataRow2_tableRow" : "dataRow1_tableRow";
         %>
                     <tr class='<%= rowStyle %>'>
                        <td valign="top"><%= risk.getInstanceName() %></td>
                        <td valign="top"><%= risk.getReportingPeriod() %></td>
         <%
                           final List riskMeasures = (List)risk.getMeasures();
                           final int numMeasures = riskMeasures.size();
                           for (Iterator k = riskMeasures.iterator(); k.hasNext();) {
                              final RiskMeasure rm = (RiskMeasure)k.next();
                              StringBuffer rmIdBuf = new StringBuffer();
                              rmIdBuf.append(rm.getName());
                              rmIdBuf.append(":::");
                              rmIdBuf.append(risk.getHandle());
                              rmIdBuf.append(":::");
                              rmIdBuf.append(rm.getResponseScale().getHandleString());
                              final Double currScore = rm.getCurrentScore();
                              final String displayedScore = rm.getDisplayedScore();
                            
                              rmIdBuf.append(":::");
                              rmIdBuf.append(ParsingUtils.formatDouble(currScore, locale));
                              
                              final String currCd = rm.getCurrCd();
                              
                              rmIdBuf.append(":::");
                              rmIdBuf.append(currCd);
                              
                              rmIdBuf.append(":::");
                              rmIdBuf.append(rm.isCalculated());
                           
                                final String rmId = rmIdBuf.toString();
                                final String rmVal = request.getParameter(rmId);
                                Double rmD = null;
                                 
                                try {
                                 rmD = ParsingUtils.parseDoubleAllowException(rmVal, locale);
                              } catch (Exception e) {}
         %>
                                <td style="white-space: nowrap; vertical-align: bottom;">
         <% 
                               if (rm.getScaleType().equalsIgnoreCase("numeric")) {
                                  if (!rm.isCalculated()) {
                                     final StringBuffer buf = new StringBuffer();
                                    NumericInputResponseScale.render(pageContext,buf,rm.getResponseScale(),rmId,rmD,null,false,psession);
                                    out.print(buf);
                                  }
         %>                       <p/>
                                  <fmt:message key="riskManagement.riskProfile.editRiskProfile.currentValue.txt"/>:&nbsp;  
         <%
                                 out.print(displayedScore);
                                 if (rm.isMonetary() && currCd != null && currScore != null) {
                                    out.print("&nbsp;");
                                    out.print(currCd);
                                 }
                               } else {
                                if (!rm.isCalculated()) {
                                      final StringBuffer buf = new StringBuffer();
                                      RiskResponseScale.render(pageContext,buf,rm.getResponseScale(),rmId,rmD,null,psession);
                                     out.print(buf);
                                  }
         %>                      <p/>
                                 <fmt:message key="riskManagement.riskProfile.editRiskProfile.currentValue.txt"/>:&nbsp;
         <%                      out.print(displayedScore);
                              }
                              if (rm.isCalculated()) {
         %>                      <input type="hidden" name="<%= rmId %>" />
         <%                    }
         
         %>                 </td>
         <%
                            }// end for each measure
         %>
                           </tr>
         <%
                           String just = request.getParameter("just_"+ risk.getHandle());
                           if (ParsingUtils.isEmpty(just)) {
                              just=risk.getJustification();
                           }
         %>
                        <tr class='<%= rowStyle %>' >
                        <td colspan="<%=numMeasures+2 %>">
                        <fmt:message key="Questionnaire.justification.txt" />:<br\>
                        <textarea name="just_<%=risk.getHandle() %>"
                           rows="4"
                           style="width:97%;border:1px solid;" ><%= StringUtil.escapeHTML(just) %></textarea>
                       </td>
                       </tr>
         <% 
                       rowNum++;
                    }
         %>
                    </table>
         
            <br/>
            <br/>
            
             <input type="hidden" name="PARAM_ORDER" value="<%= paramOrder.toString() %>" />                          
             <input type="hidden" name="TCFieldNames" value="<%= StringUtil.escapeHTML(request.getParameter("TCFieldNames")) %>" />
             <input type="hidden" name="TCQueryFilters" value="<%= StringUtil.escapeHTML(request.getParameter("TCQueryFilters")) %>" />
         </mon:Content>   
      </html:form>      
   </mon:Body>
</mon:Page>
