<%-- MENU: Risk Management > Libraries > Response Scales --%>
<%@ page import="java.util.*"%>
<%@ page import="com.ibm.icu.text.*"%>
<%@ page import="com.sas.oprisk.monitor.web.csa.RCSAGeneralModel.ResponseScaleEntry"%>
<%@ page import="com.sas.oprisk.server.ResponseScale"%>
<%@ page import="com.sas.oprisk.server.Response"%>
<%@ page import="com.sas.oprisk.framework.server.util.ParsingUtils"%>
<%@ include file="/tiles/taglibs.jsp"%>
<%
   final Locale locale = request.getLocale();
   final ResourceBundle bundle = ApplicationProperties.getBundle(locale);
   final PersistenceSession psession = MonitorContext.getPersistenceSession(request);
   final MonitorContext monitorContext = MonitorContext.getMonitorContext(request);
   final List responseScaleEntryList = (List) request.getAttribute("responseScaleEntryList");
   LayoutDirection layoutDirection = LayoutDirection.getLayoutDirection(request);
%>
<%!private String formatNumber(final Double value, ResourceBundle bundle,
      final Locale locale) {

      if (value == null)
         return "";

      long wholeNumber = value.longValue();

      if (Response.NA_VALUE.equals(value)) {
         return bundle
               .getString("dataloader.ResponseLoader.NotApplicable.string.txt");
      } else if (value
            .equals(new Double(new Long(wholeNumber).doubleValue()))) {
         final NumberFormat formatter = NumberFormat
               .getIntegerInstance(locale);
         return formatter.format(wholeNumber);
      } else {
         return ParsingUtils.formatDouble(value, locale);
      }
   }%>

<mon:Page template="wizardbanner">
   <mon:Head>
      <script type="text/javascript">

      function toggleScale(buttonObj, sectionNo) {
      
         var responseItems = document.getElementById("section" + sectionNo);
         if (responseItems.style.display == "")
         {
            responseItems.style.display = "none";
            buttonObj.src = "<fmt:message key='application.plus.image'/>";
         }
         else
         {
            responseItems.style.display = "";
            buttonObj.src = "<fmt:message key='application.minus.image'/>";
         }
      }
      
      function preview(handle) {
         openModal("<%=request.getContextPath()%>/RCSAGeneral.do"
            + "?method=responseScalePreview"
            + "&handle=" + handle,
         'rsPreview', 'width=750,height=500,scrollbars,resizable');
      }
      
      </script>

      <style type="text/css">
a:hover {
   text-decoration: underline;
}
</style>
   </mon:Head>
   <mon:Body>
      <mon:ToolBar />

      <mon:Content>
<%
   int sectionId = 0;
   Iterator entryIterator = responseScaleEntryList.iterator();
   while (entryIterator.hasNext())
   {
      sectionId++;

      ResponseScaleEntry entry = (ResponseScaleEntry) entryIterator.next();
      ResponseScale responseScale = entry.getResponseScale();
%>
         <div style="margin-bottom: 1em;">
            <mon:section expanded="false">
               <mon:title>
                  (<%= StringUtil.escapeHTML(responseScale.getExternalId()) %>)
                  <%= StringUtil.escapeHTML(entry.getDescription()) %>
<%
    if (entry.getType() != null)
    {
%>
                  (<%=bundle.getString("measureEx.displayName.txt")%>:
                  <%= StringUtil.escapeHTML(entry.getType().getName(locale, psession)) %>)
<%
    }
%>
                  <a style="margin-<%=layoutDirection.getLeft()%>: 10px" href="javascript:preview('<%=responseScale.getHandleString()%>')">
                     <u><fmt:message key="application.preview.txt" /></u>
                  </a>
                           
               </mon:title>
               
               <table width="100%" class="displayTable" cellspacing="0">
               <thead>
               <tr>
                  <th class="rsHdr"><fmt:message
                     key="response.field.responseId.displayName.txt" /></th>
                  <th class="rsHdr"><fmt:message
                     key="response.field.sourceSystemCd.displayName.txt" /></th>
                  <th class="rsHdr"><fmt:message
                     key="response.displayName.txt" /></th>
                  <th class="rsHdr"><fmt:message
                     key="response.field.responseVal.displayName.txt" /></th>
                  <th class="rsHdr"><fmt:message
                     key="response.field.minVal.displayName.txt" /></th>
                  <th class="rsHdr"><fmt:message
                     key="response.field.maxVal.displayName.txt" /></th>
                  <th class="rsHdr"><fmt:message
                     key="response.field.color.displayName.txt" /></th>
               </tr>
               </thead>
               <tbody>
               <%
                  Iterator responseIterator = entry.getResponseList()
                                          .iterator();

                                    while (responseIterator.hasNext()) {
                                       Response responseItem = (Response) responseIterator
                                             .next();
                                       final String label = responseItem.getName(
                                             locale, psession);
                                       final String sourceSystem = monitorContext
                                             .getSourceSystemDescription(
                                                   responseItem
                                                         .getSourceSystemCd(),
                                                   locale, psession);
               %>
               <tr class="dataRow1_tableRow">
                  <td><%= StringUtil.escapeHTML(responseItem.getExternalId()) %></td>
                  <td><%= StringUtil.escapeHTML(sourceSystem) %></td>
                  <td valign="middle"><%= StringUtil.escapeHTML(label) %></td>
                  <td><%=formatNumber(
                              responseItem.getResponseVal(), bundle,
                              locale)%></td>
                  <td><%=formatNumber(
                              responseItem.getMinVal(), bundle,
                              locale)%></td>
                  <td><%=formatNumber(
                              responseItem.getMaxVal(), bundle,
                              locale)%></td>
                  <td style="background-color:#<%= StringUtil.escapeHTML(responseItem.getColor()) %>">&nbsp;</td>
               </tr>
               <%
                  }
               %>
               </tbody>
               </table>
               
            </mon:section>
         </div>
<%
   }
%>
      </mon:Content>
   </mon:Body>
</mon:Page>

