<%@ page import="com.sas.oprisk.server.logical.*" %>
<%@ page import="com.sas.oprisk.monitor.web.csa.*" %>
<%@ page import="com.sas.oprisk.server.AnswerSheetStatus" %>

<%@ include file="/tiles/taglibs.jsp" %>

<%@ page import="java.util.*" %>

<%    
	final Locale locale = request.getLocale();
	final ResourceBundle bundle = ApplicationProperties.getBundle(locale);
	final PersistenceSession psession = MonitorContext.getPersistenceSession(request);
	final MonitorContext monitorContext = MonitorContext.getMonitorContext(request);
%>

<mon:Page template="details">
   <mon:Head>      
      <script type="text/javascript">    
      
      function send(answerSheetHandle) {
         doScenario("send&handle=" + answerSheetHandle);
      }
      
      function viewAssessors(roleHandle, areaHandle) {
         doScenario("viewAssessors"
            + "&roleHandle=" + roleHandle 
            + "&areaHandle=" + areaHandle);
      }
      
      function viewScenario(answerSheetHandle) {
         doScenario("select&handle=" + answerSheetHandle);
      }
      
      function doExport(answerSheetHandle) {
         doScenario("export&handle=" + answerSheetHandle);
      }
      
      function doScenario(method) {
         document.location = "<%= request.getContextPath() %>/Scenario.do"
            + "?method=" + method;
      }
      
      function showContextMenu(handle, status, roleHandle, areaHandle) {
         var notSent = '<%= AnswerSheetStatus.notSent.getValue() %>' == status;
         
         var menu = new TableMenu();
         
         menu.addMenuItem(new MenuItem(MenuItem.prototype.action,
            "<%= request.getContextPath() %>/" + 
               (notSent ? "<fmt:message key='Assessments.questionnaires.send.image'/>" 
                        : "<fmt:message key='Assessments.questionnaires.send.disabled.image'/>"), 
            "<fmt:message key='Scenario.scenarios.button.send.txt'/>", 
            "javascript:send('" + handle + "')", 
            notSent && <c:out value="${scenarioOpen}" />));
         menu.addMenuItem(new MenuItem(MenuItem.prototype.action,
            "<%= request.getContextPath() %>/<fmt:message key='application.export.image'/>", 
            "<fmt:message key='application.button.export.txt'/>", 
            "javascript:doExport('" + handle + "')"));
         menu.addMenuItem(new MenuItem(MenuItem.prototype.action,
            "<%= request.getContextPath() %>/<fmt:message key='Assessments.viewAssessors.image'/>", 
            "<fmt:message key='Assessments.questionnaires.button.viewAssessors.txt'/>", 
            "javascript:viewAssessors('" + roleHandle + "', '" + areaHandle + "')"));
         menu.render();
         
         return false;
      }
      
      </script>
   </mon:Head>
   <mon:Body>      
      <html:form action="/Scenarios?method=open">      
         <mon:ToolBar>
            <mon:Button name="okButton" onclick="breadcrumb('assessmentsForm', 2)">
               <fmt:message key='application.ok.txt' />
            </mon:Button>
         </mon:ToolBar>
         
         <mon:Content>            
            <html:hidden property="handle" />
            
            <mon:table width="100%" class="displayTable" cellspacing="0" name="answerSheets" id="entry">
            <%
               AssessmentAnswerSheet answerSheet = (AssessmentAnswerSheet)pageContext.findAttribute("entry");
               DimensionalArea location = null;
               AnswerSheetStatus answerSheetStatus = null;
               
               if (answerSheet != null)
               {
                  location = answerSheet.getLocation(psession);
                  answerSheetStatus = answerSheet.getAnswerSheetStatus(psession);
               }
            %>
               <mon:title><fmt:message key="AssessmentWizard.step.questionnaires.txt"/></mon:title>   
               
               <display:column width="1%">
                  &nbsp;<a href="#" onclick="return showContextMenu('<%=answerSheet.getHandleString()%>', '<%= answerSheetStatus.value %>', '<%= answerSheet.getRoleHandle().toString() %>', '<%= location.getHandleString() %>')"
                     ><img border="0" 
                           src="<%= request.getContextPath() %>/<fmt:message key='application.showActionsButton.row.image'/>" 
                           alt="<fmt:message key='application.rowActions.tooltip.txt'/>"
                           title="<fmt:message key='application.rowActions.tooltip.txt'/>"
                     /></a>&nbsp;</display:column>
                     
               <display:column title='<%= bundle.getString("application.id.txt") %>'>
                  <a href="javascript:viewScenario('<%=answerSheet.getHandleString()%>')"
                     ><%= StringUtil.escapeHTML(answerSheet.getAnswerSheetId()) %></a>
               </display:column>
            
               <display:column title='<%= bundle.getString("assessmentAnswerSheet.field.sourceSystemCd.displayName.txt") %>'>
                  <a href="javascript:viewScenario('<%=answerSheet.getHandleString()%>')">
                     <%= StringUtil.escapeHTML(monitorContext.getSourceSystemDescription(answerSheet.getSourceSystemCd(), locale, psession)) %>
                  </a>
               </display:column>
            
               <display:column title='<%= bundle.getString("AssessmentWizard.positions.role.txt") %>'>
                  <a href="javascript:viewScenario('<%=answerSheet.getHandleString()%>')">
                     <%= StringUtil.escapeHTML(answerSheet.getRole(psession).getRoleNm()) %>
                  </a>
               </display:column>
               
               <display:column title='<%= bundle.getString("AssessmentWizard.positions.scope.txt") %>'>
                  <a href="javascript:viewScenario('<%=answerSheet.getHandleString()%>')">
                     <%= StringUtil.escapeHTML(location.toString(psession)) %>
                  </a>
               </display:column>
               
               <display:column title='<%= bundle.getString("application.status.txt") %>'>
                  <%= bundle.getString(answerSheetStatus.getDisplayNameKey()) %>
               </display:column> 
            </mon:table>
         </mon:Content>   
      </html:form>      
   </mon:Body>
</mon:Page>
  