<%@ page import="java.util.*" %>
<%@ page import="com.sas.oprisk.monitor.web.csa.*" %>

<%@ include file="/tiles/taglibs.jsp" %>

<%
   ScenarioWizardModel model = ScenarioWizardModel.getInstance(request);
   boolean readOnly = model.isReadOnly();
   PersistenceSession psession = model.getPersistenceSession();
   Locale locale = request.getLocale();
   ResourceBundle bundle = ApplicationProperties.getBundle(locale);
%>

<mon:Page template="wizard">
   <mon:Head>
      <script type="text/javascript">
      function previewTemplate(handle) {
         goWizard("previewTemplate&templateHandle=" + handle, "previous");
      }      
      </script>
   </mon:Head>
   <mon:Body>      
      <html:form action="/ScenarioWizard">      
         <mon:ToolBar/>
         
         <mon:Content>
            <mon:maintainWizardState/>
     
            <mon:DimAreaChooser 
               property="location"
               excludedDimensions="RiskEventType"
               readOnly="true"
               feature="Scenario"
            />
                  
            <br/>
            
            <%
            if (model.isFresh())
            {
            %>
            <mon:table width="100%" class="displayTable" cellspacing="0" name="requestScope.templates" id="template">
            <%
                  final QuestionnaireTemplate t = (QuestionnaireTemplate) template;
            %>      
                  <display:column width='20'>
            <%      
                  final String tHandle = t.getHandleString();
            %>       
                     <html:radio property="template" value="<%= tHandle %>" />
                  </display:column>
                  
                  <display:column title='<%= bundle.getString("application.id.txt") %>'><c:out value="${template.templateId}"/></display:column>
              
                  <display:column title='<%= bundle.getString("structuredBusinessObjectLocalization.field.nameTxt.displayName.txt") %>'>
                     <c:if test="${not empty template}">
                        <%= StringUtil.escapeHTML(t.getName(psession)) %>
                     </c:if>
                  </display:column>
            
                  <display:column title='<%= bundle.getString("structuredBusinessObjectLocalization.field.descTxt.displayName.txt") %>'>
                     <c:if test="${not empty template}">
                       <%= StringUtil.escapeHTML((t.getDescription(psession) == null) ? "" : t.getDescription(psession)) %>
                     </c:if>
                  </display:column>
            
                  <display:column title='<%= bundle.getString("questionnaireTemplate.field.sourceSystemCd.displayName.txt") %>'>
            <%
                  if (t.getSourceSystemCd() != null) {
                     out.println(StringUtil.escapeHTML(MonitorContext.getMonitorContext(request).
                        getSourceSystemDescription(t.getSourceSystemCd(), locale, psession)));
                  }
            %>       
                  </display:column>
                   
                  <display:column width="1%" title='<%= bundle.getString("application.preview.txt") %>' align="center" headerClass="nwc">
                     <a href="javascript:previewTemplate('<c:out value='${template.handleString}'/>')">
                        <img border="0" src="<fmt:message key='application.preview.image'/>" /></a>
                  </display:column>
            </mon:table>
            <%
            }
            else
            {
               // We are editing existing assessment. Cannot change template.
               final QuestionnaireTemplate t = model.getTemplate();
               
               if (t != null)
               {
            %> 
            <table>
               <tr id="scenarioWizardTemplates_qnrTempltRk">
                  <th class="fieldlabel">
                     <fmt:message key="questionnaireTemplate.field.qnrTempltRk.displayName.txt" />:
                  </th>
                  <td class="field">
                     <c:out value="${template.templateId}" />
                  </td>
               </tr>
               <tr id="scenarioWizardTemplates_nameTxt">
                  <th class="fieldlabel">
                     <fmt:message key="structuredBusinessObjectLocalization.field.nameTxt.displayName.txt" />:
                  </th>
                  <td class="field">
                     <%= StringUtil.escapeHTML(t.getName(psession)) %>
                  </td>
               </tr>
               <tr id="scenarioWizardTemplates_descTxt" >
                  <th class="fieldlabel">
                     <fmt:message key="structuredBusinessObjectLocalization.field.descTxt.displayName.txt" />:
                  </th>
                  <td class="field">
            <%
                  final String descr = t.getDescription(psession);
                  if (descr != null) {
                     out.print(StringUtil.escapeHTML(descr));
                  }
            %>         
                  </td>
               </tr>
               <tr id="scenarioWizardTemplates_sourceSystemCd">
                  <th class="fieldlabel">
                     <fmt:message key="questionnaireTemplate.field.sourceSystemCd.displayName.txt" />:
                  </th>
                  <td class="field">
            <%
                  if (t.getSourceSystemCd() != null) {
                     out.print(StringUtil.escapeHTML(MonitorContext.getMonitorContext(request).
                        getSourceSystemDescription(t.getSourceSystemCd(), locale, psession)));
                  }
            %>       
                  </td>
               </tr>
               <tr id="scenarioWizardTemplates_riskArea">
                  <th class="fieldlabel">
                     <fmt:message key="ora.riskArea.title.txt" />:
                  </th>
                  <td class="field">
                     <%= StringUtil.escapeHTML(t.getLocation(psession).toString(psession)) %>
                  </td>
               </tr>
            </table>
            <%
               }
               else
               {
            %>
               <fmt:message key="AssessmentWizard.noTemplate.txt" /> 
            <%
               }
            }
            %>
         </mon:Content>   
      </html:form>      
   </mon:Body>
</mon:Page>
  