<%@ include file="/tiles/taglibs.jsp" %>
<%@ page import="java.util.*" %>
<%@ page import="com.sas.oprisk.monitor.web.kri.indicators.*" %>
<%@ page import="com.sas.oprisk.monitor.web.tags.smarttags.SmartLabelTag" %>

<%    
   Locale locale = request.getLocale();
   ResourceBundle bundle = ApplicationProperties.getBundle(locale);
   IndicatorAccessModel permissions = (IndicatorAccessModel) request.getAttribute("permissions");
   IndicatorPageModel model = (IndicatorPageModel) request.getAttribute("model");
   boolean readOnly = permissions.readOnly();
   String context = request.getContextPath();
%>

<mon:Page template="wizard">
   <mon:Head>
      <script type="text/javascript">
            
      var uomRequiresCurrency = new Object();
      var uomCurrency = new Object();
      <c:forEach items="${model.units}" var="unit">
        uomRequiresCurrency['<c:out value="${unit.handleString}"/>'] = <c:out value="${unit.currencyFlg and empty unit.currCd}"/>;
      <c:if test="${not empty unit.currCd}">
        uomCurrency['<c:out value="${unit.handleString}"/>'] = '<c:out value="${unit.currCd}"/>';
      </c:if>
      <c:if test="${empty unit.currCd}">
        uomCurrency['<c:out value="${unit.handleString}"/>'] = "";
      </c:if>
      </c:forEach>
      
      function updateCurrencyField()
      {
        var uomField = document.getElementById('selectUnitOfMeasure');
        var currCdField = document.getElementById('selectCurrCd');
      
        var selection = uomField.options[uomField.selectedIndex];
        var needsCurrencySelection = uomRequiresCurrency[selection.value];
      
        if (currCdField.disabled) 
        {
          if (needsCurrencySelection) currCdField.disabled = false;
          else currCdField.value = uomCurrency[selection.value];
        }
        else 
        {
          if (! needsCurrencySelection) {
            currCdField.selectedIndex = 0;
            currCdField.value = uomCurrency[selection.value];
            currCdField.disabled = true;
          }
        }
      }
      
      </script>
   </mon:Head>
   <mon:Body>      
      <html:form action="/IndicatorWizard">      
         <mon:ToolBar/>
         
         <mon:Content>
            
            <html:hidden property="handle" />

            <mon:maintainWizardState/>
            
            <mon:DimAreaChooser 
               property="dimensionalAreaHandle"
               readOnly="true" 
               feature="Indicator"
               everywhereAllowed="true"
               rootVisible="true"
               secureObjectClass="<%= Kri.class.getName() %>"
               secureAction="<%= Do.UPDATE.getValue() %>"
               />
            
            <table style="width: 100%" >                       
            
            <tr id="indicator_unitOfMeasure">
              <td>
                <mon:label styleId="unitOfMeasureLabel"
                     key="unitOfMeasure.displayName.txt" 
                     property="unitOfMeasureHandle" />:
              </td>
              <td>
                <c:if test="${not permissions.readOnly}">
                <html:select property="unitOfMeasureHandle" styleId="selectUnitOfMeasure" onchange="updateCurrencyField()">
                  <html:options collection="kriUnits" property="value" labelProperty="label" />
                </html:select> 
                </c:if>
                <c:if test="${permissions.readOnly}">
                  <c:out value="${unitOfMeasure}" />
                </c:if>
              </td>
            </tr>
            
            <tr id="indicator_currency">
              <td>
                <mon:label styleId="unitOfMeasureLabel"
                     key="kriResponseScale.field.currCd.displayName.txt" 
                     property="currCd" />:
              </td>
              <td>
                <%-- currency code drop-down --%>
                <c:if test="${not permissions.readOnly}">
                  <c:set var="currencyCds" value="${model.currencyCds}" />
                  <html:select property="currCd" styleId="selectCurrCd" disabled="<%= ! model.getEnableCurrencySelection().booleanValue() %>">
                    <html:options collection="currencyCds" property="code" labelProperty="code" />
                  </html:select>
                </c:if>
                <c:if test="${permissions.readOnly}">
                  <mon:text property="currCd" size="30" maxlength="100"  readonly="<%= readOnly %>"/>
                </c:if>
              </td>
            </tr>
            
            <script type="text/javascript">
            // initialize the currency code field on load
            updateCurrencyField();
            </script>
            
            <tr id="indicator_kriFrequencyCd">
              <td>
                <mon:label styleId="kriFrequencyLabel"
                     key="kri.field.kriFrequencyCd.displayName.txt" 
                     property="kriFrequencyCd" />:
              </td>
              <td>
                <c:if test="${not permissions.readOnly}">
                <html:select property="kriFrequencyCd" styleId="kriFrequencyCd">
                  <html:options collection="frequencies" property="value" labelProperty="label" />
                </html:select>
                </c:if>
                <c:if test="${permissions.readOnly}">
                   <c:out value="${frequencyDesc}" />
                </c:if>
              </td>
            </tr>
            <c:choose>
            <c:when test="${indicatorWizardForm.displayScaleType}">
            <tr id="indicator_kriScale">
              <td>
               <mon:label styleId="kriScaleType"
                     key="kriTemplate.range.scaleType.txt" 
                     property="scaleType" />:
               </td>
              <td>
                <c:if test="${not permissions.readOnly}">
                <html:select property="scaleType" styleId="scaleType">
                  <html:option value="3"><fmt:message key="kriTemplate.range.scaleType.valueThree.txt"/></html:option>
                  <html:option value="4"><fmt:message key="kriTemplate.range.scaleType.valueFour.txt"/></html:option>
                </html:select>
                </c:if>
                
                <c:if test="${permissions.readOnly}">
                  <c:choose>
                     <c:when test="${indicatorWizardForm.scaleType == '4'}">
                        <fmt:message key="kriTemplate.range.scaleType.valueFour.txt"/>
                     </c:when>
                     <c:otherwise>
                        <fmt:message key="kriTemplate.range.scaleType.valueThree.txt"/>
                     </c:otherwise>
                  </c:choose>
                </c:if>
              </td>
            </tr>
            </c:when>
            <c:otherwise>
               <html:hidden property="scaleType" value="3"/>
            </c:otherwise>
            </c:choose>
            <tr id="indicator_kriNature">
              <td>
                <mon:label styleId="kriNatureLabel"
                     key="kri.field.kriNatureCd.displayName.txt" 
                     property="kriNature" />:
              </td>
              <td>
                <c:if test="${not permissions.readOnly}">
                <html:select property="kriNatureCd" styleId="kriNatureCd">
                  <html:options collection="natures" property="value" labelProperty="label" />
                </html:select>
                </c:if>
                <c:if test="${permissions.readOnly}">
                  <c:out value="${nature}" />
                </c:if>
              </td>
            </tr>
            <tr id="indicator_kriType">
              <td>
                <mon:label styleId="KriTypeCdLabel"
                     key="kri.field.kriTypeCd.displayName.txt" 
                     property="kriTypeCd" />:
              </td>
              <td>
                <c:if test="${not permissions.readOnly}">
                <html:select property="kriTypeCd" styleId="kriTypeCd">
                  <html:options collection="kriTypes" property="value" labelProperty="label" />
                </html:select>
                </c:if>
                <c:if test="${permissions.readOnly}">
                  <c:out value="${type}" />
                </c:if>
              </td>
            </tr>
            
            <mon:CustFields 
               propertyKey="kri" 
               readOnly="<%= permissions.readOnly() %>" 
               format="table" 
               inOwnTable="false"
               displayHeader="false"
               groupNo="2"
               />
            
            </table>
         </mon:Content>   
      </html:form>      
   </mon:Body>
</mon:Page>


