<%@ include file="/tiles/taglibs.jsp" %>
<%@ page import="java.util.*" %>
<%@ page import="com.sas.oprisk.monitor.web.kri.templates.*" %>
<%@ page import="com.sas.oprisk.monitor.web.kri.indicators.*" %>


<%
   Locale locale = request.getLocale();
   ResourceBundle bundle = ApplicationProperties.getBundle(locale);
   PersistenceSession psession = MonitorContext.getPersistenceSession(request);

   KriDefinitionAccessModel permissions = (KriDefinitionAccessModel) request.getAttribute("permissions");
   KriDefinitionPageModel model = (KriDefinitionPageModel) request.getAttribute("model");
   String context = request.getContextPath();
   String myHandle = (String) request.getAttribute( "handle" );

   String createIndicatorURL = 
      "/KriDefinitionDispatch.do?method=createIndicator&handle=" + myHandle;

   String createIndicatorBody = bundle.getString("KriDefinitionWizard.createIndicator.txt");

   String editIndicatorURL = 
      "/KriDefinitionDispatch.do?method=editIndicator&handle=" + myHandle;

   String deleteIndicatorURL = request.getContextPath() + "/KriDefinitionWizard.do?method=deleteIndicator&handle=" + myHandle;
   String deleteIndicatorColumn = bundle.getString( "kri.IndicatorQuery.deleteIndicator.title" );

%>

<mon:Page template="wizard">
   <mon:Head>
      <script type="text/javascript">
      
      function editIndicator(kriHandle) {
         var path = '<%= editIndicatorURL %>&kriHandle=' + kriHandle;
         goWizard("forward&path=" + escape(path));
      }
      function createIndicator() {
         var path = '<%= createIndicatorURL %>';
         goWizard("forward&path=" + escape(path));
      }
      function deleteIndicator(handle) {
         var f = document.forms.kriDefinitionWizardForm;
         f.action = '<%= deleteIndicatorURL %>' 
            + '&kriHandle=' + handle;
         f.submit();
      }
      
      </script>
   </mon:Head>
   <mon:Body>      
      <html:form action="/KriDefinitionWizard">      
         <mon:ToolBar/>
         
         <mon:Content>
            
            <html:hidden property="handle" />
            <mon:maintainWizardState/>
            
            <mon:table width="100%" class="displayTable" cellspacing="0" name="requestScope.kris" id="kriEntry">
              <mon:title><fmt:message key="KriDefinitionWizard.indicatorTable.title.txt" /></mon:title>
              <% if ( permissions.userCanCreateKris() && model.isActive() ) { %>
                <mon:action href='javascript:createIndicator()'><%= createIndicatorBody %></mon:action>
              <% } %>
            <%--
              <display:setProperty name="basic.msg.empty_list" value='<%= bundle.getString("displayTable.empty.fmt.txt") %>' />
            --%>
              <display:column property="escapedId" title='<%= bundle.getString("kri.field.kriId.displayName.txt") %>' />
            
              <display:column title='<%= bundle.getString("businessObjectLocalization.field.nameTxt.displayName.txt") %>'  >
               <a href="#" onclick="editIndicator('<c:out value='${kriEntry.kriHandle}'/>')">
                  <c:out value='${kriEntry.name}' />
               </a>
              </display:column>
            
              <display:column property="location" title='<%= bundle.getString("kri.listModel.locations.txt") %>' />
              <display:column property="escapedOwner"  title='<%= bundle.getString("kri.field.owner.displayName.txt") %>' />
              <display:column property="activeFlg" title='<%= bundle.getString("kri.field.activeFlg.status.txt") %>' />
            
            <% if ( permissions.userCanDeleteKris() ) { %>
              <display:column title=''>
            
            <%  
                final KriListModelEntry entry = (KriListModelEntry) pageContext.findAttribute("kriEntry");
                final Kri indicator = entry.getKri();
            
                if ( indicator.canBeDeleted( psession ) && indicator.can( Do.DELETE, psession ) ) { %>
                  <a href="#" onclick="deleteIndicator('<c:out value='${kriEntry.kriHandle}'/>')">
                     <img border="0" style="border:0px;"
                        src="<%= request.getContextPath() %>/<fmt:message key='application.delete.image'/>" 
                        alt="<fmt:message key='application.delete.tooltip.txt'/>"
                        title="<fmt:message key='application.delete.tooltip.txt'/>"
                  /></a>
            <%   } else { %>
            &nbsp;
            <%   } %>
            
              </display:column>
            <% } %>
            
            </mon:table>
         </mon:Content>   
      </html:form>      
   </mon:Body>
</mon:Page>
