<%@ include file="/tiles/taglibs.jsp" %>
<%@ page import="java.util.*" %>
<%@ page import="com.sas.oprisk.monitor.web.kri.templates.*" %>
<%@ page import="com.sas.oprisk.monitor.web.tags.smarttags.SmartLabelTag" %>

<%    
   Locale locale = request.getLocale();
   ResourceBundle bundle = ApplicationProperties.getBundle(locale);
   KriDefinitionAccessModel permissions = (KriDefinitionAccessModel) request.getAttribute("permissions");
   KriDefinitionPageModel model = (KriDefinitionPageModel) request.getAttribute("model");
   String context = request.getContextPath();
   boolean readOnly = permissions.readOnly();
%>

<mon:Page template="wizard">
   <mon:Head>
   </mon:Head>
   <mon:Body>      
      <html:form action="/KriDefinitionWizard">      
         <mon:ToolBar/>
         
         <mon:Content>
            
            <html:hidden property="handle" />
            <mon:maintainWizardState/>
            
            <mon:DimAreaChooser 
               property="dimensionalAreaHandle"
               readOnly="true" 
               feature="IndicatorDefinition"
               everywhereAllowed="true"
               rootVisible="true"
               secureObjectClass="<%= KriTemplate.class.getName() %>"
               secureAction="<%= Do.UPDATE.getValue() %>"
               />
            
            <table style="width: 100%" >
            
            <tr id="kriDefinition_unitOfMeasure">
              <td>
                <mon:label styleId="unitOfMeasureLabel"
                     key="unitOfMeasure.displayName.txt" 
                     property="unitOfMeasureHandle" />:
              </td>
              <td>
                <c:if test="${not permissions.readOnly}">
                <html:select property="unitOfMeasureHandle" styleId="unitOfMeasureHandle">
                  <html:options collection="kriUnits" property="value" labelProperty="label" />
                </html:select> 
                </c:if>
                <c:if test="${permissions.readOnly}">
                  <c:out value="${unitOfMeasure}" />
                </c:if>
              </td>
            </tr>
            
            
            <tr id="kriDefinition_kriFrequency">
              <td>
                <mon:label styleId="kriFrequencyLabel"
                     key="kriTemplate.field.kriFrequencyCd.displayName.txt" 
                     property="kriFrequencyCd" />:
              </td>
              <td>
                <c:if test="${not permissions.readOnly}">
                <html:select property="kriFrequencyCd" styleId="kriFrequencyCd">
                  <html:options collection="frequencies" property="value" labelProperty="label" />
                </html:select>
                </c:if>
                <c:if test="${permissions.readOnly}">
                  <c:out value="${frequencyDesc}" />
                </c:if>
              </td>
            </tr>
            <c:choose>
            <c:when test="${kriDefinitionWizardForm.displayScaleType}">
            <tr id="kriDefinition_kriScale">
              <td>
               <mon:label styleId="kriScaleType"
                     key="kriTemplate.range.scaleType.txt" 
                     property="scaleType" />:
              </td>
              <td>
                <c:if test="${not permissions.readOnly}">
                <html:select property="scaleType" styleId="scaleType">
                    <html:option value="3"><fmt:message key="kriTemplate.range.scaleType.valueThree.txt"/></html:option>
                  <html:option value="4"><fmt:message key="kriTemplate.range.scaleType.valueFour.txt"/></html:option>
                </html:select>
                </c:if>
                
                <c:if test="${permissions.readOnly}">
                  <c:choose>
                     <c:when test="${kriDefinitionWizardForm.scaleType == '4'}">
                        <fmt:message key="kriTemplate.range.scaleType.valueFour.txt"/>
                     </c:when>
                     <c:otherwise>
                        <fmt:message key="kriTemplate.range.scaleType.valueThree.txt"/>
                     </c:otherwise>
                  </c:choose>
                </c:if>
              </td>
            </tr>
            </c:when>
            <c:otherwise>
               <html:hidden property="scaleType" value="3"/>
            </c:otherwise>
            </c:choose>
            
            <tr id="kriDefinition_kriNature">
              <td>
                <mon:label styleId="kriNatureLabel"
                     key="kriTemplate.field.kriNatureCd.displayName.txt" 
                     property="kriNature" />:
              </td>
              <td>
                <c:if test="${not permissions.readOnly}">
                <html:select property="kriNatureCd" styleId="kriNatureCd">
                  <html:options collection="natures" property="value" labelProperty="label" />
                </html:select>
                </c:if>
                <c:if test="${permissions.readOnly}">
                  <c:out value="${nature}" />
                </c:if>
              </td>
            </tr>
            <tr id="kriDefinition_kriType">
              <td>
                <mon:label styleId="KriTypeCdLabel"
                     key="kriTemplate.field.kriTypeCd.displayName.txt" 
                     property="kriTypeCd" />:
              </td>
              <td>
                <c:if test="${not permissions.readOnly}">
                <html:select property="kriTypeCd" styleId="kriTypeCd">
                  <html:options collection="kriTypes" property="value" labelProperty="label" />
                </html:select>
                </c:if>
                <c:if test="${permissions.readOnly}">
                  <c:out value="${type}" />
                </c:if>
              </td>
            </tr>
            
            <tr>
            </tr>
            
            <mon:CustFields 
               propertyKey="kriTemplate" 
               readOnly="<%= permissions.readOnly() %>" 
               format="table" 
               inOwnTable="false"
               displayHeader="false"
               groupNo="2"
               />
            
            </table>
         </mon:Content>   
      </html:form>      
   </mon:Body>
</mon:Page>
