<%@ include file="/tiles/taglibs.jsp"%>
<%@ page import="java.util.*"%>
<%@ page import="com.sas.oprisk.monitor.web.kri.observations.*"%>
<%@ page
   import="com.sas.oprisk.monitor.web.tags.smarttags.SmartLabelTag"%>
<%@ page import="com.sas.oprisk.server.behavior.PrimaryBusinessObject"%>
<%!// helper methods

	/**
	 * We don't want users to have the same object in their breadcrumb
	 * stack more than once, because the cache and get screwed up and 
	 * it opens up the possibility of lost edits, so only show a link 
	 * to a record that is not in the stack.
	 */
	private boolean showLinkTo(Set obsBeingEdited, ObservationListEntry obs) {
		return !obsBeingEdited.contains(obs.getObsHandle());
	}%>
<%
   final Set excludedCustomFields = new HashSet();
   excludedCustomFields.add(KriObservation.X_NORMALIZED_SCORE);
   Locale locale = request.getLocale();
			ResourceBundle bundle = ApplicationProperties.getBundle(locale);

			ObservationPageModel model = (ObservationPageModel) request
					.getAttribute("model");
			boolean isReadOnly = model.getIsReadOnly().booleanValue();
			boolean isOwner = model.isOwner().booleanValue();

			String dimAreaHandle = model.getDimAreaHandle();

			String context = request.getContextPath();

			String viewObservationURL = context
					+ "/KriObservationEditor.do?method=editObservation";

			String exportObservationsBody = bundle
					.getString("IndicatorWizard.exportObservations.txt");

			String exportObservationsURL = context
					+ "/ExportObservation?kriHandle="
					+ model.getKri().getHandleString();
			
			pageContext.setAttribute("min", Kri.object.formatNumber(model.getMin(), locale));
  			pageContext.setAttribute("mid1", Kri.object.formatNumber(model.getMid1(), locale));
		    pageContext.setAttribute("mid2", Kri.object.formatNumber(model.getMid2(), locale));
          pageContext.setAttribute("target", Kri.object.formatNumber(model.getTarget(), locale));
		    pageContext.setAttribute("max", Kri.object.formatNumber(model.getMax(), locale));
%>

<mon:Page template="details">
   <mon:Head>
      <script type="text/javascript">

      function submitToAction(action) {
        document.forms.kriObservationFormEx.action = action;
        document.forms.kriObservationFormEx.submit();
      }
      
      function go(action,extraParams) {
        var url = "<%=context%>/KriObservationEditor.do" + "?method=" + action;
        if (extraParams != null) url = url + "&" + extraParams;
        document.forms.kriObservationFormEx.action = url;
        document.forms.kriObservationFormEx.submit();
      }
      
      function newObservation() {
        go('createObservation','handle=<%=model.getKri().getHandleString()%>');
      }
      
      function forward(path, anchor) {
        path = escape(path);
        if (anchor && (anchor != "")) {
          path += "#" + anchor;
        }
      
        go('forward', 'path=' + path );
      }
      
      function viewObservation(handle)
      {
        var url = "/KriObservationEditor.do?method=editObservation&handle="+handle;
        url = escape(url);
        var dropBreadcrumb = '<%=isOwner ? "true" : "false"%>';
        dropBreadcrumb = "true";
        var params='dropBreadcrumb='+dropBreadcrumb+'&path=' + url;
        go('forward', params);
      }
      
      function exportObservation() {
        var url = "<%=context%>/ExportObservation?obsHandle=<%=model.getObservation().getHandleString()%>";
        document.forms.kriObservationFormEx.action = url;
        document.forms.kriObservationFormEx.submit();
      }
      
      <%-- Page refresh method to be called by popups --%>
      function popupCloser_refresh() {
        go('returnToEditor');
      }
      
      function returnToStage(ignored) {
        go('returnObservation');
      }
      
      </script>
   </mon:Head>
   <mon:Body>
      <html:form action="/KriObservationEditor">
         <mon:ToolBar>
            <%-- Action buttons are intially disabled, enabled later by JavaScript --%>
            <c:forEach var="action" items="${model.allowedActions}"
               varStatus="status">
               <mon:Button name="actionButton${status.count}"
                  onclick="submitToAction('${action.actionPath}')">
                  <fmt:message key='${action.labelKey}' />
               </mon:Button>
            </c:forEach>
         </mon:ToolBar>

         <mon:Content>
            <c:if test="${model.isFresh}">
               <h2><c:out
                  value="${model.kri.kriId} ${model.translation.nameTxt}" /></h2>
            </c:if>            

            <p><c:if test="${not empty model.owner}">
               <table cellSpacing='0' border='0' width='100%'>
                  <tbody>
                     <tr>
                        <td><span class='fieldlabel'><fmt:message
                           key="kri.field.owner.displayName.txt" /></span>: <span
                           class='field'><c:out
                           value="${model.ownerAsString}" /></span></td>

                        <td><span class='fieldlabel'><fmt:message
                           key="kri.validationState.label.txt" /></span>: <span
                           class='field'> <c:if
                           test="${model.isValidated}">
                           <fmt:message
                              key="kri.validationState.validated.txt" />
                        </c:if> <c:if test="${not model.isValidated}">
                           <fmt:message
                              key="kri.validationState.notValidated.txt" />
                        </c:if> </span></td>
                     </tr>
                  </tbody>
               </table>
            </c:if></p>

            <html:hidden property="handle" />
            <html:hidden property="isFresh" />
            <html:hidden property="kri" />
            <html:hidden property="responseScaleHandle" />
            <html:hidden property="kriObsRk" />
            <html:hidden property="snapshotDttm" />
            <html:hidden property="validationStateCd" />


            <mon:DimAreaChooser
               dimensionalAreaHandle="<%= dimAreaHandle %>"
               readOnly="true" feature="Indicator"
               everywhereAllowed="true" rootVisible="true"
               secureObjectClass="<%= KriTemplate.class.getName() %>"
               secureAction="<%= Do.UPDATE.getValue() %>" />
            <br />

            <c:if test="${not empty model.reviewersBlockModel}">
               <jsp:include page="../../commonBlocks/reviewers.jsp"
                  flush="true">
                  <jsp:param name="scrollable" value="false" />
                  <jsp:param name="collapsed" value="true" />
               </jsp:include>
               <br />
            </c:if>

            <table class='section' cellSpacing='1' cellPadding='0'
               width='100%' border='0'>
               <tbody>
                  <tr>
                     <td class='section'>
                     <div class='sectionheader'>
                     <div class='sectionheadertext'><c:out
                        value="${model.translation.nameTxt}" /></div>
                     </div>

                     <table class='sectionbody' cellspacing='10'
                        width='100%'>
                        <tbody>
                           <tr>
                              <td class='sectionbody'>

                              <table cellSpacing='5' border='0'>
                                 <tbody>
                                    <tr>
                                       <td><c:out
                                          value="${model.translation.descTxt}" /></td>
                                    </tr>
                                 </tbody>
                              </table>

                              <table cellSpacing='5' border='0'>
                                 <tbody>
                                    <tr>
                                       <td><c:out
                                          value="${model.translation.helpTxt}" /></td>
                                    </tr>
                                 </tbody>
                              </table>

                              <table cellSpacing='0' width='100%'
                                 border='0'>
                                 <tbody>

                                    <tr id="observation_kriObsId">
                                       <th class="fieldlabel"><mon:label
                                          key='kriObservation.field.kriObsId.displayName.txt'
                                          property="kriObsId"
                                          separatorVisible="true" /></th>
                                       <td class="field"><mon:text
                                          property="kriObsId" size="30"
                                          maxlength="100"
                                          readonly="<%= isReadOnly %>" />
                                       </td>
                                    </tr>

                                    <tr id="observation_sourceSystemCd">
                                       <th class="fieldlabel"><mon:label
                                          key='kriObservation.field.sourceSystemCd.displayName.txt'
                                          property="sourceSystemCd"
                                          separatorVisible="true" /></th>
                                       <td class="field"><c:if
                                          test="${not model.isReadOnly}">
                                          <mon:select
                                             property="sourceSystemCd">
                                             <html:options
                                                collection="sourceSystemCodes"
                                                property="code"
                                                labelProperty="description" />
                                          </mon:select>
                                       </c:if> <c:if test="${model.isReadOnly}">
                                          <html:hidden
                                             property="sourceSystemCd" />
                                          <c:out value="${sourceSystem}" />
                                       </c:if></td>
                                    </tr>

                                    <tr id="observation_assessmentPeriod">
                                       <th class="fieldlabel"><mon:label
                                          key="assessmentPeriod.displayName.txt"
                                          property="assessmentPeriod" />:
                                       </th>
                                       <td class="field"><c:if
                                          test="${not model.isReadOnly}">
                                          <html:select
                                             property="assessmentPeriod"
                                             styleId="assessmentPeriod"
                                             disabled='<%= model.getAssessmentPeriodIsDisabled() %>'>
                                             <html:options
                                                collection="assessmentPeriods"
                                                property="value"
                                                labelProperty="label" />
                                          </html:select>
                                          <c:if
                                             test="${model.assessmentPeriodIsDisabled}">
                                             <html:hidden
                                                property="assessmentPeriod" />
                                          </c:if>
                                       </c:if> <c:if test="${model.isReadOnly}">
                                          <c:out
                                             value="${model.currentPeriod}" />
                                          <html:hidden
                                             property="assessmentPeriod" />
                                       </c:if></td>
                                    </tr>
                                    <tr id="observation_score">
                                       <th class="fieldlabel"><mon:label
                                          key="kriObservation.field.score.displayName.txt"
                                          property="score" />:</th>
                                       <td class="field"><mon:text
                                          property="score" size="30"
                                          maxlength="100"
                                          readonly="<%= isReadOnly %>" />
                                       <span class="instructions"><c:out
                                          value="${model.unitOfMeasure}" /><c:if
                                          test="${model.uomIsCurrency}">
                            ( <mon:text property="currCd" size="30"
                                             maxlength="100"
                                             readonly="true" /> )
                        </c:if></span></td>
                                    </tr>

                                    <c:if
                                       test="${model.isReadOnly and model.hasNormalizedScore}">
                                       <tr id="observation_normalizedScore">
                                          <th class="fieldlabel"><%-- hack to get columns to line up right (label property is wrong on purpose) --%>
                                          <mon:label
                                             key="kriObservation.field.normalizedScore.displayName.txt"
                                             property="justification" />:
                                          </th>
                                          <td class="field"><c:out
                                             value="${model.normalizedScore}" />
                                          </td>
                                       </tr>
                                    </c:if>

                                    <tr id="observation_justification">
                                       <th class="fieldlabel"><mon:label
                                          key="kriObservation.field.justification.displayName.txt"
                                          property="justification" />:
                                       </th>
                                       <td class="field"><mon:textarea
                                          style="width: 100%"
                                          styleClass="textarea"
                                          readonly="<%= isReadOnly %>"
                                          property="justification"
                                          rows='8' /></td>
                                    </tr>
                                    <mon:CustFields
                                       propertyKey="kriObservation"
                                       readOnly="<%= isReadOnly %>"
                                       format="table"
                                       displayHeader="false"
                                       excludeFieldNames="<%=excludedCustomFields%>" />
                                 </tbody>
                              </table>

                              <table>
                                 <tr>
                                    <td>&nbsp;</td>
                                 </tr>
                              </table>

                              <%-- response scale table --%>

                              <table class='qgrp' cellSpacing='0'
                                 width="100%">
                                 <tbody>
                                    <%@ include
                                       file="responseScale.jspf"%>
                                 </tbody>
                              </table>

                              <%-- end response scale table --%> <mon:AttachmentsTable
                                 attachmentContainer='<%= (AttachmentContainer) model.getObservation() %>'
                                 refreshMethod="returnToEditor"
                                 readOnly='<%= isReadOnly %>' />

                              <c:if test="${not model.isFresh}">
                                 <table>
                                    <tr>
                                       <td>&nbsp;</td>
                                    </tr>
                                 </table>
                                 <mon:IssuesTable
                                    primaryBusinessObject='<%= (PrimaryBusinessObject) model.getObservation() %>'
                                    readOnly='false'
                                    immediateSave='<%= isReadOnly %>'
                                    forwardMethod="forward" />
                              </c:if></td>
                           </tr>
                        </tbody>
                     </table>
                     </td>
                  </tr>
               </tbody>
            </table>

            <mon:ifEnabled
               property="monitor.kri.showRecentValuesInObservationEditor">
               <p><mon:table width="100%" class="displayTable"
                  cellspacing="0"
                  name="requestScope.model.recentObservations.entries"
                  id="obs">
                  <mon:title>
                     <fmt:message
                        key="KriObservationEditor.previousScores.txt" />
                  </mon:title>

                  <display:setProperty name="basic.msg.empty_list"
                     value='<%= bundle.getString("displayTable.empty.fmt.txt") %>' />

                  <mon:action href='<%= exportObservationsURL %>'><%=exportObservationsBody%></mon:action>

                  <display:column
                     title='<%= bundle.getString("kriObservation.field.period.displayName.txt") %>'>
                     <%
                        if (obs != null) {
                     %>
                     <%
                        if (showLinkTo(
                     													model.getObservationsBeingEdited(),
                     													(ObservationListEntry) obs)) {
                     %>
                     <a
                        href="javascript:viewObservation('<%=((ObservationListEntry) obs)
														.getObsHandle()%>')">
                     <c:out value="${obs.observationDate}" /> </a>
                     <%
                        } else {
                     %>
                     <c:out value="${obs.observationDate}" />
                     <%
                        }
                     %>
                     <%
                        }
                     %>
                  </display:column>

                  <display:column property="score"
                     title='<%= bundle.getString("kriObservation.field.score.displayName.txt") %>' />

                  <display:column property="rangeDescription"
                     title='<%= bundle.getString("kriObservation.field.range.displayName.txt") %>' />

                  <display:column property="normalizedScore"
                     title='<%= bundle.getString("kriObservation.field.normalizedScore.displayName.txt") %>' />

                  <display:column
                     title='<%= bundle.getString("kriObservation.color.column.displayName.txt") %>'>
                     <div style='<c:out value="${obs.colorStyle}" />'>&nbsp;</div>
                  </display:column>

                  <display:column title=''>
                     <c:if test="${obs.hasAttachments}">
                        <img border="0" style="border: 0px;"
                           src="<%=request.getContextPath()%>/<fmt:message key='KriObservationEditor.hasAttachment.image'/>"
                           alt="<fmt:message key='KriObservationEditor.hasAttachment.tooltip.txt'/>"
                           title="<fmt:message key='KriObservationEditor.hasAttachment.tooltip.txt'/>" />
                     </c:if>
                     <c:if test="${not obs.hasAttachments}">&nbsp;</c:if>
                  </display:column>

               </mon:table></p>
            </mon:ifEnabled>

            <br />

            <%
               if (ConfigDataProperties
            									.getShowLinkedBusinessObjectsOnKriObservation()) {
            %>
            <br></br>
            <mon:LinkedBusinessObjects
               sourceBusinessObject="<%= model.getObservation() %>"
               readOnly="<%= isReadOnly %>" />
            <br>
            <br />

            <%
               }
            %>
            <br />
         </mon:Content>
      </html:form>
   </mon:Body>
</mon:Page>


