<%@ include file="/tiles/taglibs.jsp"%>
<%@ page import="java.util.*"%>
<%@ page import="com.sas.oprisk.monitor.web.kri.requests.*"%>
<%@ page
   import="com.sas.oprisk.monitor.web.tags.smarttags.SmartLabelTag"%>

<%
   try {
				Locale locale = request.getLocale();
			   PersistenceSession psession = MonitorContext.getPersistenceSession(request);
				ResourceBundle bundle = ApplicationProperties.getBundle(locale);
				ObservationRequestPageModel model = (ObservationRequestPageModel) request
						.getAttribute("model");
				boolean isReadOnly = model.getPermissions().getIsReadOnly()
						.booleanValue();

            String kriNameText = model.getKriNameText(psession);
            pageContext.setAttribute("kriNameText",kriNameText);
				String dimAreaHandle = model.getDimAreaHandle();

				String context = request.getContextPath();
				
				pageContext.setAttribute("min", Kri.object.formatNumber(model.getMin(), locale));
				pageContext.setAttribute("mid1", Kri.object.formatNumber(model.getMid1(), locale));
				pageContext.setAttribute("mid2", Kri.object.formatNumber(model.getMid2(), locale));
				pageContext.setAttribute("target", Kri.object.formatNumber(model.getTarget(), locale));
            pageContext.setAttribute("max", Kri.object.formatNumber(model.getMax(), locale));
%>

<mon:Page template="details">
   <mon:Head>
      <script type="text/javascript">

      function go(action,extraParams) {
        var url = "<%=context%>/KriObservationRequestEditor.do" + "?method=" + action;
        if (extraParams != null) url = url + "&" + extraParams;
        document.forms.observationRequestFormEx.action = url;
        document.forms.observationRequestFormEx.submit();
      }
      
      function newRequest() {
        go('createRequest','handle=<%=model.getKri().getHandleString()%>');
      }
      
      function forward(path, anchor) {
           path = escape(path);
           if (anchor && (anchor != "")) {
             path += "#" + anchor;
           }
           go('forward', 'path=' + path );
         }
      
      
      <c:if test="${model.hasObservation}">
      function viewObservation() {
        window.location='<%=context%>/KriObservationEditor.do?method=editObservation&handle=<c:out value="${model.observation.handle}"/>'
      }
      </c:if>      
      
      <%-- Page refresh method to be called by popups --%>
      function popupCloser_refresh() {
        go('returnToEditor');
      }
      
      </script>
   </mon:Head>
   <mon:Body>
      <html:form action="/KriObservationRequestEditor">
         <mon:ToolBar>
            <c:if
               test="${model.isFresh && model.permissions.userCanCreate}">
               <mon:Button name="saveButton"
                  onclick="go('submitRequest')">
                  <fmt:message key='application.save.txt' />
               </mon:Button>
            </c:if>

            <c:if test="${not model.isFresh}">
               <c:if test="${model.permissions.userCanEdit}">
                  <mon:Button name="saveButton"
                     onclick="go('submitRequest')">
                     <fmt:message key='application.save.txt' />
                  </mon:Button>
               </c:if>

               <c:if test="${model.hasObservation}">
                  <mon:Button name="viewButton"
                     onclick="go('viewObservation')">
                     <fmt:message
                        key='KriObservationRequest.viewObservation.txt' />
                  </mon:Button>
               </c:if>

               <c:if test="${model.userCanDelete}">
                  <mon:Button name="deleteButton" onclick="go('deleteRequest')">
                     <fmt:message key='application.button.delete.txt' />
                  </mon:Button>
               </c:if>

               <c:if
                  test="${model.permissions.userCanCreate and model.kriIsActive}">
                  <mon:Button name="requestButton"
                     onclick="newRequest()">
                     <fmt:message
                        key='KriObservationRequest.createNewRequest.txt' />
                  </mon:Button>
               </c:if>
            </c:if>

            <mon:Button name="cancelButton"
               onclick="go('cancelRequest')">
               <fmt:message key='application.cancel.txt' />
            </mon:Button>
         </mon:ToolBar>

         <mon:Content>

            <c:if test="${model.isFresh}">
               <h2><c:out
                  value="${model.kri.kriId} ${kriNameText}" /></h2>
            </c:if>

            <html:hidden property="handle" />
            <html:hidden property="obsReqRk" />
            <html:hidden property="isFresh" />
            <html:hidden property="kri" />

            <mon:DimAreaChooser
               dimensionalAreaHandle="<%= dimAreaHandle %>"
               readOnly="true" feature="Indicator"
               everywhereAllowed="true" rootVisible="true"
               secureObjectClass="<%= KriTemplate.class.getName() %>"
               secureAction="<%= Do.UPDATE.getValue() %>" />

            <p>&nbsp;</p>

            <table class='section' cellSpacing='1' cellPadding='0'
               width='100%' border='0'>
               <tbody>
                  <tr>
                     <td class='section'>
                     <div class='sectionheader'>
                     <div class='sectionheadertext'><c:out
                        value="${kriNameTxt}" /></div>
                     </div>

                     <table class='sectionbody' cellspacing='10'
                        width='100%'>
                        <tbody>
                           <tr>
                              <td class='sectionbody'>

                              <table cellSpacing='0' width='100%'
                                 border='0'>
                                 <tbody>

                                    <tr id="request_owner">
                                       <td><mon:label
                                          key="kri.field.owner.displayName.txt"
                                          property="ignored" />:</td>
                                       <td><c:out
                                          value="${model.ownerAsString}" /></td>
                                    </tr>

                                    <tr id="request_observationRequestId">
                                       <th class="fieldlabel"><mon:label
                                          key='kriObservationRequest.field.obsRequestId.displayName.txt'
                                          property="obsRequestId"
                                          separatorVisible="true" /></th>
                                       <td class="field"><mon:text
                                          property="obsRequestId"
                                          size="30" maxlength="100"
                                          readonly="<%= isReadOnly %>" />
                                       </td>
                                    </tr>

                                    <tr id="request_sourceSystemCd">
                                       <th class="fieldlabel"><mon:label
                                          key='kriObservationRequest.field.sourceSystemCd.displayName.txt'
                                          property="sourceSystemCd"
                                          separatorVisible="true" /></th>
                                       <td class="field"><c:if
                                          test="${not model.permissions.isReadOnly}">
                                          <mon:select
                                             property="sourceSystemCd">
                                             <html:options
                                                collection="sourceSystemCodes"
                                                property="code"
                                                labelProperty="description" />
                                          </mon:select>
                                       </c:if> <c:if
                                          test="${model.permissions.isReadOnly}">
                                          <c:out value="${sourceSystem}" />
                                       </c:if></td>
                                    </tr>

                                    <tr id="request_assessmentPeriod">
                                       <td><mon:label
                                          key="assessmentPeriod.displayName.txt"
                                          property="assessmentPeriod" />:
                                       </td>
                                       <td><c:if
                                          test="${model.isFresh}">
                                          <html:select
                                             property="assessmentPeriod"
                                             styleId="assessmentPeriod">
                                             <html:options
                                                collection="assessmentPeriods"
                                                property="value"
                                                labelProperty="label" />
                                          </html:select>
                                       </c:if> <c:if
                                          test="${not model.isFresh }">
                                          <c:out
                                             value="${model.currentPeriod}" />
                                          <html:hidden
                                             property="assessmentPeriod" />
                                       </c:if></td>
                                    </tr>

                                    <tr id="request_dueDt">
                                       <td><mon:label
                                          key="kriObservationRequest.field.dueDt.displayName.txt"
                                          property="dueDt" />:</td>
                                       <td><mon:date
                                          property="dueDt"
                                          readOnly='<%= isReadOnly %>'
                                          dateFormat='<%= model.getDateFormatShort() %>' />
                                       </td>
                                    </tr>
                                    <tr>
                                       <td>&nbsp;</td>
                                    </tr>
                                    <tr id="request_unitOfMeasure">
                                       <td><mon:label
                                          key="kriResponseScale.field.unitOfMeasure.displayName.txt"
                                          property="score" />:</td>
                                       <td><c:out
                                          value="${model.unitOfMeasure}" />
                                       <c:if
                                          test="${model.uomIsCurrency}">
                            ( <c:out value="${model.currCd}" /> )
                        </c:if></td>
                                    </tr>
                                 </tbody>
                              </table>

                              <table>
                                 <tr>
                                    <td>&nbsp;</td>
                                 </tr>
                              </table>

                              <%-- response scale table --%>

                              <table class='qgrp' cellSpacing='0'
                                 width="100%">
                                 <tbody>
                                    <%@ include
                                       file="responseScale.jspf"%>
                                 </tbody>
                              </table>

                              <%-- end response scale table --%></td>
                           </tr>
                        </tbody>
                     </table>
                     </td>
                  </tr>
               </tbody>
            </table>
            <br />
            <br />

            <%
               if (ConfigDataProperties
            										.getShowLinkedBusinessObjectsOnKriObservationRequest()) {
            %>
            <br></br>
            <mon:LinkedBusinessObjects
               sourceBusinessObject="<%= model.getObsRequest() %>"
               readOnly="<%= isReadOnly %>" />
            <br>
            <br />
            <%
               }
            %>
         </mon:Content>
      </html:form>
   </mon:Body>
</mon:Page>

<% 
   } catch (Throwable t) {
      t.printStackTrace();
   }
%>

