<%@ include file="/tiles/taglibs.jsp" %>
<%@ page import="com.sas.oprisk.monitor.web.audit.AuditAction" %>
<%@ page import="com.sas.oprisk.monitor.web.audit.component.AuditTestTableComponent" %>
<%@ page import="com.sas.oprisk.monitor.web.audit.assignTesters.AssignTestersAction" %>
<%@ page import="com.sas.oprisk.monitor.util.RequestDebug" %>
<%@ page import="com.sas.oprisk.framework.server.util.ParsingUtils" %>
<%@ page import="com.sas.oprisk.server.logical.TesterPool" %>
<%@ page import="java.util.*" %>

<mon:Page template="popup">

   <%
      String auditHandle = request.getParameter(AuditAction.AUDIT_INSTANCE_HANDLE);
      String testHandle = request.getParameter("tests");
         
      final Locale locale = request.getLocale();
      final ResourceBundle bundle = ApplicationProperties.getBundle(locale);
      
      final String exportUrl = request.getContextPath() + "/AuditAssignTesters.do?method=refresh&entryId=";
   %>
   <mon:Head>
      <mon:Title><fmt:message key="audit.scope.action.assignTesters.txt" /></mon:Title>
      
      <mon:include js="/script/checkboxRadioUtil.js" />
      
      <script type="text/javascript">
      
      
      function requestMethod( methodName ) {
         document.forms.auditAssignTestersForm.action = 
               "<%= request.getContextPath() %>/AuditAssignTesters2.do?method="
               + methodName;
         document.forms.auditAssignTestersForm.submit();
      }
      
      function doCancel(){
         window.close();
      }
      
      function assignTesters(){
         var f = document.forms.auditAssignTestersForm;
         f.testsSelected.value = getSelectedCheckboxValues(f, "testHandle");
         requestMethod('assignTesters');
      }
      
      function assignAuditors(){
         var f = document.forms.auditAssignTestersForm;
         var userHandle = getSelectedCheckboxValues(f, "userHandle");
         var testHandle = "<%= StringUtil.escapeJSForHTML(testHandle) %>";
         window.opener.doAssignAuditors(userHandle, testHandle);
         window.close();
      }
      
      // method to add the selected users from "Add Users" window.
      function addSelectedUsers( selectionArray ) 
      {
         document.forms.auditAssignTestersForm.usersToAddOrRemove.value = selectionArray;
         requestMethod('addUsers');
      }
      
      </script>
   </mon:Head>
   
   <mon:Body>
      <%
         String selColTitle = "<input type=\"checkbox\" name=\"selectAll\" title=\""
             + bundle.getString("application.selectAll.tooltip.txt") + "\" />";
      %>
      <html:form action="/AuditAssignTesters">
      
      <mon:Content>
      
         <html:hidden property="aInstHandle" />
         <html:hidden property="location" />
         <html:hidden property="uid" />
         <html:hidden property="tests" />
         
         <input type="hidden" name="UID" />
         <input type="hidden" name="tests" />
         
         <input type="hidden" name="testsSelected" />
         <input type="hidden" name="usersToAddOrRemove" />
         <input type="hidden" name="positionsToAddOrRemove" />
         
         <mon:tableComponent entryName="tests" id="test" wizCursor="refresh" exportXlsUrl="<%= exportUrl + \"tests\" %>">
            <mon:title><fmt:message key="audit.assignTesters.section.tests.title.txt" /></mon:title>
            
         </mon:tableComponent>
         
         <br/>
            <mon:tableComponent entryName="users" id="user" wizCursor="refresh"  exportXlsUrl="<%= exportUrl + \"users\" %>">
               <mon:title><fmt:message key="audit.assignTesters.section.users.title.txt" /></mon:title>
               <mon:fixedColumn width="10" title="<%= selColTitle %>">
                  <input type="checkbox" name="userHandle" value="<c:out value="${user.handle}" />" />
               </mon:fixedColumn>
            </mon:tableComponent>
      </mon:Content>
      <mon:PopupButtonBar>
         <mon:Button name="assign" onclick="javascript:assignAuditors()">
            <fmt:message key='audit.assignTesters.button.assign.label.txt' />
         </mon:Button>
         <mon:Button name="cancel" onclick="javascript:doCancel()">
            <fmt:message key='application.cancel.txt' />
         </mon:Button>
      </mon:PopupButtonBar>
      
      
   </html:form>
   
   <script type="text/javascript">
      new CheckboxGroup("auditAssignTestersForm", "userHandle", "selectAll");
   </script>
   </mon:Body>
   
   
</mon:Page>