<%@ include file="/tiles/taglibs.jsp" %>
<%@ page import="java.util.*" %>



<%
   final java.util.Locale locale = request.getLocale();
   final java.util.ResourceBundle bundle = ApplicationProperties.getBundle(locale);
   final PersistenceSession psession = MonitorContext.getPersistenceSession(request);
   
   String selColTitle = "<input type=\"checkbox\" name=\"selectAll\" title=\"" 
      + bundle.getString("application.selectAll.tooltip.txt") + "\" />";
      
   String ciHandle = request.getParameter("ciHandle");
%>

<mon:Page template="popup">
   <mon:Head>
      <mon:include js="/script/checkboxRadioUtil.js" />
      <script type="text/javascript">

         parent.allowParentToClose = function() {
            // Since this was called from an onClose() event, start a timer that will
            // re-sync the currentDialog variable when the new window is loaded.
            this.window.setTimeout(resyncCurrentDialog, 1000);
            return false;
         }
      
         function resyncCurrentDialog() {
            if ((typeof(opener.currentDialog) != 'undefined') &&
                  (opener.currentDialog == null)) 
            {
               opener.setModalDialog(window);
               return;
            }
         
            // parent window isn't ready, wait for a bit and try again 
            this.window.setTimeout(resyncCurrentDialog, 1000);
         }
         
         //public
         function doCreateTests() {
            var selections = getSelectedTestDefinitions();     
            if (selections == null) {
               alert("<fmt:message key='AssessmentWizard.error.noSelections.txt'/>");
            } else {
               window.opener.createTests('<%= StringUtil.escapeJSForHTML(ciHandle) %>', selections);
               window.close(); 
            }
         }
         
         //private
         function getSelectedTestDefinitions() {
            //getSelectedCheckboxValues method defined in the checkboxRadioUtil.js
            var values = getSelectedCheckboxValues(document.forms[0], "testDefHandle");
            return (values.length == 0) ? null : values;
         }
         
         //shows the test definition in a new popup window as readonly. The new window closes once "Done" viewing.
         function showTestDefinition(handle) {    
            openModal(
                  "<%= request.getContextPath() %>" 
                  + "/TestDefinitionEdit.do?method=select&handle="
                  + handle + "&isReadOnly=true&isPopup=true",
                  "testDefPopup", 
                  "width=750,height=550,scrollbars,resizable,status");
            }
      
      </script>
   </mon:Head>
   <mon:Body>      
      <html:form action="/AuditCreateTestsQuery">                        
         <mon:Content>
            <input type="hidden" name="ciHandle" value="<%= StringUtil.escapeHTML(request.getParameter("ciHandle")) %>"/>
            <mon:tableComponent id="testDefn" >
               <mon:title><fmt:message key="audit.createTests.table.title.txt" /></mon:title>
               <mon:fixedColumn width="10" title="<%= selColTitle %>">
                  <input type="checkbox" name="testDefHandle" value="<c:out value="${testDefn.taggedPointerHandle}" />" />
               </mon:fixedColumn>
            </mon:tableComponent>
            
            <script type="text/javascript">
               new CheckboxGroup("queryForm", "testDefHandle", "selectAll");
            </script>
         </mon:Content>   
         <mon:PopupButtonBar>
            <mon:Button name="createButton" onclick="doCreateTests()">
               <fmt:message key='audit.createTests.button.txt' />
            </mon:Button>
            
            <mon:Button name="closeButton" onclick="window.close()">
               <fmt:message key='closeButton.txt' />
            </mon:Button>
         </mon:PopupButtonBar>
      </html:form>      
   </mon:Body>
</mon:Page>
