<%@ page import="java.util.*" %>
<%@ page import="com.sas.oprisk.server.logical.*" %>
<%@ page import="com.sas.oprisk.monitor.web.table.*" %>
<%@ page import="com.sas.oprisk.monitor.web.controlTesting.testDefinitions.*" %>


<%@ include file="/tiles/taglibs.jsp" %>

<%
   final java.util.Locale locale = request.getLocale();
   final java.util.ResourceBundle bundle = ApplicationProperties.getBundle(locale);
   final PersistenceSession psession = MonitorContext.getPersistenceSession(request);
   
   boolean readOnly = true;
   User u = (User)psession.getUser();
   if( u.hasGlobalPermission(GlobalPermission.controlTesting, psession) )
	readOnly = false;	   
   
   String selColTitle = "<input type=\"checkbox\" name=\"selectAll\" title=\"" 
      + bundle.getString("application.selectAll.tooltip.txt") + "\" />";
      
   String selCtrlsColTitle = "<input type=\"checkbox\" name=\"selectAllCtrls\" title=\"" 
      + bundle.getString("application.selectAll.tooltip.txt") + "\" />";

final ControlsByRiskForm cbrForm = (ControlsByRiskForm) request.getAttribute("controlsByRiskForm");
final String exportRequest = request.getContextPath() + 
   "/ControlInstancesByRiskQuery.do?method=export" +
   "&handle=" + StringUtil.encodeURLValue(request.getParameter("tdHandle")) +
   "&" + cbrForm.asQueryParameters();
%>

<mon:Page template="popup">
   <mon:Head>
      <mon:include js="/script/checkboxRadioUtil.js" />

      <script type="text/javascript">
      
         parent.allowParentToClose = function() {
            // Since this was called from an onClose() event, start a timer that will
            // re-sync the currentDialog variable when the new window is loaded.
               this.window.setTimeout(resyncCurrentDialog, 1000);
         
            return false;
         }
      
         function resyncCurrentDialog() {
            if ((typeof(opener.currentDialog) != 'undefined') &&
                  (opener.currentDialog == null)) 
            {
                  opener.setModalDialog(window);
                  return;
            }
         
         // parent window isn't ready, wait for a bit and try again 
            this.window.setTimeout(resyncCurrentDialog, 1000);
      }
         //public
         function doAddSelections(bClose) {
            var selections = addAndContinue();     
            if (selections == null) {
               alert("<fmt:message key='AssessmentWizard.error.noSelections.txt'/>");
            } else {
               //invoke the parent's[TestDefinition] javascript method to add the selected controls in it's page.
               window.opener.addSelectedControls(selections);
               if (bClose) { 
                 window.close(); 
               }
            }
         }
         
         //private
         function addAndContinue() {
            //getSelectedCheckboxValues method defined in the checkboxRadioUtil.js
            var values = getSelectedCheckboxValues(document.forms[0], "controlHandle");
            return (values.length == 0) ? null : values;
         }
         
         
         function areaUpdated(handle) {      
            document.forms[0].submit();
            return false;
         }
      
      //
      // When a risk is selected/de-selected, we want to update the control instance table.
      //
      // But when he user hits selectAll, we only want to submit once
      //
      var updatingMultipleRiskInstances = false;
      
         function updateControlInstanceTable() {
            if ( ! updatingMultipleRiskInstances )
            {
               var values = getSelectedCheckboxValues(document.forms[0], "selectedRiskHandles");
               var selections = (values.length == 0) ? null : values;
               document.forms[0].submit();
            }
            return false;
         }
         
         //shows the Risk instance in a new popup window as readonly. The new window closes once "Done" viewing.
         function showRiskInstance(handle) {    
            openModal(
                  "<%= request.getContextPath() %>" 
                  + "/RiskInstance.do?method=select&handle="
                  + handle + "&readOnly=true&popup=true",
                  "controlInstancePopup", 
                  "width=650,height=450,scrollbars,resizable,status");
            }
         
         //shows the control instance in a new popup window as readonly. The new window closes once "Done" viewing.
         function showControlInstance(handle) {    
            openModal(
                  "<%= request.getContextPath() %>" 
                  + "/ControlInstance.do?method=select&handle="
                  + handle + "&readOnly=true&popup=true",
                  "controlInstancePopup", 
                  "width=650,height=450,scrollbars,resizable,status");
            }
      </script>
   </mon:Head>
   <mon:Body>      
      <html:form action="/ControlInstancesByRiskQuery">                        
         <mon:Content>
            <input type="hidden" name="tdHandle" value="<%= HTMLUtils.escapeHTML(request.getParameter("tdHandle")) %>"/>
             <!-- html:hidden property="selectedRiskHandles" /-->
             
             <mon:DimAreaChooser 
            property="areaHandle"
            rootVisible="true"   
            feature="Risk"        
            readOnly='<%= (readOnly) %>' 
            selectMethod="areaUpdated"
             />
             
             <br/>
         
             <mon:tableComponent entryName="risks" id="riskInstance" exportXlsUrl='<%= exportRequest + "&entryId=risks" %>' >
                <mon:title><fmt:message key="controlInstanceByRisk.section.risks.txt"/></mon:title>       
                <mon:fixedColumn width="10" title="<%= selColTitle %>">          
                  <html:multibox property="selectedRiskHandles">
                  <c:out value='${riskInstance.handleString}'/>
                  </html:multibox>
                </mon:fixedColumn>
             </mon:tableComponent>
             
             <script type="text/javascript">
             var cbg = new CheckboxGroup("controlsByRiskForm", "selectedRiskHandles", "selectAll");
             cbg.addOnChangeListener(updateControlInstanceTable);
             </script>
             
             <br/>
         
             <mon:tableComponent entryName="controls" id="controlInstance" exportXlsUrl='<%= exportRequest + "&entryId=controls" %>' >>
                <mon:title><fmt:message key="controlInstanceByRisk.section.controls.txt"/></mon:title>       
                <mon:fixedColumn width="10" title="<%= selCtrlsColTitle %>">
                  <input type="checkbox" name="controlHandle" value="<c:out value="${controlInstance.taggedPointerHandle}" />" />
                </mon:fixedColumn>
             </mon:tableComponent>
             
             <script type="text/javascript">
             new CheckboxGroup("controlsByRiskForm", "controlHandle", "selectAllCtrls");
             </script>            
         </mon:Content> 
         
         <mon:PopupButtonBar>
            <mon:Button name="addButton" onclick="doAddSelections(false)">
               <fmt:message key='application.button.add.txt' />
            </mon:Button>
            <mon:Button name="addAndCloseButton" onclick="doAddSelections(true)">
               <fmt:message key='application.button.addAndClose.txt' />
            </mon:Button>
            <mon:Button name="closeButton" onclick="window.close()">
               <fmt:message key='closeButton.txt' />
            </mon:Button>
         </mon:PopupButtonBar>  
      </html:form>      
   </mon:Body>
</mon:Page>
