<%@ page import="java.util.*" %>
<%@ page import="com.sas.oprisk.server.logical.*" %>
<%@ page import="com.sas.oprisk.monitor.web.table.*" %>
<%@ page import="com.sas.oprisk.monitor.web.controlTesting.testers.*" %>

<%@ include file="/tiles/taglibs.jsp" %>

<%
final java.util.Locale locale = request.getLocale();
final java.util.ResourceBundle bundle = ApplicationProperties.getBundle(locale);
final PersistenceSession psession = MonitorContext.getPersistenceSession(request);

final String exportUrl = request.getContextPath() + "/PotentialTestersQuery.do?method=export";
%>

<mon:Page template="popup">
   <mon:Head>
      <mon:include js="/script/checkboxRadioUtil.js" />

      <script type="text/javascript">
      
      parent.allowParentToClose = function() 
      {
        // Since this was called from an onClose() event, start a timer that will
        // re-sync the currentDialog variable when the new window is loaded.
        this.window.setTimeout(resyncCurrentDialog, 1000);
        return false;
      }
      
      function resyncCurrentDialog() 
      {
        if ((typeof(opener.currentDialog) != 'undefined') && (opener.currentDialog == null)) 
        {
          opener.setModalDialog(window);
          return;
        }
      
        // parent window isn't ready, wait for a bit and try again 
        this.window.setTimeout(resyncCurrentDialog, 1000);
      }
      
      <%------------------------------%>
      <%--    Expand/Collapse All   --%>   
      <%------------------------------%>     
      var sections = new Array();
      function registerSection(sectionId) {
      // window.alert("I am testing"+ sections.length);
         sections[sections.length] = sectionId;
      
      /*
       * I am invoking this function to make sure the table components are expanded.
         Bugs:S0640929,S0643074 
            
       */   
      
         expandCollapseAll(true);
      
         
      }
      function expandCollapseAll(expand) {
       //  window.alert("CollapseExpandAll"+expand);
         setVisible("collapseAll", expand);
         setVisible("expandAll", !expand);
        
         for(var i = 0; i < sections.length; i++) {
           setSectionExpanded(sections[i], expand);
         }
         setExpanded('reviewers_body', 'reviewers_body_toggle_img', expand);
      }
      <%------------------------------%>
      
      function doAddSelections(addAndClose) 
      {
        var selections = getSelectedUserHandles();
        if (selections == null) 
        {
          alert("<fmt:message key='AssessmentWizard.error.noSelections.txt'/>");
        } 
        else 
        {
          //invoke the parent's[ManageTestersAction] javascript method to add the selected users in it's page.
          window.opener.addSelectedUsers(selections);
          if (addAndClose) { 
            window.close(); 
          }
        }
      }
         
      function getSelectedUserHandles() 
      {
        // getSelectedCheckboxValues method defined in the checkboxRadioUtil.js
        var values = getSelectedCheckboxValues(document.forms[0], "userHandle");
        return (values.length == 0) ? null : values;
      }
      
      </script>
   </mon:Head>
   <mon:Body>      
      <html:form action="/PotentialTestersQuery">      
         
         <mon:Content>
             <input type="hidden" name="containerHandle" value="<%= StringUtil.escapeHTML(request.getParameter("containerHandle")) %>"/>

             <c:forEach items="${model.sections}" var="section">
         <%
            final PotentialTestersPageModel.Section s = 
               (PotentialTestersPageModel.Section) pageContext.findAttribute( "section" );
            final String sectionId = s.getId(); 
            final String expandedId = sectionId + "_expanded";
         %>
               <input type='hidden' name='<%= expandedId %>' value='true' />
               <mon:section id="<%= sectionId %>" expandedProperty="<%= expandedId %>">
                 <mon:title><c:out value="${section.name}"/></mon:title>
         
                 <c:forEach items="${section.tables}" var="xxx" varStatus="status">
         
                 <c:if test="${not status.first}"><br/></c:if>
         
         <%
            final PotentialTestersPageModel.Table t = 
               (PotentialTestersPageModel.Table) pageContext.findAttribute( "xxx" );
            // maybe put the s_ in the model
            final String entryId = t.getId(); 
         %>
                 <mon:tableComponent entryName="<%= entryId %>" id="user" exportXlsUrl='<%= exportUrl + "&entryId=" + entryId%>' >
                   <mon:title><fmt:message key="manageTesters.selectByUsers.txt"/></mon:title>  
         
                   <mon:fixedColumn width="10">
                     <input type='checkbox' name='userHandle' value='<c:out value="${user.handle}" />' />
                   </mon:fixedColumn>
         
                 </mon:tableComponent>        
                 </c:forEach>
         
             </mon:section>
             <br/>
             </c:forEach>
         
             <c:if test="${model.nothingToDisplay}">
             <p><fmt:message key='manageTesters.noQualifiedUsers.txt' /></p>
             </c:if>
         </mon:Content>   
         
         <mon:PopupButtonBar>
            <c:if test="${not model.nothingToDisplay}">
               <mon:Button name="add" onclick="doAddSelections(false)">
                  <fmt:message key='application.button.add.txt' />
               </mon:Button>
               <mon:Button name="addAndClose" onclick="doAddSelections(true)">
                  <fmt:message key='application.button.addAndClose.txt' />
               </mon:Button> 
            </c:if>
            <mon:Button name="close" onclick="window.close()">
               <fmt:message key='closeButton.txt' />
            </mon:Button>
         </mon:PopupButtonBar>
      </html:form>      
   </mon:Body>
</mon:Page>
