<%@ page import="java.util.*" %>
<%@ page import="com.sas.oprisk.monitor.web.dimension.*" %>
<%@ page import="com.sas.oprisk.server.logical.*" %>
<%@ page import="com.sas.oprisk.monitor.web.dimension.DimensionBrowserAction.LabelValueRelationBean" %>
<%@ page import="com.sas.oprisk.monitor.web.table.TableComponentTag" %>

<%@ include file="/tiles/taglibs.jsp" %>

<mon:setBundle />
<%    
   final PersistenceSession psession = MonitorContext.getPersistenceSession(request);
   final java.util.Locale locale = request.getLocale();
   java.util.ResourceBundle bundle = ApplicationProperties.getBundle(locale);
   final DimensionNodeModel model = (DimensionNodeModel)request.getAttribute("model");
   final String dimValue = model != null ? model.getNode().getDimension().getValue() : "";
   final DimensionalPoint scope = model != null ? model.getScope() : null;
   final String scopeHandle = scope != null ? scope.getHandleString() : "";
   final DimensionalArea deletableArea = DimRelationElement.object.areaWhereUserCan(Do.DELETE, psession);
   final DimensionalArea updatableArea = DimRelationElement.object.areaWhereUserCan(Do.UPDATE, psession);
   
   String delimiter = "<br/>";
   String pathSeparator = com.sas.oprisk.server.util.PathUtils.getPaddedPathSeparator();
   
   String busObjTypeName = BusinessObjectTypeInfo.DIM_RELATION_ELEMENT.getBusinessObjectTypeName(); 
   Map customFieldMap = CustomFieldDescriptorManager.getCustFieldDescriptorsMap(busObjTypeName);
   List allDimRelationElements = model != null
      ? model.getAllDimRelationElements() : Collections.EMPTY_LIST;
   Map nodeCustomFieldValueMap =
      TableComponentTag.getCustValuesForTablePage(allDimRelationElements, psession);
%>

<c:if test="${not empty model.relations or cpb_preview}">

<mon:include js="/script/checkboxRadioUtil.js" />

<script type="text/javascript">

function owner(dre, relation) {
   var f = document.forms.<c:out value="${model.formName}"/>;
   f.action = 'Dimension.do?method=viewOwnersModal'
         + '&dimRelationElement=' + dre
         + '&relation=' + relation;
   f.submit();
}

function addMapping(relation) {
   var f = document.forms.<c:out value="${model.formName}"/>;
   f.relation.value = relation;
   f.dimension.value = "";
   doDim('addMappingModal');
}

function removeSelectedMappings(relation) {
   var f = document.forms.<c:out value="${model.formName}"/>;
   var fieldName = "sm." + relation;
   if (!hasAnySelectedCheckboxes(f, fieldName)) {
      alert("<fmt:message key='DimensionRelations.mustSelectOne.txt'/>");
      return;
   }
   
   if (confirm("<fmt:message key='DimensionRelations.removeSelected.confirm.txt'/>")) {
      f.relation.value = relation;
      f.selProp.value = fieldName;
      doDim('removeSelectedMappings', 'mappings');
   }
}

</script>

<%-- these are needed by the mappings actions --%>
<input type="hidden" name="dimensionalPoint" value="<%= scopeHandle %>" />
<input type="hidden" name="relation" />
<input type="hidden" name="selProp" />

<div id="<%= dimValue + "_DimensionNodeMappings" %>">

<a name="mappings"></a>
<h2 style="margin-top: 1em;"><fmt:message key='DimensionRelations.title'/></h2>

<div id="<%= dimValue + "_InheritedMappings" %>">
   <c:if test="${not empty model}">
      <html:multibox onclick="doDimNode('view', 'mappings')"
        property="showInheritedMappings">true</html:multibox>&nbsp;
   </c:if>
   
   <!-- For preview purpose -->
   <c:if test="${cpb_preview}">
      <input type="checkbox" /> 
   </c:if>
   
   <fmt:message key="DimensionRelations.showInherited.txt"/>
</div>

<c:if test="${not empty model.relations}">
<div id="<%= dimValue + "_mappings" %>">
   <c:forEach var="relation" items="${model.relations}" varStatus="status">
<%
   final LabelValueRelationBean relation = (LabelValueRelationBean) pageContext.findAttribute("relation");
   final DimRelation dimRel = relation.getDimRelation();
   pageContext.setAttribute("mappings", model.getRelationMappings().get(relation.getValue()));
   final DimensionalPoint scopeDomain = scope.withDimensions(dimRel.getDomainDimensions(psession), psession);
%>
   <br />
   <mon:table class="displayTable" width="100%" cellspacing="0" name="pageScope.mappings" id="elt">
      <mon:title><c:out value="${relation.label}"/></mon:title>

      <c:if test="${model.canCreateMappings}">
         <% String href = "javascript:addMapping('" + StringUtil.escapeJSForHTMLAttribute(relation.getValue()) + "')"; %>
         <mon:action href='<%= href %>'>
            <fmt:message key='DimensionRelations.add.link.txt'/>
         </mon:action>&nbsp;|&nbsp;
      </c:if>
      
      <c:if test="${model.canDeleteMappings and not empty pageScope.mappings}">
         <% String href2 = "javascript:removeSelectedMappings('" + StringUtil.escapeJSForHTMLAttribute(relation.getValue()) + "')"; %>
         <mon:action href='<%= href2 %>'>
            <fmt:message key='DimensionRelations.removeSelected.title'/>
         </mon:action>
      </c:if>
<%
   if (elt != null)
   {
      final DimRelationElement dimRelElement = (DimRelationElement) elt;
      final boolean isExcluded = dimRelElement.isExcluded();
      final User owner = dimRelElement.getOwner(psession);
      final DimensionalPoint domain = dimRelElement.getDomain(psession);
      final DimensionalPoint legalDomain = dimRelElement.getDomainWithLegalDimsOnly(psession);
      final DimensionalPoint codomain = dimRelElement.getCodomain(psession);
      final DimensionalPoint drePoint = dimRelElement.getDimensionalPoint(psession);
      final Double relativeWeight = dimRelElement.getRelativeWeight();
      final String externalId = codomain.getExternalId();
      // can edit this dre?
      pageContext.setAttribute("canEditMappings", Boolean.valueOf(drePoint.isUnder(updatableArea)));
%>    
      <display:column width='20'>
<%
      if (isExcluded)
      {
%>         <img border="0" src="images/excludedMapping.gif"
                alt="<fmt:message key='application.excludedMapping.tooltip.txt'/>" 
                title="<fmt:message key='application.excludedMapping.tooltip.txt'/>"/>
<%
      }
      else if (drePoint.getHandleString().equals(scopeHandle) ||
               domain.getHandleString().equals(scopeHandle))
      {
         if (drePoint.isUnder(deletableArea))
         {
%>         <input type="checkbox" name="sm.<c:out value='${relation.value}'/>" 
                  value="<c:out value='${elt.handleString}'/>" />
<%
         }
         else
         {
%>         <img border="0" src="images/identifiedMapping.gif"
                alt="<fmt:message key='application.identifiedMapping.tooltip.txt'/>" 
                title="<fmt:message key='application.identifiedMapping.tooltip.txt'/>"/>
<%
         }
      }
      else if (!scopeDomain.getHandleString().equals(legalDomain.getHandleString()) &&
               scopeDomain.isUnder(legalDomain))
      { 
%>         <img border="0" src="images/inheritedMapping.gif"
                alt="<fmt:message key='application.inheritedMapping.tooltip.txt'/>" 
                title="<fmt:message key='application.inheritedMapping.tooltip.txt'/>"/>
<%
      }
%>
      </display:column>
      
      <!-- Display Relative Weight -->
      <display:column title='<%= bundle.getString("dimRelationElement.field.relativeWeight.displayName.txt") %>'>
         <%= (relativeWeight != null) ?  relativeWeight.toString() : "" %>
      </display:column>
      
      <!-- Display External Id -->
      <display:column title='<%= bundle.getString("application.id.txt") %>'>
         <%= (externalId != null) ?  StringUtil.escapeHTML(externalId) : "" %>
      </display:column>

      <!-- Domain / Dimensional Point -->
      <display:column title='<%= bundle.getString("dimRelationElement.field.dimensionalPoint.displayName.txt") %>'>
<%
      if (!(domain.getHandleString().equals(scopeHandle)))
      {
%>       
         <%= StringUtil.escapeHTML(domain.toLabeledStringWithPath(delimiter, pathSeparator, locale, psession), delimiter) %>
<%    }
      else
      {
         out.print(StringUtil.escapeHTML(domain.toLabeledStringWithPath(delimiter, pathSeparator, locale, psession), delimiter));
      }
%>    </display:column>
      
      <!-- Codomain / Name -->
      <display:column title='<%= bundle.getString("businessObjectLocalization.field.nameTxt.displayName.txt") %>'>
         <%= StringUtil.escapeHTML(codomain.toLabeledStringWithPath(delimiter, pathSeparator, locale, psession), delimiter) %>
      </display:column>
      
<%
         Iterator customFieldIter = customFieldMap.values().iterator();
         while (customFieldIter.hasNext())
         {
            FieldDescriptor fd = (FieldDescriptor)customFieldIter.next();
            String customFieldLabelKey =
               busObjTypeName + ".field." + fd.getName() + ".displayName.txt";
            String customFieldValue = "";
            if (nodeCustomFieldValueMap != null)
            {
               Object obj = TableComponentTag.getRawCustomFieldValue(
                  nodeCustomFieldValueMap, dimRelElement, fd, locale, false);
               if (obj != null)
                  customFieldValue = obj.toString();
            }
%>    
      <display:column title='<%= ApplicationProperties.getProperty(customFieldLabelKey, locale) %>'>
         <%= StringUtil.isEmpty(customFieldValue) ? "&nbsp;" : StringUtil.escapeHTML(customFieldValue) %>
      </display:column>
<%    
         }
%>
      
      <display:column title='<%= bundle.getString("ControlWizard.step.owner.txt") %>'>
<%
      if (owner != null)
      {
%>          
         <c:if test="${canEditMappings}">
            <a href="javascript:owner('<%= dimRelElement.getHandleString() %>', '<%= StringUtil.escapeJSForHTMLAttribute(relation.getValue()) %>')">
               <img border="0" align="absmiddle" src="images/user.png"/>&nbsp;</c:if><%= StringUtil.escapeHTML(owner.getFriendlyName(locale)) %><c:if test="${canEditMappings}">
            </a>
         </c:if>
<%
      }
      else
      {
%>
         <c:if test="${canEditMappings}">
            <a href="javascript:owner('<%= dimRelElement.getHandleString() %>', '<%= StringUtil.escapeJSForHTMLAttribute(relation.getValue()) %>')">
            <img border="0" align="absmiddle" src="images/adduser.png"/></a>
         </c:if>
<%
      }
%>
      </display:column>
<%
   }
%>
   </mon:table>
</c:forEach>
</div>
</c:if>
</div>
</c:if>
