<%@ include file="/tiles/taglibs.jsp" %>
<%@ page import="java.util.*" %>
<%@ page import="com.sas.oprisk.monitor.web.dimension.split.*" %>
<%@ page import="com.sas.oprisk.framework.server.util.DateTimeUtils" %>
<%@ page import="com.sas.oprisk.framework.server.objects.FieldDescriptor" %>
<%@ page import="com.sas.oprisk.server.ApplicationProperties" %>

<%    
   Locale locale = request.getLocale();
   ResourceBundle bundle = ApplicationProperties.getBundle(locale);
   PersistenceSession psession = MonitorContext.getPersistenceSession(request);

   final String selColTitle = 
      "<input type=\"checkbox\" name=\"selectAll\" title=\"" 
      + bundle.getString("application.selectAll.tooltip.txt") + "\" />";
   
%>

<mon:Page template="wizard">
   <mon:Head>
      <mon:include js="/script/checkboxRadioUtil.js" />
      <script type="text/javascript">
      
      function monitorInit() {
         initNSMenu();
      }
      
      </script>
   </mon:Head>
   <mon:Body>      
      <html:form action="/SplitWizard">      
         <mon:ToolBar/>
         
         <mon:Content>            
            <mon:maintainWizardState/>
            
            <input type="hidden" name="method" />
            <html:hidden property="handle" />
            
            <p>
            <fmt:message key="SplitWizard.childrenTab.table.title.txt" />
            </p>
            
            <mon:table width="100%" class="displayTable" cellspacing="0" name="requestScope.wizardState.childrenState.childEntries" id="child">
              
              <display:column width="2%" title="<%= selColTitle %>">
               <html:multibox property="childrenToMove"><c:out value='${child.handle}'/></html:multibox>
              </display:column>
            
              <display:column title='<%= bundle.getString("SplitWizard.field.name.displayName.txt") %>'><c:out value="${child.name}"/></display:column>
            
            </mon:table>
            
            <script type="text/javascript">
            new CheckboxGroup("splitWizardForm", "childrenToMove", "selectAll");
            </script>
            
            <%--
            
            Note the hack to get the check boxes to work correctly when all the boxes are unchecked.
            The hidden field below holds an empty value. If any values are checked,
            their values will be returned. If no boxes are checked, an empty string is returned. That
            prevents the wizard framework from stepping on the new (missing) value with the old value.
            
            --%>
            <input type="hidden" name="childrenToMove" value="" />
         </mon:Content>   
      </html:form>      
   </mon:Body>
</mon:Page>
