<%@ include file="/tiles/taglibs.jsp" %>
<%@ page import="java.util.*" %>
<%@ page import="com.sas.oprisk.monitor.web.dimension.split.*" %>

<%    
   Locale locale = request.getLocale();
   ResourceBundle bundle = ApplicationProperties.getBundle(locale);
   final SplitWizardState state = (SplitWizardState) request.getAttribute("wizardState");

   String context = request.getContextPath();
   //String addEventsURL = context + "/SplitWizard.do?handle=" + state.getSourceNodeHandle();
   String addEventsText = bundle.getString("SplitWizard.eventTab.eventTable.addEvents.txt");
   String removeEventsText = bundle.getString("SplitWizard.eventTab.eventTable.removeEvents.txt");
   
   final String selColTitle = 
      "<input type=\"checkbox\" name=\"selectAll\" title=\"" 
      + bundle.getString("application.selectAll.tooltip.txt") + "\" />";
   
%>

<mon:Page template="wizard">
   <mon:Head>
      <mon:include js="/script/checkboxRadioUtil.js" />
      <script type="text/javascript">
      
      function updateSelectedEntries(moveAll)
      {
        var entriesTable = document.getElementById('selectedEntries');
        if ( moveAll == 'true' ) {
          entriesTable.style.display='none';
        }
        else {
          entriesTable.style.display='block';
        }
      }
      </script>
   </mon:Head>
   <mon:Body>      
      <html:form action="/SplitWizard">      
         <mon:ToolBar/>
         
         <mon:Content>
            <input type="hidden" name="method" />
            <html:hidden property="handle" />
            
            <mon:maintainWizardState/>
            
            <p>
            <fmt:message key="SplitWizard.eventTab.options.txt" /><br />
            <html:radio property="moveAllEvents" value="true" onclick="updateSelectedEntries(this.value)" /><fmt:message key="SplitWizard.eventTab.all.option.txt" /><br />
            <html:radio property="moveAllEvents" value="false" onclick="updateSelectedEntries(this.value)" /><fmt:message key="SplitWizard.eventTab.selected.option.txt" />
            </p>
            
            <div id="selectedEntries">
            <p>
            <span class="requiredIndicator">&nbsp;&#42&nbsp;</span><fmt:message key='SplitWizard.ldc.objectIsLocked.warning.txt' />
            </p>
            
            <mon:table width="100%" scrollHeight="210px" class="displayTable" cellspacing="0" name="requestScope.wizardState.eventState.eventEntries" id="event">
              <mon:title><fmt:message key="SplitWizard.eventTab.eventTable.title.txt" /></mon:title>
              
              <mon:action href="javascript:goWizard('addEvents')"><%= addEventsText %></mon:action>
              <mon:action href="javascript:goWizard('removeEvents')"><%= removeEventsText %></mon:action>
            
              <display:setProperty name="basic.msg.empty_list" value='<%= bundle.getString("displayTable.empty.fmt.txt") %>' />
            
              <display:column width="1%" title="<%= selColTitle %>">
               <html:multibox property="removeEventHandles"><c:out value='${event.handle}'/></html:multibox>
               <input type='hidden' id='<c:out value="${event.handle}"/>' name="eventHandles" value='<c:out value="${event.handle}"/>' /> 
              </display:column>
            
              <display:column title="">
                <c:if test="${event.isLocked}" ><span class="requiredIndicator">&nbsp;&#42&nbsp;</span></c:if>
              </display:column>
            
              <display:column width="15%" 
                              title='<%= bundle.getString("opRiskEvent.field.referenceNo.displayName.txt") %>'><c:out value="${event.referenceNumber}"/></display:column>
            
              <display:column width="10%" 
                              title='<%= bundle.getString("opRiskEvent.field.sourceSystemCd.displayName.txt") %>'><c:out value="${event.sourceSystemCd}"/></display:column>
            
              <display:column width="15%" 
                              title='<%= bundle.getString("opRiskEvent.field.opRiskEventId.displayName.txt") %>'><c:out value="${event.externalId}"/></display:column>
            
              <display:column title='<%= bundle.getString("opRiskEvent.field.eventShortDesc.displayName.txt") %>'><c:out value="${event.name}"/></display:column>
            
            </mon:table>
            </div>
            
            <script type="text/javascript">
            new CheckboxGroup("splitWizardForm", "removeEventHandles", "selectAll");
            <c:choose>
             <c:when test='${requestScope.wizardState.eventState.moveAllEvents}'>
              updateSelectedEntries('true');
             </c:when>
             <c:otherwise>
              updateSelectedEntries('false');
             </c:otherwise>
            </c:choose>
            
            </script>
         </mon:Content>   
      </html:form>      
   </mon:Body>
</mon:Page>
