<%@ include file="/tiles/taglibs.jsp"%>
<%@ page import="com.sas.oprisk.monitor.web.incident.IncidentModel" %>
<%@ page import=" com.sas.oprisk.server.logical.DimensionalArea" %>
<%@ page import="com.sas.oprisk.monitor.web.incident.cellFormatter.WorkFlowStatusCellFormatter" %>
<%@ page import="java.util.*" %>
<%@ page import="com.sas.solutions.cpb.web.tag.field.FieldRenderer" %>
<%
   java.util.Locale locale = request.getLocale();
   final ResourceBundle bundle = ApplicationProperties.getBundle(locale);
   final PersistenceSession psession = MonitorContext.getPersistenceSession(request);
   LayoutDirection layoutDirection = LayoutDirection.getLayoutDirection(request);
   IncidentModel model = (IncidentModel)request.getAttribute("model");
   String handle = model.getHandle();
   Boolean canAddCause = (Boolean)request.getAttribute("canAddCause");
   
   String exportUrl = request.getContextPath() + "/IncidentWizardCausesQuery.do?opRiskEventHandle=" + handle + "&entryId=causeInstances";
   String exportUrlForEffectCauses = request.getContextPath() + "/IncidentWizardCausesQuery.do?opRiskEventHandle=" + handle + "&entryId=effectCauseInstances";
   
   MonitorContext mc = MonitorContext.getMonitorContext(request);
   java.util.Map formatters = new java.util.HashMap();
   formatters.put("validationStateCd", new WorkFlowStatusCellFormatter(mc));
   
   // 4.3 Hotfix 4, retaining delete confirmation if change reason is not required anymore.
   boolean changeReasonRequired = ConfigDataProperties.isChangeReasonRequired();
   String deleteConfirmMsg = model.getDeleteConfirmationMessage(psession);
%>
<mon:Page>
<%-- BEGIN PAGE --%>

   <mon:Head>
   <%-- BEGIN HEAD --%>
<script type="text/javascript">
function wizardInit() {
   // override wizardInit so that buttons are not disabled
}

function addCause() {
   var f = document.forms.incidentWizardForm;
   f.action =
     "<%= request.getContextPath() %>/IncidentWizard.do?method=createCause";
   f.submit();
}

function removeCause(handle) {
   var f = document.forms.incidentWizardForm;
   f.action =
     "<%= request.getContextPath() %>/IncidentWizard.do?method=removeCause&causeHandle=" + handle;
   f.submit();
}

function removeEffectCause(handle) {
   var f = document.forms.incidentWizardForm;
   f.action =
     "<%= request.getContextPath() %>/IncidentWizard.do?method=removeEffectCause&causeHandle=" + handle;
   f.submit();
}

function viewCause(handle) {
   var f = document.forms.incidentWizardForm;
   f.action =
     "<%= request.getContextPath() %>/IncidentWizard.do?method=editCause&causeHandle=" + handle;
   f.submit();
}

function viewEffectCause(handle) { 
   var f = document.forms.incidentWizardForm;
   f.action =
     "<%= request.getContextPath() %>/IncidentWizard.do?method=editEffectCause&causeHandle=" + handle;
   f.submit();
}
</script>
   <%-- END HEAD --%>
   </mon:Head>
   
   <mon:Body>
   <%-- BEGIN BODY --%>
      
      <html:form action="/IncidentWizard">
      
      <mon:ToolBar>
      <%-- BEGIN TOOL BAR --%>
      <%-- END TOOL BAR --%>
      </mon:ToolBar>
      
      <mon:Content>
      <%-- BEGIN CONTENT --%>
   <input type="hidden" name="eventHandle" value="<%= StringUtil.escapeHTML(handle) %>" />

   <html:hidden property="opRiskEventId" />
   <html:hidden property="opRiskEventRk" />
   <html:hidden property="referenceNo" />
   <html:hidden property="validationStateCd" />
   <html:hidden property="eventTypeCd" />
   <html:hidden property="handle" />
   <html:hidden property="activeFlg" />
   <html:hidden property="thresholdExceededMsg" />

      <script type="text/javascript">
          function confirmGoWizard(methodName, buttonName) {
            <% if (!changeReasonRequired) { %>
            if (methodName == 'delete'){
               return confirm(unescape("<%= deleteConfirmMsg %>"));
            }
            else {
               return true;
            }
            <% } else {%>
            return true;
            <% } %>
          }
      </script>
     
    <mon:maintainWizardState />
    
    <div id="incident_incidentCauses">
    <mon:tableComponent id="cause" entryName="causeInstances" exportXlsUrl="<%= exportUrl %>" wizCursor="causes" columnFormatters="<%= formatters %>" >
      <mon:title><fmt:message key="IncidentWizard.incident.causes.label.txt"/></mon:title>
      <c:if test="${ !requestScope.model.readOnly && requestScope.canAddCause && !model.isFullyAssigned }">
        <mon:action href="javascript:addCause();"><fmt:message key='opRiskEventForm.section.causes.add.txt' /></mon:action>
      </c:if>
      <c:if test="${!requestScope.model.readOnly && canDeleteCause}">
      <mon:fixedColumn width="1%" before="false" title='<%= bundle.getString("application.delete.txt") %>' >
            <a href="javascript:removeCause('<c:out value='${cause.handle}'/>')">
                    <img border="0" src="<fmt:message key='application.delete.image' />"  
              alt="<fmt:message key='application.delete.tooltip.txt'/>" 
              title="<fmt:message key='application.delete.tooltip.txt'/>"/>
      </mon:fixedColumn>
      </c:if>
   </mon:tableComponent>
   <c:if test="${hasInvisibleIncidentCauses}">
      <mon:InfoMessage><fmt:message key="incident.hasInvisibleItems.txt" /></mon:InfoMessage>
   </c:if>
    </div>
   <br/>
   
   <%-----------------------------------%>
   <%--   Total Assigned/Unassigned   --%>
   <%-----------------------------------%>   
   <div>
   <c:choose>
   <c:when test='${not model.totalAssignedUnAssignedConfidential}'>
      <table cellpadding="4" cellpadding="0" border="0">
         <tr valign="top">
            <td class="label">
               &nbsp;&nbsp;       
               <b><fmt:message key="incidentCause.totalAssigned.txt" />:</b>
            </td>
            <td align='<%=layoutDirection.getRight()%>'>
               <fmt:formatNumber type='PERCENT' maxFractionDigits='2' value='${model.causeTotalAssigned}' />
            </td>
         </tr>
         <tr valign="top">
            <td class="label">
               &nbsp;&nbsp;       
               <b><fmt:message key="incidentCause.totalUnassigned.txt" />:</b>
            </td>
            <td align='<%=layoutDirection.getRight()%>'>
               <fmt:formatNumber type='PERCENT' maxFractionDigits='2' value='${model.causeTotalUnassigned}' />
            </td>
         </tr>
      </table>
 </c:when>
 <c:otherwise>
   
    <table cellpadding="4" cellpadding="0" border="0">
      <tr valign="top">
         <td class="label">
            &nbsp;&nbsp;       
            <b><fmt:message key="incidentCause.totalAssigned.txt" />:</b>
         </td>
         <td align='<%=layoutDirection.getRight()%>'>
         <%=FieldRenderer.renderConfidentialField(request.getLocale()) %>
         </td>
      </tr>
      <tr valign="top">
         <td class="label">
            &nbsp;&nbsp;       
            <b><fmt:message key="incidentCause.totalUnassigned.txt" />:</b>
         </td>
         <td align='<%=layoutDirection.getRight()%>'>
          <%=FieldRenderer.renderConfidentialField(request.getLocale()) %>
         </td>
      </tr>
   </table>
   </c:otherwise>
 </c:choose>
   </div>

   <br/>
   <br/>
   <div id="incident_effectCauses">
   <mon:tableComponent id="cause" entryName="effectCauseInstances" exportXlsUrl="<%= exportUrlForEffectCauses %>" wizCursor="causes" columnFormatters="<%= formatters %>" >     
      <mon:title><fmt:message key="IncidentWizard.effect.causes.label.txt"/></mon:title>
       <c:if test="${!requestScope.model.readOnly && canDeleteCause}">
         <mon:fixedColumn width="1%" before="false" title='<%= bundle.getString("application.delete.txt") %>' >
               <a href="javascript:removeEffectCause('<c:out value='${cause.handle}'/>')">
                       <img border="0" src="<fmt:message key='application.delete.image' />"  
                 alt="<fmt:message key='application.delete.tooltip.txt'/>" 
                 title="<fmt:message key='application.delete.tooltip.txt'/>"/>
         </mon:fixedColumn>
         </c:if>
   </mon:tableComponent>
   <c:if test="${hasInvisibleEffectCauses}">
      <mon:InfoMessage><fmt:message key="incident.hasInvisibleItems.txt" /></mon:InfoMessage>
   </c:if>
   </div>
      <%-- END CONTENT --%>
      </mon:Content>
   
      </html:form>
      
   <%-- END BODY --%>
   </mon:Body>
   
<%-- END PAGE --%>
</mon:Page>