<%@ page import="java.util.*" %>
<%@ include file="/tiles/taglibs.jsp" %>
<%@ page import="com.sas.oprisk.monitor.web.MonitorContext" %>
<%@ page import="com.sas.oprisk.monitor.web.incident.IncidentModel" %>
<%@ page import="com.sas.oprisk.monitor.web.incident.forms.EffectFormEx" %>
<%@ page import="com.sas.oprisk.monitor.web.incident.cellFormatter.BaseAmountCellFormatter" %>
<%@ page import="com.sas.oprisk.monitor.web.incident.cellFormatter.CombineCurrencyAmountCellFormatter" %>
<%@ page import="com.sas.oprisk.monitor.web.incident.cellFormatter.WorkFlowStatusCellFormatter" %>
<%@ page import="com.sas.solutions.cpb.web.tag.field.FieldRenderer" %>
<%
   java.util.Locale locale = request.getLocale();
   java.util.ResourceBundle bundle = ApplicationProperties.getBundle(locale);
   MonitorContext mc = MonitorContext.getMonitorContext(request);
   final PersistenceSession psession = MonitorContext.getPersistenceSession(request);
   IncidentModel model = (IncidentModel)request.getAttribute("model");
   boolean canDeleteRecoveriesWithoutLosses = true;
   if (ConfigDataProperties.getRecoveriesWithoutLossesAllowed().equals(Boolean.FALSE) && 
         !model.getRecoveries(model.getOpRiskEvent(request), psession).isEmpty() &&
         model.getFinancialEffects(model.getOpRiskEvent(request), psession).size() <= 1) {
      canDeleteRecoveriesWithoutLosses = false;
   }

   boolean canCreateEffect = SecurityUtils.canDoSomewhere(Do.CREATE, FinancialImpact.object, psession);
   boolean canReadEffect   = SecurityUtils.canDoSomewhere(Do.READ, FinancialImpact.object, psession);
   boolean canLinkEffect   = SecurityUtils.canDoSomewhere(Do.LINK, FinancialImpact.object, psession);
   boolean canDeleteEffect   = SecurityUtils.canDoSomewhere(Do.DELETE, FinancialImpact.object, psession) &&
               canDeleteRecoveriesWithoutLosses;
   

   String handle = model.getHandle();
   final User currentUser = (User) psession.getUser();
   
   
   java.util.Map formatters = new java.util.HashMap();
   formatters.put("displayBaseEffectAmount", new BaseAmountCellFormatter(mc));
   formatters.put("displayEffectAmount", new CombineCurrencyAmountCellFormatter(mc));
   formatters.put("validationStateCd", new WorkFlowStatusCellFormatter(mc));
   
   String exportDirectUrl = request.getContextPath() + "/IncidentWizardEffectsQuery.do?opRiskEventHandle=" + handle + "&entryId=effects";
   String exportIndirectUrl = request.getContextPath() + "/IncidentWizardEffectsQuery.do?opRiskEventHandle=" + handle + "&entryId=nonFinancialImpactForms";
   
   // 4.3 Hotfix 4, retaining delete confirmation if change reason is not required anymore.
   boolean changeReasonRequired = ConfigDataProperties.isChangeReasonRequired();
   String deleteConfirmMsg = model.getDeleteConfirmationMessage(psession);
%>
<mon:Page>

   <mon:Head>
   
<script type="text/javascript">
function wizardInit() {
   // override wizardInit so that buttons are not disabled
}

<%-- forward to specified page --%>
function forward(path) {
   goWizard("forward&path=" + escape(path));
}

function doEffect(path) {
   path += "&immediateSave=false";
   forward(path);
}

function addFinancialEffect() {
    document.forms.<c:out value="${model.formName}" />.action = 
       "<%= request.getContextPath()+'/' %>"
         + "IncidentWizard.do?method=createFinancialEffect"
         + "&opRiskEventHandle=" + "<%= StringUtil.encodeURLValue(handle) %>";
    document.forms.<c:out value="${model.formName}" />.submit();
}

function linkToEffect() {
   openModal("<%= request.getContextPath() %>/LinkToEffectQuery.do?"
            + "opRiskEventHandle=" + "<%= StringUtil.encodeURLValue(handle) %>"
         + "&immediateSave=false",
      "subs_popup", "width=1100,height=500,scrollbars,resizable");
}

function editFinancialEffect( handle ) {
    document.forms.<c:out value="${model.formName}" />.action = 
       "<%= request.getContextPath()+'/' %>"
         + "IncidentWizard.do?method=editFinancialEffect"
         + "&opRiskEventHandle=" + "<%= StringUtil.encodeURLValue(handle) %>"
         + "&financialImpactHandle=" + handle;
    document.forms.<c:out value="${model.formName}" />.submit();
}

function removeFinancialEffect( handle ) {
    document.forms.<c:out value="${model.formName}" />.action = 
       "<%= request.getContextPath()+'/' %>"
         + "IncidentWizard.do?method=removeFinancialEffect"
         + "&opRiskEventHandle=" + "<%= StringUtil.encodeURLValue(handle) %>"
         + "&financialImpactHandle=" + handle;
    document.forms.<c:out value="${model.formName}" />.submit();
}

function addIndirectEffect() {
   action = "<%= request.getContextPath()+'/' %>"
        + "IncidentWizard.do?method=createIndirectEffectToLink&opRiskEventHandle=" 
        + "<%= StringUtil.encodeURLValue(handle) %>";
   document.forms.<c:out value="${model.formName}" />.action = action;
   document.forms.<c:out value="${model.formName}" />.submit();
}

function editIndirectEffect( nonFinancialImpactHandle ) {
    document.forms.<c:out value="${model.formName}" />.action = 
       "<%= request.getContextPath()+'/' %>"
         + "IncidentWizard.do?method=editIndirectEffect"
         + "&opRiskEventHandle=" + "<%= StringUtil.encodeURLValue(handle) %>"
         + "&nonFinancialImpactHandle=" + nonFinancialImpactHandle;
    document.forms.<c:out value="${model.formName}" />.submit();
}

function removeIndirectEffect( nonFinancialImpactHandle ) {
    document.forms.<c:out value="${model.formName}" />.action = 
       "<%= request.getContextPath()+'/' %>"
         + "IncidentWizard.do?method=removeIndirectEffect"
         + "&opRiskEventHandle=" + "<%= StringUtil.encodeURLValue(handle) %>"
         + "&nonFinancialImpactHandle=" + nonFinancialImpactHandle;
    document.forms.<c:out value="${model.formName}" />.submit();
}

</script>

   </mon:Head>
   
   <mon:Body>
   
      <html:form action="/IncidentWizard" >
      
      <mon:ToolBar />
      
      <mon:Content>

   <html:hidden property="opRiskEventId" />
   <html:hidden property="opRiskEventRk" />
   <html:hidden property="referenceNo" />
   <html:hidden property="validationStateCd" />
   <html:hidden property="eventTypeCd" />
   <html:hidden property="handle" />
   <html:hidden property="activeFlg" />
   <html:hidden property="thresholdExceededMsg" />
   
      <script type="text/javascript">
          function confirmGoWizard(methodName, buttonName) {
            <% if (!changeReasonRequired) { %>
            if (methodName == 'delete'){
               return confirm(unescape("<%= deleteConfirmMsg %>"));
            }
            else {
               return true;
            }
            <% } else {%>
            return true;
            <% } %>
          }
      </script>
  
   <mon:maintainWizardState/>

   <%------------------------------%>
   <%--      Direct Effects      --%>
   <%------------------------------%>
   
   <mon:tableComponent id="effect" entryName="effects" exportXlsUrl="<%= exportDirectUrl %>" wizCursor="effects" columnFormatters="<%= formatters %>" >
      <mon:title><fmt:message key="incident.investigate.directEffects.displayName.txt"/></mon:title>
      <c:if test="${not readOnly}">
         <% if (canCreateEffect) { %>
            <mon:action href="javascript:addFinancialEffect();">
               <fmt:message key='incident.effect.createDirectEffect.txt' />
            </mon:action>
         <% } %>
         <% if (canReadEffect) { %>
               <mon:action href="javascript:linkToEffect();">
                  <fmt:message key='application.link.txt' />
               </mon:action>
         <% } %>
      </c:if>
      <c:if test="${! requestScope.model.readOnly}">
      <% if (canDeleteEffect) { %>
         <mon:fixedColumn width="1%" before="false" title='<%= bundle.getString("application.remove.txt") %>' >
          <a href="javascript:removeFinancialEffect('<c:out value='${effect.handle}'/>')">
             <img border="0" src="<fmt:message key='application.remove.image' />"  
        alt="<fmt:message key='application.remove.tooltip.txt'/>" 
        title="<fmt:message key='application.remove.tooltip.txt'/>"/>
         </mon:fixedColumn>
      <% } %>
      </c:if>
   </mon:tableComponent>
   <c:if test="${hasInvisibleFinancialEffects}">
      <mon:InfoMessage><fmt:message key="incident.hasInvisibleItems.txt" /></mon:InfoMessage>
   </c:if>

   <br/>
   
   <%------------------------------%>
   <%--   Total Direct Effects   --%>
   <%------------------------------%>   
   <div>
   <table cellpadding="4" cellpadding="0" border="0">
      <c:if test="${not model.isNearMissIncident}">
      <tr valign="top">
         <td class="label">
            &nbsp;&nbsp;       
            <b><fmt:message key="${breakdown.labels['totalDirectEffects']}" />:</b>
         </td>
         
          <c:choose>
              <c:when test="${!breakdown.grossLossConfidential}">
               <td>
                     <c:out value="${model.baseCurrencyCd}" />
               </td>
               <td>
                     <c:out value="${breakdown.grossLossInBaseCurrencyAmt}" />
               </td>
               
             </c:when>
             <c:otherwise>
                 <td>
               <%=FieldRenderer.renderConfidentialField(request.getLocale()) %>
                 </td>
                  <td>
               
                 </td>
                
             </c:otherwise>
         </c:choose>
         
        
      </tr>
      </c:if>
      
      <c:if test="${breakdown.isNearMissInEffect or model.isNearMissIncident}">
      <tr valign="top">
         <td class="label">
            &nbsp;&nbsp;       
            <b><fmt:message key="${breakdown.labels['totalNearMissDirectEffects']}" />:</b>
         </td>
          <c:choose>
              <c:when test="${!breakdown.grossNearMissConfidential}">
         <td>
                  <c:out value="${model.baseCurrencyCd}" />
               </td>
               <td>
                  <c:out value="${breakdown.grossNearMissInBaseCurrencyAmt}" />
               </td>
             </c:when>
             <c:otherwise>
                 <td>
               <%=FieldRenderer.renderConfidentialField(request.getLocale()) %>
                 </td>
                  <td>
               
                 </td>
             </c:otherwise>
         </c:choose>
        
      </tr>
      </c:if>
   </table>
   </div>

   <br/>
   <br/>
   

   <%------------------------------%>
   <%--    Indirect Effects      --%>
   <%------------------------------%>
   <mon:tableComponent id="ie" entryName="nonFinancialImpactForms" exportXlsUrl="<%= exportIndirectUrl %>" wizCursor="effects" columnFormatters="<%= formatters %>" >
      <mon:title><fmt:message key="incident.investigate.indirectEffects.displayName.txt"/></mon:title>
      <c:if test="${not readOnly}">
      <mon:action href="javascript:addIndirectEffect();">
         <fmt:message key='incident.investigate.addIndirectEffect.txt' />
      </mon:action>
      </c:if>
      <c:if test="${! requestScope.model.readOnly}">
      <mon:fixedColumn width="1%" before="false" title='<%= bundle.getString("application.delete.txt") %>' >
          <a href="javascript:removeIndirectEffect('<c:out value='${ie.handle}'/>')">
             <img border="0" src="<fmt:message key='application.delete.image' />"  
        alt="<fmt:message key='application.delete.tooltip.txt'/>" 
        title="<fmt:message key='application.delete.tooltip.txt'/>"/>
      </mon:fixedColumn>
      </c:if>
   </mon:tableComponent>
   
      </mon:Content>
   
      </html:form>
      
   </mon:Body>
   
</mon:Page>
