<%@ include file="/tiles/taglibs.jsp" %>
<%@ page import="com.sas.oprisk.monitor.web.opriskevent.actions.EventFormPageModel" %>
<%@ page import="com.sas.oprisk.monitor.web.incident.IncidentModel" %>
<%@ page import="com.sas.oprisk.monitor.web.incident.forms.IncidentRecoveryForm" %>
<%@ page import="com.sas.oprisk.monitor.web.incident.cellFormatter.BaseAmountCellFormatter" %>
<%@ page import="com.sas.oprisk.monitor.web.incident.cellFormatter.WorkFlowStatusCellFormatter" %>
<%@ page import="com.sas.oprisk.monitor.web.incident.cellFormatter.CombineCurrencyAmountCellFormatter" %>
<%@ page import="com.sas.solutions.cpb.web.tag.field.FieldRenderer" %>
<%@ page import="com.sas.oprisk.server.ConfigDataProperties" %>
<%    
   java.util.Locale locale = request.getLocale();
   java.util.ResourceBundle bundle = ApplicationProperties.getBundle(locale);
   MonitorContext mc = MonitorContext.getMonitorContext(request);
   final PersistenceSession psession = MonitorContext.getPersistenceSession(request);
   LayoutDirection layoutDirection = LayoutDirection.getLayoutDirection(request);
   IncidentModel model = (IncidentModel)request.getAttribute("model");

   boolean canCreateRecovery = SecurityUtils.canDoSomewhere(Do.CREATE, FinancialImpact.object, psession);
   boolean canReadRecovery   = SecurityUtils.canDoSomewhere(Do.READ, FinancialImpact.object, psession);
   boolean canDeleteRecovery   = SecurityUtils.canDoSomewhere(Do.DELETE, FinancialImpact.object, psession);
   boolean canAddRecoveriesWithoutLosses = true;
  

   String handle = "";
   if (model == null){
       handle = request.getParameter("opRiskEventHandle");
       final MonitorSession ms = MonitorSession.getMonitorSession(request);
       model = (IncidentModel)ms.getCachedPageModel(handle);
   }
   else {
       handle = model.getHandle();
       if (model.getIsNearMissIncident().booleanValue()) {
          canCreateRecovery = false;
          canReadRecovery   = false;
       }
   }  
   
   if (ConfigDataProperties.getRecoveriesWithoutLossesAllowed().equals(Boolean.FALSE) && model.getFinancialEffects(model.getOpRiskEvent(request), psession).isEmpty()) {
   	canAddRecoveriesWithoutLosses = false;
   }
   final User currentUser = (User) psession.getUser();
   String baseLossAmt = bundle.getString("financialImpactForm.section.recoveryAmount.txt") + " (" + model.getBaseCurrencyCd() + ")";
   
   java.util.Map formatters = new java.util.HashMap();
   formatters.put("recoveryAmt", new CombineCurrencyAmountCellFormatter(mc));
   formatters.put("baseRecoveryAmt", new BaseAmountCellFormatter(mc));
   formatters.put("validationStateCd", new WorkFlowStatusCellFormatter(mc));
   
   String exportDirectUrl = request.getContextPath() + "/IncidentWizardRecoveryQuery.do?opRiskEventHandle=" + StringUtil.encodeURLValue(handle) + "&entryId=directRecoveries";
   String exportInsuranceUrl = request.getContextPath() + "/IncidentWizardRecoveryQuery.do?opRiskEventHandle=" + StringUtil.encodeURLValue(handle) + "&entryId=insuranceRecoveries";
   
   // 4.3 Hotfix 4, retaining delete confirmation if change reason is not required anymore.
   boolean changeReasonRequired = ConfigDataProperties.isChangeReasonRequired();
   String deleteConfirmMsg = model.getDeleteConfirmationMessage(psession);
%>
<mon:Page>

   <mon:Head>

<script type="text/javascript">

function wizardInit() {
   // override wizardInit so that buttons are not disabled
}

<%-- forward to specified page --%>
function forward(path) {
   goWizard("forward&path=" + escape(path));
}

function doRecovery(path) {
   path += "&immediateSave=false";
   forward(path);
}

function addDirectRecovery() {
   action = "<%= request.getContextPath()+'/' %>"
        + "IncidentWizard.do?method=createDirectRecovery&opRiskEventHandle=" 
        + "<%= StringUtil.encodeURLValue(handle) %>";
   document.forms.<c:out value="${model.formName}" />.action = action;
   document.forms.<c:out value="${model.formName}" />.submit();
}

function addInsuranceRecovery() {
   action = "<%= request.getContextPath()+'/' %>"
   + "IncidentWizard.do?method=createInsuranceRecovery&opRiskEventHandle=" 
   + "<%= StringUtil.encodeURLValue(handle) %>";
   document.forms.<c:out value="${model.formName}" />.action = action;
   document.forms.<c:out value="${model.formName}" />.submit();
}


function linkToRecovery() {
   openModal("<%= request.getContextPath() %>/LinkToRecoveryQuery.do?"
            + "opRiskEventHandle=" + "<%= StringUtil.encodeURLValue(handle) %>"
         + "&immediateSave=false",
      "subs_popup", "width=1100,height=500,scrollbars,resizable");
}

function linkToDirectRecovery() {
   openModal("<%= request.getContextPath() %>/LinkToDirectRecoveryQuery.do?"
            + "opRiskEventHandle=" + "<%= StringUtil.encodeURLValue(handle) %>"
         + "&immediateSave=false",
      "subs_popup", "width=1100,height=500,scrollbars,resizable");
}


function editDirectRecovery( financialImpactHandle ) {
    document.forms.<c:out value="${model.formName}" />.action = 
       "<%= request.getContextPath()+'/' %>"
         + "IncidentWizard.do?method=editDirectRecovery"
         + "&opRiskEventHandle=" + "<%= StringUtil.encodeURLValue(handle) %>"
         + "&financialImpactHandle=" + encodeURIComponent(financialImpactHandle);
    document.forms.<c:out value="${model.formName}" />.submit();
}

function editInsuranceRecovery( financialImpactHandle ) {
    document.forms.<c:out value="${model.formName}" />.action = 
       "<%= request.getContextPath()+'/' %>"
         + "IncidentWizard.do?method=editInsuranceRecovery"
         + "&opRiskEventHandle=" + "<%= StringUtil.encodeURLValue(handle) %>"
         + "&financialImpactHandle=" + encodeURIComponent(financialImpactHandle);
    document.forms.<c:out value="${model.formName}" />.submit();
}


function removeRecovery(method, financialImpactHandle) {
    document.forms.<c:out value="${model.formName}" />.action = 
       "<%= request.getContextPath()+'/' %>"
         + "IncidentWizard.do?method=" + method
         + "&opRiskEventHandle=" + "<%= StringUtil.encodeURLValue(handle) %>"
         + "&financialImpactHandle=" + encodeURIComponent(financialImpactHandle);
    document.forms.<c:out value="${model.formName}" />.submit();
}

</script>

<style type="text/css">

tr.row td.label {
  float: <%=layoutDirection.getLeft()%>;
  text-align: <%=layoutDirection.getLeft()%>;
  margin-<%=layoutDirection.getRight()%>:10px;
}
tr.row td.formw {
  float: <%=layoutDirection.getRight()%>;
  text-align: <%=layoutDirection.getRight()%>;
  font-weight: bold;
} 
</style>
      
   </mon:Head>
   
   <mon:Body>
   
      <html:form action="/IncidentWizard" >
      
      <mon:ToolBar>

      </mon:ToolBar>
      
      <mon:Content>
   
   <html:hidden property="opRiskEventId" />
   <html:hidden property="opRiskEventRk" />
   <html:hidden property="referenceNo" />
   <html:hidden property="validationStateCd" />
   <html:hidden property="eventTypeCd" />
   <html:hidden property="handle" />
   <html:hidden property="activeFlg" />
   <html:hidden property="thresholdExceededMsg" />
   
      <script type="text/javascript">
          function confirmGoWizard(methodName, buttonName) {
            <% if (!changeReasonRequired) { %>
            if (methodName == 'delete'){
               return confirm(unescape("<%= deleteConfirmMsg %>"));
            }
            else {
               return true;
            }
            <% } else {%>
            return true;
            <% } %>
          }
      </script>
  
   <mon:maintainWizardState/>

   <mon:tableComponent id="recovery" entryName="directRecoveries" exportXlsUrl="<%= exportDirectUrl %>" wizCursor="recoveries" columnFormatters="<%= formatters %>" >
      <mon:title><fmt:message key="IncidentWizard.directRecoveries.label.txt"/></mon:title>
      <c:if test="${not readOnly}">
         <% if (canCreateRecovery && canAddRecoveriesWithoutLosses) { %>
           <mon:action href="javascript:addDirectRecovery();"><fmt:message key='application.create.txt'/></mon:action>
         <% } %>
         <% if (canReadRecovery && canAddRecoveriesWithoutLosses) { %>
            <mon:action href="javascript:linkToDirectRecovery();"><fmt:message key='application.link.txt' /></mon:action>
         <% } %>
      </c:if>


      <c:if test="${! requestScope.model.readOnly}">
      <% if (canDeleteRecovery) { %>
        <mon:fixedColumn before="false" title='<%= bundle.getString("application.remove.txt") %>' width="1%">
           <a href="javascript:removeRecovery('removeDirectRecovery', '<c:out value='${recovery.handle}'/>')">
             <img border="0" src="<fmt:message key='application.remove.image' />"  
            alt="<fmt:message key='application.remove.tooltip.txt'/>" 
            title="<fmt:message key='application.remove.tooltip.txt'/>"/>
           </a>
         </mon:fixedColumn>
      <% } %>
      </c:if>
   </mon:tableComponent>
   <c:if test="${hasInvisibleDirectRecoveries}">
      <mon:InfoMessage><fmt:message key="incident.hasInvisibleItems.txt" /></mon:InfoMessage>
   </c:if>
   
   <br/>

   <mon:tableComponent id="recovery" entryName="insuranceRecoveries" exportXlsUrl="<%= exportInsuranceUrl %>" wizCursor="recoveries" columnFormatters="<%= formatters %>" >
      <mon:title><fmt:message key="IncidentWizard.insuranceRecoveries.label.txt"/></mon:title>
      <c:if test="${not readOnly}">
         <% if (canCreateRecovery && canAddRecoveriesWithoutLosses) { %>
           <mon:action href="javascript:addInsuranceRecovery();"><fmt:message key='application.create.txt'/></mon:action>
         <% } %>
         <% if (canReadRecovery && canAddRecoveriesWithoutLosses) { %>
            <mon:action href="javascript:linkToRecovery();"><fmt:message key='application.link.txt' /></mon:action>
         <% } %>
      </c:if>


      <c:if test="${! requestScope.model.readOnly}">
      <% if (canDeleteRecovery) { %>
        <mon:fixedColumn before="false" title='<%= bundle.getString("application.remove.txt") %>' width="1%">
           <a href="javascript:removeRecovery('removeInsuranceRecovery', '<c:out value='${recovery.handle}'/>')">
             <img border="0" src="<fmt:message key='application.remove.image' />"  
            alt="<fmt:message key='application.remove.tooltip.txt'/>" 
            title="<fmt:message key='application.remove.tooltip.txt'/>"/>
           </a>
         </mon:fixedColumn>
      <% } %>
      </c:if>
   </mon:tableComponent>
   <c:if test="${hasInvisibleInsuranceRecoveries}">
      <mon:InfoMessage><fmt:message key="incident.hasInvisibleItems.txt" /></mon:InfoMessage>
   </c:if>

   <br/>

   <table width="40%">
   <tr valign="top" id="nonInsuranceCoverageAmount" class="tableevenrow">
 
         <td class="label">
            <b><fmt:message key="IncidentWizard.totalDirectRecoveries.label.txt" /></b>:
         </td>
  <c:choose>
      <c:when test="${!model.nonInsuranceCoverageAmountConfidential}">    
         <td>
            <c:out value="${model.baseCurrencyCd}" />
         </td>
         <td class="formw" align="<%=layoutDirection.getRight()%>">
            <c:out value="${breakdown.directRecoveriesInBaseCurrencyAmt}" />
         </td>
   </c:when>
         <c:otherwise>
         <td>
            
         </td>
         <td class="formw" align="<%=layoutDirection.getRight()%>">
               <%=FieldRenderer.renderConfidentialField(request.getLocale()) %>
         </td>
    </c:otherwise>
  </c:choose>
   </tr>
   
    <tr valign="top" id="insuranceRecoveryAmount" class="tableevenrow">
    
    
      <td class="label">
         <b><fmt:message key="IncidentWizard.totalInsuranceRecoveries.label.txt" /></b>:
      </td>
   <c:choose>
      <c:when test="${!model.insuranceCoverageAmountConfidential}">
      <td>
         <c:out value="${model.baseCurrencyCd}" />
      </td>
      <td class="formw" align="<%=layoutDirection.getRight()%>">
         <c:out value="${breakdown.insuranceRecoveriesInBaseCurrencyAmt}" />
      </td>
      </c:when>
      <c:otherwise>
      
      <td>
         
      </td>
      <td class="formw" align="<%=layoutDirection.getRight()%>">
         <%=FieldRenderer.renderConfidentialField(request.getLocale()) %>
      </td>
       </c:otherwise>
  </c:choose>
    </tr>
   
    <tr valign="top" id="totalRecoveryAmount" class="tableoddrow">
    
         <td class="label">
            <b><fmt:message key="opRiskEvent.field.totalRecoveryAmount.displayName.txt" /></b>:
         </td>
     <c:choose>
      <c:when test="${!(model.insuranceCoverageAmountConfidential || model.nonInsuranceCoverageAmountConfidential) }">
         <td>
            <c:out value="${model.baseCurrencyCd}" />
         </td>
         <td class="formw" align="<%=layoutDirection.getRight()%>">
            <c:out value="${breakdown.totalRecoveriesInBaseCurrencyAmt}" />
         </td>
     </c:when>   
     <c:otherwise>
         <td>
            
         </td>
         <td class="formw" align="<%=layoutDirection.getRight()%>">
                 <%=FieldRenderer.renderConfidentialField(request.getLocale()) %>
         </td>
      </c:otherwise>
  </c:choose>
    </tr>
    </table>
      </mon:Content>
   
      </html:form>
      
   </mon:Body>
   
</mon:Page>