<%@ page import="java.util.*" %>
<%@ page import="java.io.*" %>
<%@ page import="java.text.MessageFormat" %>
<%@ page import="com.sas.oprisk.server.*" %>
<%@ page import="com.sas.solutions.cpb.runtime.*" %>
<%@ page import="com.sas.solutions.cpb.screendefs.*" %>
<%@ page import="com.sas.solutions.cpb.screendefs.xml.validator.*" %>
<%@ page import="com.sas.oprisk.monitor.web.cpb.runtime.*" %>
<%@ page import="org.apache.struts.util.LabelValueBean" %>
<%@ page import="com.sas.oprisk.monitor.web.opriskevent.actions.EventFormPageModel" %>
<%@ page import="com.sas.oprisk.server.ApplicationProperties" %>
<%@ page import="com.sas.oprisk.monitor.web.incident.IncidentModel" %>
<%@ page import="com.sas.solutions.cpb.web.tag.field.FieldRenderer" %>
<%@ page import="com.sas.oprisk.framework.server.util.ParsingUtils" %>

<%@ include file="/tiles/taglibs.jsp" %>
<%
   final Locale locale = request.getLocale();
   final ResourceBundle bundle = ApplicationProperties.getBundle(locale);
   final PersistenceSession psession = MonitorContext.getPersistenceSession(request);
   final EventFormPageModel model = (EventFormPageModel)request.getAttribute("model");
   boolean readOnly = Boolean.TRUE.equals(request.getAttribute("readOnly"));

   // overwrite
   String doneAsClose = request.getParameter("doneAsClose");
   if (doneAsClose != null && doneAsClose.equals("true")) readOnly = true;
   final String template = request.getAttribute("template") != null
      ? (String) request.getAttribute("template")
      : "wizard";
      
      
   // 4.3 Hotfix 4, retaining delete confirmation if change reason is not required anymore.
   boolean changeReasonRequired = ConfigDataProperties.isChangeReasonRequired();
   String deleteConfirmMsg = model.getDeleteConfirmationMessage(psession);
%>

<mon:Page template="<%= template %>">

<mon:Head>

   <mon:include js="/script/checkboxRadioUtil.js" />
   
   <script type="text/javascript">
   function wizardInit() {
      // override wizardInit so that buttons are not disabled
   }
   
   function doIncident(method, anchor) {
      var f = document.forms[0];
      f.action = "<%= request.getContextPath() %>/IncidentWizard.do"
         + "?method=" + method;
         
      if (anchor) {
         f.action = f.action + "#" + anchor;
      }
         
      f.submit();
   }
   
   function forward(path, refreshMethod, anchor) {
      var method = "forward" + "&path=" + escape(path);
      if (refreshMethod) {
         method += "&rm=" + refreshMethod;
      }
      doIncident(method, anchor);
   }
   
   function submitToAction(action) {
     var f = document.forms[0];
     f.action = action;
     f.submit();
   }
   
   function go(action,extraParams) {
     var url = "<%= request.getContextPath() %>/IncidentWizard.do?method=" + action;
     if (extraParams != null) url = url + "&" + extraParams;
     submitToAction( url );
   }
   
   function forward(path, anchor) {
     path = escape(path);
     if (anchor && (anchor != "")) {
       path += "#" + anchor;
     }
     go('forward', 'path=' + path );
   }
   
   addLoadEvent(setFocus);
   
   </script>

</mon:Head>

<mon:Body>
   
   <html:form action="/IncidentWizard" >
   
   <mon:ToolBar>
      <c:if test="${not empty template}" >
         <mon:Button name="actionButton" onclick="javascript:window.close()">
            <fmt:message key='application.button.done.txt' />
         </mon:Button>
      </c:if>
   </mon:ToolBar>
   
   <mon:Content>
      
      <html:hidden property="opRiskEventId" />
      <html:hidden property="opRiskEventRk" />
      <html:hidden property="referenceNo" />
      <html:hidden property="validationStateCd" />
      <html:hidden property="eventTypeCd" />
      <html:hidden property="handle" />
      <html:hidden property="activeFlg" />
      <html:hidden property="thresholdExceededMsg" />
      <html:hidden property="newEdit" />
      
      <script type="text/javascript">
          function confirmGoWizard(methodName, buttonName) {
            <% if (!changeReasonRequired) { %>
            if (methodName == 'delete'){
               return confirm(unescape("<%= deleteConfirmMsg %>"));
            }
            else {
               return true;
            }
            <% } else {%>
            return true;
            <% } %>
          }
      </script>
   
      <%-- render the screen --%>
      <cpb:screen screenID="incidentEvent" readOnly="<%= readOnly %>" />
      
      <mon:maintainWizardState/>
   
   </mon:Content>
   
   </html:form>
   
</mon:Body>

</mon:Page>