<%@ page import="java.io.*" %>
<%@ page import="java.util.*" %>
<%@ page import="com.sas.oprisk.monitor.web.*" %>
<%@ page import="com.sas.oprisk.monitor.web.utils.*" %>
<%@ page import="com.sas.framework.themes.client.Image" %>

<%@ page errorPage="pageError.jsp" %>

<%@ include file="/tiles/taglibs.jsp" %>
<mon:setBundle />
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<!--**************************************************************************-->
<!-- Copyright  2003 - 2010 by SAS Institute Inc., Cary, NC, USA.            -->
<!-- All Rights Reserved.                                                     -->
<!--**************************************************************************-->
<mon:html>
<head>
<meta http-equiv="Page-Enter"  content="BlendTrans(Duration=0)" />
<meta http-equiv="Page-Exit" content="BlendTrans(Duration=0)" />
   <c:set var="hasMenu" scope="request"><tiles:getAsString name="hasMenu"/></c:set>
   
   <%@ include file="/script/timeoutWarning.jsp" %>
   
   <sas:InitializeComponents/>
   <sas:StyleSheet styleNames="SAS Style,orm,orm_IE,custom,CPB,CPBDialog,CPBSpellChecker"/>

<%
   // If there's an exception, embed the stacktrace in the page.  Sometimes we display a 
   // "pretty" page to hide the exception, but developers still want to see the exception.
   String exceptionNames[] = new String[] {      
      "javax.servlet.error.exception",
      "saved.javax.servlet.error.exception",
      "javax.servlet.jsp.jspException"
      };
   Throwable exception = null;
   
   for (int i = 0; i < exceptionNames.length; i++) {
      exception = (Throwable)request.getAttribute(exceptionNames[i]);
      if (exception != null) {
         break;
      }
   }
   
   if (null != exception) {
      final StringWriter sw = new StringWriter();
      final PrintWriter pw = new PrintWriter(sw);
      exception.printStackTrace(pw);
      pw.close();
      out.println("<!--");
      out.println(sw);
      out.println("-->");
   }

	final ResourceBundle bundle = ApplicationProperties.getBundle(request.getLocale());
	String title = (String)pageContext.findAttribute("title");
	if (!Boolean.FALSE.equals(pageContext.findAttribute("titleIsKey"))) {
		try {
         if (title != null)
         {
            title = bundle.getString(title);
         }
		} catch (MissingResourceException mre) {
			title = "???" + title + "???";
		}
	}
   
   request.setAttribute("displayTitle", title);
%>
   <meta http-equiv="expires" content="0" />
   <meta http-equiv="Pragma" content="no-cache" />
   
   <title><%= StringUtil.escapeHTML(title, "&") %></title>
   
   <tiles:insert attribute="modalScriptIncludes" />
   <tiles:insert attribute="styleAndScriptIncludes" />
   
   <%-- Hooks for other head includes --%>
   <tiles:insert attribute="include-head" />
   <mon:include flush="true" />
</head>

<body onload="monitorInit()" onkeydown="doKeyFilter(event)">

<%-- div needed for overlib --%>
<div id="overDiv" style="position:absolute; visibility:hidden; z-index:1000;"></div>
<table cellpadding="0" cellspacing="0" style="width: 100%;">
<tr>
   <td><jsp:include page="bannerMenuBar.jsp" /></td>
</tr>
<tr>
   <td>
      <a name="mainContentArea"></a>
      <div id="content">
      
         <c:if test="${hasMenu}">
      		<h1><%= StringUtil.escapeHTML(title, "&") %></h1>
         </c:if>
      
         <tiles:insert attribute="contentActions" />
         <tiles:insert attribute="messages" />
         <tiles:insert attribute="content" />
      
         <div id="footer">
            <tiles:insert attribute="footer" />
         </div>
         
      </div> <!-- content -->
   </td>
</tr>
</table>

</body> 

</mon:html>
