<%@ page import="java.util.*" %>
<%@ page import="com.sas.oprisk.monitor.web.actions.*" %>
<%@ page import="com.sas.oprisk.monitor.web.utils.*" %>
<%@ page import="com.sas.framework.themes.client.Image" %>

<%@ page errorPage="pageError.jsp" %>

<%@ include file="/tiles/taglibs.jsp" %>
<mon:setBundle />
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<!--**************************************************************************-->
<!-- Copyright (c) 2008 by SAS Institute Inc., Cary, NC, USA.                 -->
<!-- All Rights Reserved.                                                     -->
<!--**************************************************************************-->
<!-- NAME:     Layout.jsp                                                     -->
<!-- VERSION:  4.1                                                            -->
<!-- DESCRIPTION: One of the tiles file that's used to layout all the jsp's   -->
<!--                                                                          -->
<!-- PRODUCT:  SAS(r) OpRisk Monitor                                          -->
<!-- USAGE:    to be used with all the jsp's to layout the content            -->
<!--**************************************************************************-->
<mon:html>
<head>
<%
   LayoutDirection layoutDirection = LayoutDirection.getLayoutDirection(request);
   String collapseButtonKey;
   
   if (layoutDirection.isLeftToRight())
   {
      collapseButtonKey = "application.collapseButton.image";
   }
   else
   {
      collapseButtonKey = "application.expandButton.image";
   }
   
   ResourceBundle bundle = ApplicationProperties.getBundle(request.getLocale());
   String collapseButtonImage = bundle.getString(collapseButtonKey);
%>
   <script type="text/javascript">
   </script>
   
   <sas:InitializeComponents/>
   <sas:StyleSheet styleNames="SAS Style,orm,orm_IE,custom,CPB,CPBDialog,CPBSpellChecker"/>

<%
   String title = (String)pageContext.findAttribute("title");
   if (!Boolean.FALSE.equals(pageContext.findAttribute("titleIsKey"))) {
      try {
         if (title != null)
         {
            title = bundle.getString(title);
         }
      } catch (MissingResourceException mre) {
         title = "???" + title + "???";
      }
   }
   
   request.setAttribute("displayTitle", title);
%>
   <meta http-equiv="expires" content="0" />
   <meta http-equiv="Pragma" content="no-cache" />
   
   <title><%= StringUtil.escapeHTML(title, "&") %></title>
   
   <tiles:insert attribute="modalScriptIncludes" />
   <tiles:insert attribute="styleAndScriptIncludes" />
   
   <%-- Hooks for other head includes --%>
   <tiles:insert attribute="include-head" />
   
   <mon:include js="/script/wizard.js" />
   <mon:include js="/script/scripts.jsp" />
   <mon:include flush="true" />

   <script type="text/javascript">
   function monitorInit() {
      initNSMenu();
      wizardInit();
   }
   function wizardInit() {
      if (isPageReadOnly()) {
         var form = document.forms[0];
         // disable all other form fields and buttons
         for (i = 0; i < form.elements.length; i++) {
           var objType = form.elements[i].type;
            if (objType != "hidden") {
               try {
                  var element = form.elements[i];
                  if (!element.getAttribute("actionbutton"))
                  {
                     if (disableWhenReadOnly(element)) {
                        element.disabled = true;
                     }
                  }
              } catch (e) {
                 // ignore...
              }
            }
         }   
      }
   }
   
   function isPageReadOnly() {
      <c:if test="${readOnly}" >
         return true;
      </c:if>
      return false;
   }
   
   function disableWhenReadOnly(element) {
      return true;
   }
   </script>
</head>

<body onload="monitorInit();" onkeydown="doKeyFilter(event)"
   dir='<%= layoutDirection %>'>

<table cellpadding="0" cellspacing="0" style="width: 100%;">
<tr>
   <td><jsp:include page="bannerMenuBar.jsp" /></td>
</tr>
<tr>
   <td>
      <div id="wizardContent">
         <div>
            
            <table width="100%" style="height:400px;border: 1 solid #D7BD8D;background-color: #f4f4f2;"
               cellpadding="0" cellspacing="0">
            
               <tr valign="top">
               
                  <mon:wizardNav/>
                  
                  <td id="navwdg"><a href="javascript:navtog()" title="<fmt:message key="application.hideNav.txt" />"><img src="<%=collapseButtonImage%>" name="navwdg" border="0" width="11" height="14" hspace="0" vspace="0" alt="<fmt:message key="application.hideNav.txt" />" /></a></td>
                  
                  <td width="100%" class='<tiles:getAsString name="contentStyle"/>'>
                  
                    <h1><%= StringUtil.escapeHTML(title, "&") %></h1>
                    <tiles:insert attribute="contentActions" />
                    
                    <div style="height:1em;"></div>
                    
                    <tiles:insert attribute="messages" />
      
                    <c:if test="${not empty instructions}">
                          <div class="instructions">
                             <fmt:message key="${instructions}" />
                          </div>
                          <p/>
                    </c:if>
      
                    <tiles:insert attribute="content" />
                     
                  </td>
               </tr>
            
            </table>
            
            <!-- Buttons -->
            <table width="100%" class="wizardButtonBar" cellpadding="0" cellspacing="0">
              <tr>
                 <td>
                   <mon:wizardButtonBar styleClass="button" />
                 </td>
              </tr>
            </table>
      
         </div>      
         
         <div id="footer">
            <tiles:insert attribute="footer" />
         </div>
         
      </div><!-- content -->
   </td>
</tr>
</table>

<%@ include file="/script/timeoutWarning.jsp" %>

</body> 

</mon:html>