<%@ include file="/tiles/taglibs.jsp" %>
<%@ include file="launchWRS.jsp" %>

<mon:setBundle />

<%@ page import="java.util.*" %>
<%@ page import="java.sql.Timestamp" %>
<%@ page import="com.ibm.icu.text.SimpleDateFormat" %>
<%@ page import="com.sas.oprisk.framework.server.util.DateTimeUtils" %>
<%@ page import="java.awt.Color" %>
<%@ page import="java.net.URLEncoder" %>
<%@ page import="com.sas.text.SASFormat" %>

<%@ page import="com.sas.oprisk.server.DimensionalPoint" %>
<%@ page import="com.sas.oprisk.monitor.web.csa.ReportViewerModel" %>
<%@ page import="com.sas.graphics.components.GraphConstants" %>

<script type="text/javascript"
   src="<%= request.getContextPath()+"/" %>script/reportDrillthrough.jsp"></script>

<%    
     Locale locale = request.getLocale();
     ResourceBundle bundle = ApplicationProperties.getBundle(locale);
     PersistenceSession psession = MonitorContext.getPersistenceSession(request);
     final String cursor = (String) request.getAttribute("cursor");
     final List results = (List) request.getAttribute("reportListResults");
     final SASFormat sasFormat = SASFormat.getInstance("NLDATMAP.");
     sasFormat.setLocale(Locale.getDefault());
     final User currentUser = (User) psession.getUser();
%>

<script type="text/javascript">

function setFocus() {
}

function exportReportToPDF() {
    var parms = "id=<%= cursor %>";
    parms += "&dimensionalPoint=" + document.forms[0].dimensionalPoint.value;
    window.location.href = 
       "<%= request.getContextPath() %>"
       + "/ReportPdfExport"
       + "?" + parms;
}

function dpRefresh(daHandle) {
   goWizard('<%= cursor %>&dpRefresh=true');
}

</script>

  <html:form action="/ReportViewer">
  
     <html:hidden property="storedProcessName" />
     <html:hidden property="view" />
  
     <mon:DimPointChooser 
		property="dimensionalPoint"
		selectMethod="dpRefresh"
		feature="CustomReporting"
		rootVisible="true"
		readOnly='false'/>
		   
   <p/>

<%
   try {
        
       final SimpleDateFormat dtFormat = 
          new SimpleDateFormat("ddMMMyy:HH:mm:ss", Locale.ENGLISH);
          
       String lastPageDim = "";

       if (results != null) {
	   for (final Iterator ri = results.iterator(); ri.hasNext(); ) {
	      final List ob = (List) ri.next();
	   
	      final String obs = (String) ob.get(0);
	      final Object ambiguousObsRk = (Object) ob.get(1);
	      final Double value = (Double) ob.get(2);
	      final Double floor = (Double) ob.get(3);
	      final Double ceil1 = (Double) ob.get(4);
	      final Double ceil2 = (Double) ob.get(5);
	      final Double ceil3 = (Double) ob.get(6);
	      final String period = (String) ob.get(7);
	      final String bigBadFlg = (String) ob.get(8);
	      final String currentPageDim = (String) ob.get(9);
	      
          if ((currentPageDim != null) && (!lastPageDim.equals(currentPageDim))) {
             if (!lastPageDim.equals("")) out.print("</div></div>");
             lastPageDim = currentPageDim;
             
%>	            <p/>
                <div class="section">
                 <div class="sectionheader">
                  <div class="sectionheadertext"><%= currentPageDim %></div>
                 </div>
                 <div class="sectionbody">
<%        }
	      
	      final Integer obsRk;
	      if (ambiguousObsRk instanceof Double) obsRk = new Integer(((Double)ambiguousObsRk).intValue());
	      else obsRk = (Integer)ambiguousObsRk;
	      
	      if ((obs != null) && (value != null)) {
	         
	         final Double[] valueList = new Double[] { 
	            floor, 
	            ceil1,
	            ceil2,
	            ceil3};
	         
	      	 final String name = obs.trim();
	         ReportViewerModel.createKPIInstance(
	            180,
	            ConfigDataProperties.getKPIChartWidth(),
	            obsRk,
	            name, 
	            valueList, 
	            value.doubleValue(), 
	            (bigBadFlg.equals("Y")),
                GraphConstants.SKIN_SATIN,
                period.trim(),
	            request.getSession(),
	            request);
             
%>           <a class="reportDrillThroughImg" href="javascript:goToKriObs(<%= obsRk %>);"
                ><img border="0" src="<%= request.getContextPath() %>/ReportImage?id=<%= obsRk %>" 
                  alt="<%=name%>" title="<%=name%>" /></a>
<%        }
       }
       }
       out.print("</div></div>");

    } catch (Exception e) {
       e.printStackTrace();
       //out.println(e.getMessage());
    }
%>

  </html:form>

<p/>

<p class="reportfootnote">
<fmt:message key="reports.timestamp.message.fmt.txt">
   <fmt:param value="<%= StringUtil.escapeHTML(currentUser.getFriendlyName(request.getLocale())) %>" />
   <fmt:param value="${completionTimestamp}" />
</fmt:message>
</p>

<style type="text/css">

a.reportDrillThroughImg {
   border: 1px solid #f4f4f2;
}

a.reportDrillThroughImg:hover {
   border: 1px solid blue; 
}

</style>
