<%@ include file="/tiles/taglibs.jsp" %>
<%@ page import="com.sas.oprisk.monitor.web.tasklist.*" %>
<%@ page import="com.sas.oprisk.monitor.web.utils.*" %>
<%@ page import="com.sas.oprisk.framework.server.util.ParsingUtils" %>
<%@ page import="com.sas.oprisk.server.license.ProductFeature" %>
<%@ page import="com.sas.oprisk.server.behavior.CentricityTypeCd" %>
<%@ page import="com.sas.oprisk.server.behavior.GlobalPermission" %>
<%@ page import="com.sas.oprisk.server.OpRiskEvent" %>
<%@ page import="com.sas.oprisk.server.ConfidentialFieldRegistry" %>
<%@ page import="com.sas.oprisk.server.ConfidentialObject" %>
<%@ page import="com.sas.solutions.cpb.web.tag.field.FieldRenderer" %>
<%@ page import="java.util.*" %>

<%
   MainActionModel model = MainActionModel.getFromRequest(request);
   PersistenceSession psession =
      MonitorContext.getPersistenceSession(request);
   User currentUser = (User) psession.getUser();
   
   Map confidentialObjectReferences =
      model.getConfidentialObjectReferences();

   Locale locale = request.getLocale();
   ResourceBundle bundle = ApplicationProperties.getBundle(locale);
   Iterator groupIter;
%>

<mon:Page template="default">
   <mon:Head>
      <script type="text/javascript">
      var activeRequest=false;
      
      function removeEntry(entryHandle, objType, objName) {
         if(activeRequest!=true){      
      
            var msg = unescape("<%=ParsingUtils.escape(bundle
                            .getString("taskList.removeEntry.confirm.msg.fmt.txt"))%>");
            msg = formatMessage(msg, unescape(objType), unescape(objName));
            if (confirm(msg)) {
               beginWait();
                         
                 IAPService.removeTaskListEntry(
                        entryHandle,
                        removeEntryRow
                     );
               
               activeRequest=true;
            }
          }else{
             beginWait();
          }
      }
      
      function removeEntryRow(entryId) {
         document.location = "<%=request.getContextPath()%>/RemoveFromTaskListMessage.do?handle=" 
              + entryId;
        activeRequest=false;
      }
      
      function performAction( actionName ) {
         document.location.href = "<%= request.getContextPath() %>/" + actionName;
      }
      
      var sections = new Array();
      function registerSection(sectionId) {
         sections[sections.length] = sectionId;
      }
      
      function expandCollapseAll(expand) {
         setVisible("collapseAll", expand);
         setVisible("expandAll", !expand);
         
         for(var i = 0; i < sections.length; i++) {
            setSectionExpanded(sections[i], expand);
         }
      }
      </script>
      <mon:include js="/dwr/interface/CommonService.js"/>
   </mon:Head>
   <mon:Body>      
         <mon:ToolBar/>
         <mon:Content>
            <h2>
            <fmt:message key='taskList.user.txt'/>
            <%= StringUtil.escapeHTML(currentUser.getFriendlyName(request.getLocale())) %>
         </h2>
         <%------------------------------%>
         <%--    Expand/Collapse All   --%>
         <%------------------------------%>
         <div id="expandAll" style="display: none;"><img
            border="0" id="allnodes_img"
            alt="<fmt:message key='application.expandAllSections.txt'/>"
            src="<%=request.getContextPath()%>/<fmt:message key='application.expandAllNodes.image'/>" />
         &nbsp;<a href="javascript:expandCollapseAll(true)"><fmt:message
            key='incident.investigate.expandAll.txt' /></a></div>
         <div id="collapseAll"><img border="0" id="allnodes_img"
            alt="<fmt:message key='application.collapseAllSections.txt'/>"
            src="<%=request.getContextPath()%>/<fmt:message key='application.collapseAllNodes.image'/>" />
         &nbsp;<a href="javascript:expandCollapseAll(false)"><fmt:message
            key='incident.investigate.collapseAll.txt' /></a></div>
                  
         <%-- SHORTCUTS { --%>
         <%
            groupIter = model.getMyTasksGroupList().iterator();
            while (groupIter.hasNext())
            {
               TaskListGroup group = (TaskListGroup)groupIter.next();
         %>
         <div style="padding: .5em 0 1em 0">
         <mon:section expanded="true" styleClassPrefix="tree">
            <mon:title>
               <%=bundle.getString(group.getDisplayNameKey())%>
            </mon:title>
            
            <table class="displayTable" cellspacing="0" border="0">
               <thead>
                  <tr>
                     <th><fmt:message key="taskListPrefs.columnHeading.taskName.txt" /></th>
                  </tr>
               </thead>
               <tbody>
         <%
               int i = 0;
               Iterator memberIter = group.getMembers().iterator();
               while(memberIter.hasNext())
               {
                  TaskListViewEntry member = (TaskListViewEntry)memberIter.next();
                  
                  Iterator itemDetailIter = member.getItemDetail().iterator();
                  while (itemDetailIter.hasNext())
                  {
                     TaskListDetailItem detailItem = (TaskListDetailItem)itemDetailIter.next();
                     
                     Iterator valueIter = detailItem.getColumnValues().iterator();
                     while(valueIter.hasNext())
                     {
                        Object value = valueIter.next();
                        String rowStyleClass = ((i % 2) == 0) ? "dataRow2_tableRow"
                                                              : "dataRow1_tableRow";
         %>
                        <tr class="<%=rowStyleClass%>">
                           <td>
                              <a href="<%=detailItem.getEditURL()%>">
                               <fmt:message><%= StringUtil.escapeHTML(value) %></fmt:message>
                              </a>
                           </td>
                        </tr>
         <%
                        i++;
                     }
                  }
               }
         %>
               </tbody>
            </table>
         </mon:section>
         </div>
         <%
            }
         %>
         <%-- SHORTCUTS } --%>
         
         <%-- STATIC-PRESENTATION TASKLIST { --%>
         <script type="text/javascript">
         function setExpandedState(key, expanded)
         {
            CommonService.setTasklistExpandedState(key, expanded, function() { });
         }
         </script>
         <%
            groupIter = model.getAlertsGroupList().iterator();
            while (groupIter.hasNext())
            {
               TaskListGroup group = (TaskListGroup)groupIter.next();
               String toggleCategoryMethod = group.getDisplayNameKey().replaceAll("\\.", "_");
               boolean isCategoryExpanded = TaskListViewEntry.getIsExpanded(toggleCategoryMethod, false, request);

         %>
         <%-- Each Category --%>
         <script type="text/javascript">
         function <%=toggleCategoryMethod%>(expanded) { setExpandedState("<%=toggleCategoryMethod%>", expanded); }
         </script>
         <div style="padding: .5em 0 1em 0">
         <mon:section expanded="<%=isCategoryExpanded%>" styleClassPrefix="tree" onToggleMethod="<%=toggleCategoryMethod%>">
            <mon:title>
               <%=bundle.getString(group.getDisplayNameKey())%>
               (<%=group.getDetailCount()%>)
            </mon:title>
         <%
               int i = 0;
               Iterator memberIter = group.getMembers().iterator();
               while(memberIter.hasNext())
               {
                  TaskListViewEntry member = (TaskListViewEntry)memberIter.next();
                  String toggleTasklistMethod = member.getTitleKey().replaceAll("\\.", "_");
                  boolean isTasklistExpanded = TaskListViewEntry.getIsExpanded(toggleTasklistMethod, member.getIsInitiallyExpanded(), request);
         
         %>
            <%-- Each Tasklist Table --%>
            <script type="text/javascript">
            function <%=toggleTasklistMethod%>(expanded) { setExpandedState("<%=toggleTasklistMethod%>", expanded); }
            </script>
            <div style="padding: .5em 0 1em 0">
            <mon:section expanded="<%=isTasklistExpanded%>" styleClassPrefix="tree" onToggleMethod="<%=toggleTasklistMethod%>">
               <mon:title>
                  <fmt:message><%=member.getTitleKey()%></fmt:message>
                  (<%=member.getItemDetailSize() %>)
               </mon:title>
               
               <table class="displayTable" style="width: 100%;" cellspacing="0" border="0">
                  <thead>
                     <tr>
         <%
         boolean hasNavigations = false;
         Iterator itemDetailIter = member.getItemDetail().iterator();
         if (itemDetailIter.hasNext())
         {
             do
             {
                 TaskListDetailItem detailItem = (TaskListDetailItem)itemDetailIter.next();
                 if (detailItem.getNavigations() != null)
                 {
                     hasNavigations = true;
                     break;
                 }
             } while (itemDetailIter.hasNext());
         }
         if (hasNavigations)
         {
             %>
             <th><fmt:message>displayTable.action.txt</fmt:message></th>
             <%
         }

                  int columnHeadingIndex = 0;
                  Iterator columnHeadingKeysIter = member.getColumnHeadingKeys().iterator();
                  while (columnHeadingKeysIter.hasNext())
                  {
                     Object columnHeadingKey = columnHeadingKeysIter.next();
                     if (columnHeadingIndex > 0)
                     {
         %>
                        <th><fmt:message><%=columnHeadingKey%></fmt:message></th>
         <%
                     }
                     columnHeadingIndex++;
                  }
         %>
                     </tr>
                  </thead>
                  <tbody>
         <%
                  itemDetailIter = member.getItemDetail().iterator();
                  if (itemDetailIter.hasNext())
                  {
                     do
                     {
                        TaskListDetailItem detailItem = (TaskListDetailItem)itemDetailIter.next();
                        
                        Set confidentialFieldsForThisRow =
                           ConfidentialFieldRegistry.getConfidentialFields(
                              detailItem, confidentialObjectReferences);
                        
                        List fieldRefs = member
                              .getConfidentialFieldReferences(confidentialFieldsForThisRow);
                        
                        detailItem.maskColumnValuesForConfidentiality(fieldRefs,
                           FieldRenderer.renderConfidentialField(locale));
                        
                        String rowStyleClass = ((i % 2) == 0) ? "dataRow2_tableRow"
                                                              : "dataRow1_tableRow";
         %>
                     <tr class="<%=rowStyleClass%>">
         <%
                        if (detailItem.getNavigations() != null)
                        {
                            %><td align=center><%
                           out.print(NavigationRenderer.writeNavigations(detailItem.getNavigations()));
                            %></td><%
                        }
                        int col = 0;
                        String style = "";
                        
                        Iterator valueIter = detailItem.getColumnValues().iterator();
                        while((col < columnHeadingIndex) && valueIter.hasNext())
                        {
                           Object value = valueIter.next();
                           if (col > 0)
                           {
         %>
                        <td>
                           <a <%=style%>href="<%=detailItem.getEditURL()%>">
                              <%= (value == null) ? "" : StringUtil.escapeHTML(value) %>
                           </a>
                        </td>
         <%
                           }
                           else
                           {
                              if ((value != null) && (((String)value).length() > 0))
                              {
                              	style = "style=\"color:" + (String)value + "\" ";
                              }
                           }
                           
                           col++;
                        }
                        
                        i++;
         %>
                  </tr>
         <%
                     }
                     while (itemDetailIter.hasNext());
                  
                  }
                  else
                  {
         %>
                  <tr>
                     <td colspan="<%=columnHeadingIndex%>">
                        <fmt:message key="TC.tableComponent.noRecords.txt" />
                     </td>
                  </tr>
         <%
                  }
         %>
                  </tbody>
               </table>
            </mon:section>
            </div>
         <%
               }
         %>
         </mon:section>
         </div>
         <%
            }
         %>
         <%-- STATIC-PRESENTATION TASKLIST } --%>
         
         <%-- CONFIGURE MY TASK LIST BUTTON { --%>
         <%
         if (ConfigDataProperties.getTasklistIsUserConfigurable().booleanValue())
         {
         %>
         <form name="dummyForm" method="post">
            <input type="button" class="button"
               onmouseover="this.className='button buttonRollover'"
               onmouseout="this.className='button'"
               value="<fmt:message key='taskList.label.prefs.txt' />"
               onclick="performAction('TaskListPrefs.do')" />
         </form>
         <%
         }
         %>
         <%-- CONFIGURE MY TASK LIST BUTTON } --%>
         </mon:Content>        
   </mon:Body>
</mon:Page>
