<%@ page import="com.sas.solutions.cpb.util.StringUtil"%>
<%@ page import="java.util.*" %>
<%@ page import="com.sas.workflow.engine.client.WorkflowEngineServiceInterface" %>
<%@ page import="com.sas.workflow.engine.mediation.Operand" %>
<%@ page import="com.sas.workflow.engine.mediation.Status" %>
<%@ page import="com.sas.workflow.engine.mediation.Process" %>
<%@ page import="com.sas.workflow.engine.mediation.Policy" %>

<%@ page import="com.sas.workflow.engine.WorkflowObjectId" %>


<%@ page import="com.sas.oprisk.framework.server.objects.TaggedPointerHandle" %>
<%@ page import="com.sas.oprisk.server.services.ServiceLocator" %>
<%@ page import="com.sas.oprisk.server.*" %>
<%@ page import="com.sas.oprisk.server.workflow.WorkflowUtil" %>
<%@ page import="com.sas.oprisk.server.workflow.WorkflowUIComponentUtil" %>
<%@ page import="com.sas.oprisk.monitor.web.cpb.util.UIContextUtil" %>
<%@ page import="com.sas.solutions.cpb.runtime.*" %>

<%
   WorkflowEngineServiceInterface engine = ServiceLocator.getWorkflowService();
   Process process = (Process)engine.get(new WorkflowObjectId(request.getParameter("id")));
   Set statusIds = process.getStatuses();
   Set policyIds = process.getPolicies();
   Set operands = process.getOperands();
   pageContext.setAttribute("statusIds", statusIds);
   pageContext.setAttribute("policyIds", policyIds);
%>
<html>
<head>
<title>Details for <%= StringUtil.escapeHTML(process.getLabel()) %></title>
</head>
<body>
<pre>
Label: <%= StringUtil.escapeHTML(process.getLabel()) %>
State: <%
int pState = process.getState();
String state = "";

switch(pState){
   case(Process.STATE_UNSTARTED) : state = "Unstarted"; break;
   case(Process.STATE_STARTED) : state = "Started"; break;
   case(Process.STATE_FINISHED) : state = "Finished"; break;
   case(Process.STATE_ABORTED) : state = "Aborted"; break;
   default : state = Integer.valueOf(pState).toString(); break;
}
%><%= StringUtil.escapeHTML(state) %>

ACL:
<%= StringUtil.escapeHTML(process.getACL()) %>

Current Status:
<table border=1>
<tr><th>Label</th><th>Description</th></tr>
<%
Set currentStatusIds = process.getCurrentStatuses();
for (Iterator s = currentStatusIds.iterator(); s.hasNext();)
{
   Status status = (Status)engine.get((WorkflowObjectId)s.next());
   %>
     <tr>
       <td><%= StringUtil.escapeHTML(status.getLabel()) %></td>
       <td><%= StringUtil.escapeHTML(status.getDescription()) %></td>
     </tr>
   <%
}
%>
</table>
Available Status:
<table border=1>
<tr><th>Label</th><th>Description</th></tr>
<%
  if (statusIds != null && !statusIds.isEmpty()){
     for (Iterator s = statusIds.iterator(); s.hasNext();){
       WorkflowObjectId objId = (WorkflowObjectId)s.next();
       Status status = (Status)engine.get(objId);
%>
  <tr>
    <td><%= StringUtil.escapeHTML(status.getLabel()) %></td>
    <td><%= StringUtil.escapeHTML(status.getDescription()) %></td>
  </tr>
<%
     }
  }
%>
</table>
Policies:
<%
  if (policyIds != null && !policyIds.isEmpty()){
     for (Iterator p = policyIds.iterator(); p.hasNext();){
       WorkflowObjectId objId = (WorkflowObjectId)p.next();
       Policy policy = (Policy)engine.get(objId);
%><%= StringUtil.escapeHTML(policy.getLabel()) %>
<%
     }
  }
%>

Local Operands:
<%
  if (operands != null && !operands.isEmpty()){
    for (Iterator op = operands.iterator(); op.hasNext();){
      WorkflowObjectId objId = (WorkflowObjectId)op.next();
      Operand opObj = (Operand)engine.get(objId);
%><%= StringUtil.escapeHTML(opObj.getLabel()) %>   <%= StringUtil.escapeHTML(opObj.getText()) %>
<%
    }
  }
%>

Attributes:
<%
   Set attrKeys = process.getAttributeKeys();
   for (Iterator it = attrKeys.iterator(); it.hasNext();){
      String key = (String)it.next();
%><%= StringUtil.escapeHTML(key) %> :  <%= StringUtil.escapeHTML(process.getAttribute(key)) %>
<%
   }
%>

Timers:
<%= StringUtil.escapeHTML(process.getTimers()) %>

</pre>
</body>
</html>
